	.INCLUDE	"interp6502.s"
;    1: ;=============================================================================
;    2: ;Smartport Virtual Hard Drive Manager, version 1.0.0
;    3: ;
;    4: ;Copyright 2012 Cédric PELTIER, pcedric@hotmail.com
;    5: ;
;    6: ;This file is part of the SmartportVHD project
;    7: ;
;    8: ;SmartportVHD Manager is free software: you can redistribute it and/or modify
;    9: ;it under the terms of the GNU General Public License as published by
;   10: ;the Free Software Foundation version 3
;   11: ;
;   12: ;SmartportVHD Manager is distributed in the hope that it will be useful,
;   13: ;but WITHOUT ANY WARRANTY; without even the implied warranty of
;   14: ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   15: ;GNU General Public License for more details.
;   16: ;
;   17: ;You should have received a copy of the GNU General Public License
;   18: ;along with Smartport VHD. If not, see <http://www.gnu.org/licenses/>.
;   19: ;=============================================================================
;   20: 
;   21: ;
;   22: ; Hardware constants
;   23: ;
;   24: const ttop			  = $0022
					; ttop = 34
;   25: const htab			  = $0024
					; htab = 36
;   26: const vtab			  = $0025
					; vtab = 37
;   27: const outmode		  = $0032
					; outmode = 50
;   28: const csw           = $0036
					; csw = 54
;   29: const speaker       = $C030
					; speaker = 49200
;   30: const showgraphics  = $C050
					; showgraphics = 49232
;   31: const showtext      = $C051
					; showtext = 49233
;   32: const showfull      = $C052
					; showfull = 49234
;   33: const showmix       = $C053
					; showmix = 49235
;   34: const showpage1     = $C054
					; showpage1 = 49236
;   35: const showpage2     = $C055
					; showpage2 = 49237
;   36: const showlores     = $C056
					; showlores = 49238
;   37: const showhires     = $C057
					; showhires = 49239
;   38: const pushbttn1     = $C061
					; pushbttn1 = 49249
;   39: const pushbttn2     = $C062
					; pushbttn2 = 49250
;   40: const pushbttn3     = $C063
					; pushbttn3 = 49251
;   41: const keyboard      = $C000
					; keyboard = 49152
;   42: const keystrobe     = $C010
					; keystrobe = 49168
;   43: const keyenter      = $8D
					; keyenter = 141
;   44: const keyspace      = $A0
					; keyspace = 160
;   45: const keyarrowup    = $8B
					; keyarrowup = 139
;   46: const keyarrowdown  = $8A
					; keyarrowdown = 138
;   47: const keyarrowleft  = $88
					; keyarrowleft = 136
;   48: const keyarrowright = $95
					; keyarrowright = 149
;   49: const keyescape     = $9B
					; keyescape = 155
;   50: const keyctrla      = $81
					; keyctrla = 129
;   51: const keyctrlb      = $82
					; keyctrlb = 130
;   52: const keyctrlc      = $83
					; keyctrlc = 131
;   53: const keyctrld      = $84
					; keyctrld = 132
;   54: const keyctrle      = $85
					; keyctrle = 133
;   55: const keyctrli      = $89
					; keyctrli = 137
;   56: const keyctrlk      = $8B
					; keyctrlk = 139
;   57: const keyctrll      = $8C
					; keyctrll = 140
;   58: const keyctrln      = $8E
					; keyctrln = 142
;   59: const keyctrlo      = $8F
					; keyctrlo = 143
;   60: const keyctrlp      = $90
					; keyctrlp = 144
;   61: const keyctrlq      = $91
					; keyctrlq = 145
;   62: const keyctrlr      = $92
					; keyctrlr = 146
;   63: const keyctrls      = $93
					; keyctrls = 147
;   64: const keyctrlt      = $94
					; keyctrlt = 148
;   65: const keyctrlu      = $95
					; keyctrlu = 149
;   66: const keyctrlv      = $96
					; keyctrlv = 150
;   67: const keyctrlw      = $97
					; keyctrlw = 151
;   68: const keyctrlx      = $98
					; keyctrlx = 152
;   69: const keyctrlz      = $9A
					; keyctrlz = 154
;   70: const keyslash		  = $AF
					; keyslash = 175
;   71: const keydelete     = $FF
					; keydelete = 255
;   72: const getbuff       = $01FF
					; getbuff = 511
;   73: word txtscrn[]      = [$0400,$0480,$0500,$0580,$0600,$0680,$0700,$0780]
D0000:					; txtscrn
	DW	$0400
	DW	$0480
	DW	$0500
	DW	$0580
	DW	$0600
	DW	$0680
	DW	$0700
	DW	$0780
;   74: word                = [$0428,$04A8,$0528,$05A8,$0628,$06A8,$0728,$07A8]
	DW	$0428
	DW	$04A8
	DW	$0528
	DW	$05A8
	DW	$0628
	DW	$06A8
	DW	$0728
	DW	$07A8
;   75: word                = [$0450,$04D0,$0550,$05D0,$0650,$06D0,$0750,$07D0]
	DW	$0450
	DW	$04D0
	DW	$0550
	DW	$05D0
	DW	$0650
	DW	$06D0
	DW	$0750
	DW	$07D0
;   76: 
;   77: ; 000-063 maj invert
;   78: ; 064-127 maj flash
;   79: ; 128-191 maj normal
;   80: ; 224-255 min normal
;   81: 
;   82: ;
;   83: ; Data and text buffer constants
;   84: ;
;   85: const machid     = $BF98
					; machid = 49048
;   86: const vector_clk = $BF06
					; vector_clk = 48902
;   87: 
;   88: ;
;   89: ; Plasma register structure access
;   90: ;
;   91: const areg = 0
					; areg = 0
;   92: const xreg = 1
					; xreg = 1
;   93: const yreg = 2
					; yreg = 2
;   94: const preg = 3
					; preg = 3
;   95: 
;   96: ;
;   97: ; Smartport Constants for commands
;   98: ;
;   99: const c_sp_cmd_status = $00
					; c_sp_cmd_status = 0
;  100: const c_sp_cmdex_status = $40
					; c_sp_cmdex_status = 64
;  101: const c_sp_cmd_readblk = $01
					; c_sp_cmd_readblk = 1
;  102: const c_sp_cmdex_readblk = $41
					; c_sp_cmdex_readblk = 65
;  103: const c_sp_cmd_writeblk = $02
					; c_sp_cmd_writeblk = 2
;  104: const c_sp_cmdex_wrtieblk = $42
					; c_sp_cmdex_wrtieblk = 66
;  105: const c_sp_cmd_format = $03
					; c_sp_cmd_format = 3
;  106: const c_sp_cmdex_format = $43
					; c_sp_cmdex_format = 67
;  107: const c_sp_cmd_control = $04
					; c_sp_cmd_control = 4
;  108: const c_sp_cmdex_control = $44
					; c_sp_cmdex_control = 68
;  109: const c_sp_cmd_init = $05
					; c_sp_cmd_init = 5
;  110: const c_sp_cmdex_init = $45
					; c_sp_cmdex_init = 69
;  111: const c_sp_cmd_open = $06
					; c_sp_cmd_open = 6
;  112: const c_sp_cmdex_open = $46
					; c_sp_cmdex_open = 70
;  113: const c_sp_cmd_close = $07
					; c_sp_cmd_close = 7
;  114: const c_sp_cmdex_close = $47
					; c_sp_cmdex_close = 71
;  115: const c_sp_cmd_read = $08
					; c_sp_cmd_read = 8
;  116: const c_sp_cmdex_read = $48
					; c_sp_cmdex_read = 72
;  117: const c_sp_cmd_write = $09
					; c_sp_cmd_write = 9
;  118: const c_sp_cmdex_write = $49
					; c_sp_cmdex_write = 73
;  119: 
;  120: ;
;  121: ; Smartport Manager constants
;  122: ;
;  123: const c_spt_buf = $1F80
					; c_spt_buf = 8064
;  124: 
;  125: ;
;  126: ; Smartport Constants for structures access
;  127: ;
;  128: const c_sp_prmcnt = 0
					; c_sp_prmcnt = 0
;  129: const c_sp_id = 1
					; c_sp_id = 1
;  130: const c_sp_buffer = 2
					; c_sp_buffer = 2
;  131: const c_sp_code = 4
					; c_sp_code = 4
;  132: const c_sp_blknum_low = 4
					; c_sp_blknum_low = 4
;  133: const c_sp_blknum_med = 5
					; c_sp_blknum_med = 5
;  134: const c_sp_blknum_hig = 6
					; c_sp_blknum_hig = 6
;  135: const c_sp_bytcnt_low = 4
					; c_sp_bytcnt_low = 4
;  136: const c_sp_bytcnt_hig = 5
					; c_sp_bytcnt_hig = 5
;  137: const c_sp_dib_dsb = 0
					; c_sp_dib_dsb = 0
;  138: const c_sp_dib_size = 1
					; c_sp_dib_size = 1
;  139: const c_sp_dib_string = 4
					; c_sp_dib_string = 4
;  140: const c_sp_dib_type = 20
					; c_sp_dib_type = 20
;  141: const c_sp_dib_subtype = 21
					; c_sp_dib_subtype = 21
;  142: const c_sp_dib_version = 22
					; c_sp_dib_version = 22
;  143: ; following constant are spvhd specifics
;  144: const c_spvhd_major = 0
					; c_spvhd_major = 0
;  145: const c_spvhd_minor = 1
					; c_spvhd_minor = 1
;  146: const c_spvhd_revision = 2
					; c_spvhd_revision = 2
;  147: const c_spvhd_id = 3
					; c_spvhd_id = 3
;  148: const c_spvhd_devcount = 4
					; c_spvhd_devcount = 4
;  149: const c_spvhd_signaturesize = 5
					; c_spvhd_signaturesize = 5
;  150: const c_spvhd_signature = 6
					; c_spvhd_signature = 6
;  151: const c_spvhd_datelow = 0
					; c_spvhd_datelow = 0
;  152: const c_spvhd_datehigh = 1
					; c_spvhd_datehigh = 1
;  153: const c_spvhd_minutes = 2
					; c_spvhd_minutes = 2
;  154: const c_spvhd_hours = 3
					; c_spvhd_hours = 3
;  155: const c_spvhd_param = 0
					; c_spvhd_param = 0
;  156: const c_spvhd_path = 1
					; c_spvhd_path = 1
;  157: 
;  158: ;
;  159: ; Smartport Constants for code field in status command and control command
;  160: ;
;  161: const c_sp_sta_sta = 0
					; c_sp_sta_sta = 0
;  162: const c_sp_sta_dcb = 1
					; c_sp_sta_dcb = 1
;  163: const c_sp_sta_dib = 3
					; c_sp_sta_dib = 3
;  164: ; the following codes are specifics to the smartporvhd
;  165: ; to be used with status and control smartport commands
;  166: const c_spvhd_date = 10
					; c_spvhd_date = 10
;  167: const c_spvhd_explore = 11
					; c_spvhd_explore = 11
;  168: const c_spvhd_nextfile = 12
					; c_spvhd_nextfile = 12
;  169: const c_spvhd_parmsel = 13
					; c_spvhd_parmsel = 13
;  170: const c_spvhd_parmboot = 14
					; c_spvhd_parmboot = 14
;  171: const c_spvhd_parmtemp = 15
					; c_spvhd_parmtemp = 15
;  172: 
;  173: ;
;  174: ; Global variables
;  175: ;
;  176: byte g_perr
D0048:	DS	1			; g_perr
;  177: byte g_key
D0049:	DS	1			; g_key
;  178: 
;  179: word g_spep		;smartport entry point
D0050:	DS	2			; g_spep
;  180: byte g_spvhdid	;spvhd smartport id
D0052:	DS	1			; g_spvhdid
;  181: word g_spsize  ;size of transfered data after smartport calls
D0053:	DS	2			; g_spsize
;  182: byte g_sperr   ;last error code
D0055:	DS	1			; g_sperr
;  183: byte g_dev_selected ;selected device
D0056:	DS	1			; g_dev_selected
;  184: byte g_spvhd_signature[] = "SPVHD"
D0057:					; g_spvhd_signature
	DB	$05
	DB	$53,$50,$56,$48,$44
;  185: 
;  186: byte msg_rc[] = "RC="
D0063:					; msg_rc
	DB	$03
	DB	$52,$43,$3D
;  187: byte msg_sperr[] = "ERROR "
D0067:					; msg_sperr
	DB	$06
	DB	$45,$52,$52,$4F,$52,$20
;  188: byte msg_installed[] = "SmartportRTC driver loaded"
D0074:					; msg_installed
	DB	$1A
	DB	$53,$6D,$61,$72,$74,$70,$6F,$72
	DB	$74,$52,$54,$43,$20,$64,$72,$69
	DB	$76,$65,$72,$20,$6C,$6F,$61,$64
	DB	$65,$64
;  189: ;
;  190: ; Fields labels
;  191: ;
;  192: 
;  193: byte label_null[] = ""
D0101:					; label_null
	DB	$00
;  194: byte label_date[] = "-- --- ---- --:--"
D0102:					; label_date
	DB	$11
	DB	$2D,$2D,$20,$2D,$2D,$2D,$20,$2D
	DB	$2D,$2D,$2D,$20,$2D,$2D,$3A,$2D
	DB	$2D
;  195: 
;  196: ;
;  197: ; Lookup table to display month
;  198: ;
;  199: 
;  200: word months[] = "JANFEBMARAPRMAYJUNJULAOUSEPOCTNOVDEC"
D0120:					; months
	DB	$24
	DB	$4A,$41,$4E,$46,$45,$42,$4D,$41
	DB	$52,$41,$50,$52,$4D,$41,$59,$4A
	DB	$55,$4E,$4A,$55,$4C,$41,$4F,$55
	DB	$53,$45,$50,$4F,$43,$54,$4E,$4F
	DB	$56,$44,$45,$43
;  201: 
;  202: ;
;  203: ; Global buffers 
;  204: ;
;  205: 
;  206: ;buffer to work on the pathname used by the disk image selector
;  207: byte g_hour
D0157:	DS	1			; g_hour
;  208: byte g_minute
D0158:	DS	1			; g_minute
;  209: byte g_day
D0159:	DS	1			; g_day
;  210: byte g_month
D0160:	DS	1			; g_month
;  211: word g_year
D0161:	DS	2			; g_year
;  212: 
;  213: ;
;  214: ; Helpers
;  215: ;
;  216: ;def getkey()
;  217: ;    return (romcall(0, 0, 0, 0, $FD0C)).1
;  218: ;end
;  219: ;def bell()
;  220: ;    romcall(0, 0, 0, 0, $FBDD)
;  221: ;end
;  222: def home()
C0008:					; home()
;  223:     romcall(0, 0, 0, 0, $FC58)
	JSR	INTERP
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$58,$FC		; CW	64600
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  224: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  225: def gotoxy(x, y)
C0010:					; gotoxy()
					; x = 2
					; y = 4
;  226: 	^($24) = x
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$2A,$24			; CB	36
	DB	$66,$02			; LLW	2
	DB	$70			; SB
;  227: 	romcall(y, 0, 0, 0, $FB5B)
	DB	$66,$04			; LLW	4
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$5B,$FB		; CW	64347
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  228: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  229: def crout()
C0012:					; crout()
;  230: 	cout($8D)
	JSR	INTERP
	DB	$2A,$8D			; CB	141
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  231: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  232: def prbyte(h)
C0014:					; prbyte()
					; h = 2
;  233: 	cout('$')
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$2A,$24			; CB	36
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  234: 	romcall(h, 0, 0, 0, $FDDA)
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$DA,$FD		; CW	64986
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  235: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  236: def prword(h)
C0016:					; prword()
					; h = 2
;  237: 	cout('$')
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$2A,$24			; CB	36
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  238: 	romcall(h >> 8, h, 0, 0, $F941)
	DB	$66,$02			; LLW	2
	DB	$2A,$08			; CB	8
	DB	$1C			; SHR
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$41,$F9		; CW	63809
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  239: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  240: def printeger(i)
C0018:					; printeger()
					; i = 2
;  241: 	byte numstr[7]
					; numstr = 4
;  242: 	byte place, sign
					; place = 11
					; sign = 12
;  243: 
;  244: 	place = 6
	JSR	INTERP
	DB	$58,$0D,$01		; ENTER	13,1
	DB	$2A,$06			; CB	6
	DB	$74,$0B			; SLB	11
;  245: 	if i < 0
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$46			; ISLT
	DB	$4C,<C0020,>C0020	; BRFLS	C0020
;  246: 		sign = 1
	DB	$2A,$01			; CB	1
	DB	$74,$0C			; SLB	12
;  247: 		i		 = -i
	DB	$66,$02			; LLW	2
	DB	$10			; NEG
	DB	$76,$02			; SLW	2
;  248: 	else
	DB	$50,<C0021,>C0021	; JUMP	C0021
C0020:
;  249: 		sign = 0
	DB	$00			; ZERO
	DB	$74,$0C			; SLB	12
;  250: 	fin
C0021:
;  251: 	while i >= 10
C0022:
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$48			; ISGE
	DB	$4C,<C0023,>C0023	; BRFLS	C0023
;  252: 		numstr[place] = i % 10 + '0'
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$0A			; MOD
	DB	$2A,$30			; CB	48
	DB	$02			; ADD
	DB	$70			; SB
;  253: 		i							= i / 10
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$08			; DIV
	DB	$76,$02			; SLW	2
;  254: 		place					= place - 1
	DB	$64,$0B			; LLB	11
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$0B			; SLB	11
;  255: 	loop
	DB	$50,<C0022,>C0022	; JUMP	C0022
C0023:
;  256: 	numstr[place] = i + '0'
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$66,$02			; LLW	2
	DB	$2A,$30			; CB	48
	DB	$02			; ADD
	DB	$70			; SB
;  257: 	place					= place - 1
	DB	$64,$0B			; LLB	11
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$0B			; SLB	11
;  258: 	if sign
	DB	$64,$0C			; LLB	12
	DB	$4C,<C0024,>C0024	; BRFLS	C0024
;  259: 		numstr[place] = '-'
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$2A,$2D			; CB	45
	DB	$70			; SB
;  260: 		place					= place - 1
	DB	$64,$0B			; LLB	11
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$0B			; SLB	11
;  261: 	fin
C0024:
C0025:
;  262: 	numstr[place] = 6 - place
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$2A,$06			; CB	6
	DB	$64,$0B			; LLB	11
	DB	$04			; SUB
	DB	$70			; SB
;  263: 	prstr(@numstr[place])
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  264: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  265: 
;  266: ; =====================================
;  267: ; Memory management routines
;  268: ;
;  269: 
;  270: ; Compare two memory block
;  271: ; return 0 if the content match
;  272: deft memcmp(lp_src1, lp_src2, l_len)
C0026:					; memcmp()
					; lp_src1 = 2
					; lp_src2 = 4
					; l_len = 6
;  273: 	byte i
					; i = 8
;  274: 	i = 0
	LDA	#9
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDA	#$00
	TAY
	JSR	_PUSHYA
	LDY	#$08
	JSR	_SLB
;  275: 	while i < l_len
C0028:
	LDY	#$08
	JSR	_LLB
	LDY	#$06
	JSR	_LLW
	JSR	ISLT
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0029
:
;  276: 		if ^(lp_src1+i) <> ^(lp_src2+i)
	LDY	#$02
	JSR	_LLW
	LDY	#$08
	JSR	_LLB
	JSR	ADD
	JSR	LB
	LDY	#$04
	JSR	_LLW
	LDY	#$08
	JSR	_LLB
	JSR	ADD
	JSR	LB
	JSR	ISNE
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0030
:
;  277: 			return 1
	LDA	#$01
	LDY	#$00
	JSR	_PUSHYA
	JMP	_LEAVE
;  278: 		fin
C0030:
C0031:
;  279: 		i = i + 1
	LDY	#$08
	JSR	_LLB
	LDA	#$01
	LDY	#$00
	JSR	_PUSHYA
	JSR	ADD
	LDY	#$08
	JSR	_SLB
;  280: 	loop
	JMP	C0028
C0029:
;  281: 	return 0
	LDA	#$00
	TAY
	JSR	_PUSHYA
	JMP	_LEAVE
;  282: end
;  283: 
;  284: ; =====================================
;  285: ; ProDOS routines
;  286: 
;  287: ;def prodos_online(unit,buf)
;  288: ;    byte params[4]
;  289: ;
;  290: ;    params.0  = 2
;  291: ;    params.1  = unit
;  292: ;    params:2  = buf
;  293: ;    g_perr      = syscall($C5, @params)
;  294: ;    return g_perr
;  295: ;end
;  296: ;def prodos_getpfx(path)
;  297: ;    byte params[3]
;  298: 
;  299: ;    ^path    = 0
;  300: ;    params.0 = 1
;  301: ;    params:1 = path
;  302: ;    g_perr     = syscall($C7, @params)
;  303: ;    return path
;  304: ;end
;  305: ;def prodos_setpfx(path)
;  306: ;    byte params[3]
;  307: 
;  308: ;    params.0 = 1
;  309: ;    params:1 = path
;  310: ;    g_perr     = syscall($C6, @params)
;  311: ;    return path
;  312: ;end
;  313: ;def prodos_open(path, buff)
;  314: ;    byte params[6]
;  315: 
;  316: ;    params.0 = 3
;  317: ;    params:1 = path
;  318: ;    params:3 = buff
;  319: ;    g_perr     = syscall($C8, @params)
;  320: ;    return params.5
;  321: ;end
;  322: ;def prodos_close(refnum)
;  323: ;    byte params[2]
;  324: 
;  325: ;    params.0 = 1
;  326: ;    params.1 = refnum
;  327: ;    g_perr     = syscall($CC, @params)
;  328: ;    return g_perr
;  329: ;end
;  330: ;def prodos_read(refnum, buff, len)
;  331: ;    byte params[8]
;  332: 
;  333: ;    params.0 = 4
;  334: ;    params.1 = refnum
;  335: ;    params:2 = buff
;  336: ;    params:4 = len
;  337: ;    params:6 = 0
;  338: ;    g_perr     = syscall($CA, @params)
;  339: ;    return params:6
;  340: ;end
;  341: ;def prodos_write(refnum, buff, len)
;  342: ;    byte params[8]
;  343: 
;  344: ;    params.0 = 4
;  345: ;    params.1 = refnum
;  346: ;    params:2 = buff
;  347: ;    params:4 = len
;  348: ;    params:6 = 0
;  349: ;    g_perr     = syscall($CB, @params)
;  350: ;    return params:6
;  351: ;end
;  352: ;def prodos_create(path, access, type, aux)
;  353: ;    byte params[12]
;  354: 
;  355: ;    params.0  = 7
;  356: ;    params:1  = path
;  357: ;    params.3  = access
;  358: ;    params.4  = type
;  359: ;    params:5  = aux
;  360: ;    params.7  = $1
;  361: ;    params:8  = 0
;  362: ;    params:10 = 0
;  363: ;    g_perr      = syscall($C0, @params)
;  364: ;    return g_perr
;  365: ;end
;  366: ;def prodos_destroy(path)
;  367: ;    byte params[12]
;  368: 
;  369: ;    params.0 = 1
;  370: ;    params:1 = path
;  371: ;    g_perr     = syscall($C1, @params)
;  372: ;    return g_perr
;  373: ;end
;  374: ;def prodos_newline(refnum, emask, nlchar)
;  375: ;    byte params[4]
;  376: 
;  377: ;    params.0 = 3
;  378: ;    params.1 = refnum
;  379: ;    params.2 = emask
;  380: ;    params.3 = nlchar
;  381: ;    g_perr     = syscall($C9, @params)
;  382: ;    return g_perr
;  383: ;end
;  384: 
;  385: ; =====================================
;  386: ; Keyboard routines
;  387: 
;  388: def getkey()
C0032:					; getkey()
;  389:     repeat
	JSR	INTERP
C0035:
;  390:     until ^keyboard >= 128
	DB	$2C,$00,$C0		; CW	49152
	DB	$60			; LB
	DB	$2A,$80			; CB	128
	DB	$48			; ISGE
	DB	$4C,<C0035,>C0035	; BRFLS	C0035
C0034:
;  391:     return ^keystrobe
	DB	$2C,$10,$C0		; CW	49168
	DB	$60			; LB
	DB	$5C			; RET
;  392: end
;  393: 
;  394: ; =====================================
;  395: ; data routines
;  396: 
;  397: ; -------------------------------------
;  398: ; Translate a binary byte to decimal ascii
;  399: deft dat_bin2dec(l_src,lp_dst)
C0036:					; dat_bin2dec()
					; l_src = 2
					; lp_dst = 4
;  400: 	byte i
					; i = 6
;  401: 	i = l_src / 10
	LDA	#7
	STA	FRMSZ
	LDA	#2
	STA	NPARMS
	JSR	_ENTER
	LDY	#$02
	JSR	_LLW
	LDA	#$0A
	LDY	#$00
	JSR	_PUSHYA
	JSR	DIV
	LDY	#$06
	JSR	_SLB
;  402: 	if i < 10
	LDY	#$06
	JSR	_LLB
	LDA	#$0A
	LDY	#$00
	JSR	_PUSHYA
	JSR	ISLT
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0038
:
;  403: 		^lp_dst = '0' + i
	LDY	#$04
	JSR	_LLW
	LDA	#$30
	LDY	#$00
	JSR	_PUSHYA
	LDY	#$06
	JSR	_LLB
	JSR	ADD
	JSR	SB
;  404: 	else
	JMP	C0039
C0038:
;  405: 		^lp_dst = '?'
	LDY	#$04
	JSR	_LLW
	LDA	#$3F
	LDY	#$00
	JSR	_PUSHYA
	JSR	SB
;  406: 	fin
C0039:
;  407: 	i = l_src - i * 10
	LDY	#$02
	JSR	_LLW
	LDY	#$06
	JSR	_LLB
	LDA	#$0A
	LDY	#$00
	JSR	_PUSHYA
	JSR	MUL
	JSR	SUB
	LDY	#$06
	JSR	_SLB
;  408: 	(lp_dst).1 = '0' + i
	LDY	#$04
	JSR	_LLW
	LDA	#$01
	LDY	#$00
	JSR	_PUSHYA
	JSR	ADD
	LDA	#$30
	LDY	#$00
	JSR	_PUSHYA
	LDY	#$06
	JSR	_LLB
	JSR	ADD
	JSR	SB
;  409: end
	LDA	#$00
	TAY
	JSR	_PUSHYA
	JMP	_LEAVE
;  410: 
;  411: ; -------------------------------------
;  412: ; Update global date and time from a prodos date
;  413: def dat_date_unpack(lp_date)
C0040:					; dat_date_unpack()
					; lp_date = 2
;  414: 	g_hour = (lp_date).3
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$60			; LB
	DB	$78,<D0157,>D0157	; SAB	D0157
;  415: 	g_minute = (lp_date).2
	DB	$66,$02			; LLW	2
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$60			; LB
	DB	$78,<D0158,>D0158	; SAB	D0158
;  416: 	g_day = (lp_date).0 & 31
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$1F			; CB	31
	DB	$14			; BAND
	DB	$78,<D0159,>D0159	; SAB	D0159
;  417: 	g_month = ( ( (lp_date).0 >> 5) ? ( ( (lp_date).1 & 1) << 3) ) -1 
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$05			; CB	5
	DB	$1C			; SHR
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$14			; BAND
	DB	$2A,$03			; CB	3
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$78,<D0160,>D0160	; SAB	D0160
;  418: 	g_year = (lp_date).1 >> 1;
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$1C			; SHR
	DB	$7A,<D0161,>D0161	; SAW	D0161
;  419: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  420: 
;  421: ; =====================================
;  422: ; Low level display routines
;  423: 
;  424: ; -------------------------------------
;  425: ; Display a string on the screen
;  426: defn dsp_print(x,y,msg)
C0042:					; dsp_print()
					; x = 2
					; y = 4
					; msg = 6
;  427: 	byte i
					; i = 8
;  428: 	word lp_ptr
					; lp_ptr = 9
;  429: 	x = x - 1
	LDA	#11
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	EOR	#$FF
	ADC	ESTKH-2,X
	TAY
	TYA
	LDY	#$03
	STA	(FP),Y
	DEY
	LDA	ESTKL-2,X
	STA	(FP),Y
;  430: 	lp_ptr = txtscrn[y]
	LDA	#<D0000
	LDY	#>D0000
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	ASL
	ROL	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:	TAY
	LDA	(ESTK-2,X)
	STA	ESTKH-2,X
	TYA
	STA	ESTKL-2,X
	LDY	ESTKH-2,X
	TYA
	LDY	#$0A
	STA	(FP),Y
	DEY
	LDA	ESTKL-2,X
	STA	(FP),Y
;  431: 	if ^msg > 0
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0044
:
;  432: 		for i = 1 to ^msg
	LDA	#$01
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
C0047:
	LDA	ESTKL-2,X
	LDY	#$08
	STA	(FP),Y
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	CMP	ESTKL-2,X
	TYA
	SBC	ESTKH-2,X
	BPL	:+
	JMP	C0046
:
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:
;  433: 			(lp_ptr).[x+i] = (msg).[i] ^ 128
	LDY	#$0A
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	ESTKL-6,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	ESTKL-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	ESTKL-6,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-8,X
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	LDA	ESTKH-8,X
	ADC	ESTKH-6,X
	STA	ESTKH-6,X
	LDA	(ESTK-6,X)
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDA	#$80
	LDY	#$00
	EOR	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	EOR	ESTKH-6,X
	TAY
	LDA	ESTKL-6,X
	STA	(ESTK-4,X)
;  434: 		next
	JMP	C0047
C0046:
;  435: 	fin
C0044:
C0045:
;  436: end
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
;  437: 
;  438: ; -------------------------------------
;  439: ; Display last error code
;  440: def dsp_err()
C0048:					; dsp_err()
;  441: 	if g_sperr <> 0
	JSR	INTERP
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0050,>C0050	; BRFLS	C0050
;  442: 		gotoxy(0,0)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
;  443: 		^outmode = $3F
	DB	$2A,$32			; CB	50
	DB	$2A,$3F			; CB	63
	DB	$70			; SB
;  444: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  445: 		prstr(@msg_sperr)
	DB	$26,<D0067,>D0067	; LAA	D0067
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  446: 		prbyte(g_sperr)
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$54,<C0014,>C0014	; CALL	C0014
	DB	$30			; DROP
;  447: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  448: 		^outmode = $FF
	DB	$2A,$32			; CB	50
	DB	$2A,$FF			; CB	255
	DB	$70			; SB
;  449: 	fin
C0050:
C0051:
;  450: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  451: 
;  452: ; -------------------------------------
;  453: ; Display last error code
;  454: def dsp_err2()
C0052:					; dsp_err2()
;  455: 	if g_sperr <> 0
	JSR	INTERP
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0054,>C0054	; BRFLS	C0054
;  456: 		^outmode = $3F
	DB	$2A,$32			; CB	50
	DB	$2A,$3F			; CB	63
	DB	$70			; SB
;  457: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  458: 		prstr(@msg_sperr)
	DB	$26,<D0067,>D0067	; LAA	D0067
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  459: 		prbyte(g_sperr)
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$54,<C0014,>C0014	; CALL	C0014
	DB	$30			; DROP
;  460: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  461: 		^outmode = $FF
	DB	$2A,$32			; CB	50
	DB	$2A,$FF			; CB	255
	DB	$70			; SB
;  462: 	fin
C0054:
C0055:
;  463: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  464: 
;  465: ; =====================================
;  466: ; Clock routines
;  467: 
;  468: ; -------------------------------------
;  469: ; Clock driver for Prodos 8 before beeing patched
;  470: ; small is beautifull ;-)
;  471: asm clock_driver()
C0056:					; clock_driver()
;  472: 	JSR 0
	JSR 0
;  473: 	DB 0	;status command
	DB 0	;status command
;  474: 	DW 0	;pointer to parameter list
	DW 0	;pointer to parameter list
;  475: 	RTS
	RTS
;  476: ;parameter list
;  477: 	DB 3 	;parameter count
	DB 3 	;parameter count
;  478: 	DB 0	;spvhd id
	DB 0	;spvhd id
;  479: 	DW $BF90 ;destination buffer pointer
	DW $BF90 ;destination buffer pointer
;  480: 	DB 10 ;smartportvhd clock request
	DB 10 ;smartportvhd clock request
;  481: end
	JSR	_PUSHYA
	RTS
;  482: 
;  483: ; -------------------------------------
;  484: ; Copy the clock driver into the
;  485: ; Prodos 8 driver area
;  486: asm clock_driver_copy()
C0058:					; clock_driver_copy()
;  487: 	PHA
	PHA
;  488: 	TXA
	TXA
;  489: 	PHA
	PHA
;  490: 	TYA
	TYA
;  491: 	PHA
	PHA
;  492: 	LDY $3E
	LDY $3E
;  493: 	LDA $C08B
	LDA $C08B
;  494: 	LDA $C08B
	LDA $C08B
;  495: l:
l:
;  496: 	LDA ($3C),Y
	LDA ($3C),Y
;  497: 	STA ($42),Y
	STA ($42),Y
;  498: 	DEY
	DEY
;  499: 	BPL l
	BPL l
;  500: 	
;  501: 	LDA $C082
	LDA $C082
;  502: 	PLA
	PLA
;  503: 	TAY
	TAY
;  504: 	PLA
	PLA
;  505: 	TAX
	TAX
;  506: 	PLA
	PLA
;  507: end
	JSR	_PUSHYA
	RTS
;  508: 
;  509: ; -------------------------------------
;  510: ; Patch the clock driver and install it
;  511: ; if no clock driver is already active
;  512: ; don't work in threaded or native mode
;  513: ; as only pcode mode access memory code
;  514: def clock_driver_install()
C0060:					; clock_driver_install()
;  515: 	word location
					; location = 2
;  516: 	if ^vector_clk == $60
	JSR	INTERP
	DB	$58,$04,$00		; ENTER	4,0
	DB	$2C,$06,$BF		; CW	48902
	DB	$60			; LB
	DB	$2A,$60			; CB	96
	DB	$40			; ISEQ
	DB	$4C,<C0062,>C0062	; BRFLS	C0062
;  517: 		; relocate the driver code
;  518: 		location = *(vector_clk+1)
	DB	$2C,$06,$BF		; CW	48902
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$62			; LW
	DB	$76,$02			; SLW	2
;  519: 		clock_driver:1 = g_spep
	DB	$26,<C0056,>C0056	; LAA	C0056
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$72			; SW
;  520: 		clock_driver:4 = location+7
	DB	$26,<C0056,>C0056	; LAA	C0056
	DB	$2A,$04			; CB	4
	DB	$02			; ADD
	DB	$66,$02			; LLW	2
	DB	$2A,$07			; CB	7
	DB	$02			; ADD
	DB	$72			; SW
;  521: 		clock_driver.8 = g_spvhdid
	DB	$26,<C0056,>C0056	; LAA	C0056
	DB	$2A,$08			; CB	8
	DB	$02			; ADD
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$70			; SB
;  522: 		; copy it over the Prodos clock driver
;  523: 		*($3C) = @clock_driver
	DB	$2A,$3C			; CB	60
	DB	$26,<C0056,>C0056	; LAA	C0056
	DB	$72			; SW
;  524: 		^($3E) = 15
	DB	$2A,$3E			; CB	62
	DB	$2A,$0F			; CB	15
	DB	$70			; SB
;  525: 		*($42) = location 
	DB	$2A,$42			; CB	66
	DB	$66,$02			; LLW	2
	DB	$72			; SW
;  526: 		clock_driver_copy()
	DB	$54,<C0058,>C0058	; CALL	C0058
	DB	$30			; DROP
;  527: 		; activate the clock
;  528: 		;^machid = ^machid ? 1
;  529: 		^vector_clk = $4C
	DB	$2C,$06,$BF		; CW	48902
	DB	$2A,$4C			; CB	76
	DB	$70			; SB
;  530: 	fin
C0062:
C0063:
;  531: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  532: 
;  533: ; -------------------------------------
;  534: ; Smartport driver call
;  535: asm sp_call(l_spe, l_spcmd, l_spprm)
C0064:					; sp_call()
					; l_spe = 2
					; l_spcmd = 4
					; l_spprm = 6
;  536: 	LDY     #$02        ; strptr
	LDA	#8
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDY     #$02        ; strptr
;  537: 	LDA     (FP),Y
	LDA     (FP),Y
;  538: 	STA     SPEP2
	STA     SPEP2
;  539: 	INY
	INY
;  540: 	LDA     (FP),Y
	LDA     (FP),Y
;  541: 	STA     SPEP2+1
	STA     SPEP2+1
;  542: 	INY
	INY
;  543: 	LDA     (FP),Y
	LDA     (FP),Y
;  544: 	STA     SPCMD2
	STA     SPCMD2
;  545: 	INY
	INY
;  546: 	INY
	INY
;  547: 	LDA     (FP),Y
	LDA     (FP),Y
;  548: 	STA     SPPRM2
	STA     SPPRM2
;  549: 	INY
	INY
;  550: 	LDA     (FP),Y
	LDA     (FP),Y
;  551: 	STA     SPPRM2+1
	STA     SPPRM2+1
;  552: 	DB	$20
	DB	$20
;  553: SPEP2:	DW	0000
SPEP2:	DW	0000
;  554: SPCMD2:	DB	00
SPCMD2:	DB	00
;  555: SPPRM2:	DW	0000
SPPRM2:	DW	0000
;  556: 	PHP
	PHP
;  557: 	STA	  $3C
	STA	  $3C
;  558: 	STX	  $3D
	STX	  $3D
;  559: 	STY	  $3E
	STY	  $3E
;  560: 	PLA
	PLA
;  561: 	STA	  $3F
	STA	  $3F
;  562: ;	PLA
;  563: ;	TAX
;  564: ;	LDA     #<REGVALS
;  565: ;	LDY     #>REGVALS
;  566: ;	STA     ESTKL,X
;  567: ;	STY     ESTKH,X
;  568: end
	JSR	_PUSHYA
	JMP	_LEAVE
;  569: 
;  570: ; =====================================
;  571: ; Smartport routines
;  572: 
;  573: ; -------------------------------------
;  574: ; Send status or control commands
;  575: ; id smartportid of the target resident
;  576: ; cmd  either sp_cmd_status or sp_cmd_ctrl
;  577: ; code either sp_status, sp_dcb, sp_dib, or spvhd_*
;  578: ; buffer pointer to the buffer for smartport data
;  579: ; g_spsize is filled with the size of transfered data
;  580: ; Return error code, 0 when no error
;  581: def sp_util(l_id,l_cmd,l_code,l_buffer)
C0066:					; sp_util()
					; l_id = 2
					; l_cmd = 4
					; l_code = 6
					; l_buffer = 8
;  582: 	word l_rs
					; l_rs = 10
;  583: 	byte l_params[5]
					; l_params = 12
;  584: 	if l_id <> 255 and g_spep <> 0
	JSR	INTERP
	DB	$58,$11,$04		; ENTER	17,4
	DB	$66,$02			; LLW	2
	DB	$2A,$FF			; CB	255
	DB	$42			; ISNE
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$24			; LAND
	DB	$4C,<C0068,>C0068	; BRFLS	C0068
;  585: 		l_params.c_sp_prmcnt = 3
	DB	$28,$0C			; LLA	12
	DB	$2A,$03			; CB	3
	DB	$70			; SB
;  586: 		l_params.c_sp_id = l_id
	DB	$28,$0D			; LLA	13
	DB	$66,$02			; LLW	2
	DB	$70			; SB
;  587: 		l_params:c_sp_buffer = l_buffer
	DB	$28,$0E			; LLA	14
	DB	$66,$08			; LLW	8
	DB	$72			; SW
;  588: 		l_params.c_sp_code = l_code
	DB	$28,$10			; LLA	16
	DB	$66,$06			; LLW	6
	DB	$70			; SB
;  589: 		;l_rs = 
;  590: 		sp_call(g_spep, l_cmd, @l_params)
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$66,$04			; LLW	4
	DB	$28,$0C			; LLA	12
	DB	$54,<C0064,>C0064	; CALL	C0064
	DB	$30			; DROP
;  591: 		g_spsize = ^($3D) ? (^($3E)<<8)
	DB	$2A,$3D			; CB	61
	DB	$60			; LB
	DB	$2A,$3E			; CB	62
	DB	$60			; LB
	DB	$2A,$08			; CB	8
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$7A,<D0053,>D0053	; SAW	D0053
;  592: 		return ^($3C) ;return error code
	DB	$2A,$3C			; CB	60
	DB	$60			; LB
	DB	$5A			; LEAVE
;  593: 		;A=error code
;  594: 		;X=lsb of transfered size
;  595: 		;Y=msb of transfered size
;  596: 		;g_spsize = (l_rs).xreg ? (((l_rs).yreg)<<8)
;  597: 		;return (l_rs).areg ;return error code
;  598: 	fin
C0068:
C0069:
;  599: 	return 255
	DB	$2A,$FF			; CB	255
	DB	$5A			; LEAVE
;  600: end
;  601: 
;  602: ; -------------------------------------
;  603: ; Ask number of devices on the current smartport interface
;  604: ; return the number of smartport resident
;  605: def sp_device_count()
C0070:					; sp_device_count()
;  606: 	byte l_buffer[8]
					; l_buffer = 2
;  607: 	byte l_rc
					; l_rc = 10
;  608: 	l_buffer.0 = 0
	JSR	INTERP
	DB	$58,$0B,$00		; ENTER	11,0
	DB	$28,$02			; LLA	2
	DB	$00			; ZERO
	DB	$70			; SB
;  609: 	g_sperr = sp_util(0, c_sp_cmd_status, c_sp_sta_sta, @l_buffer)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$28,$02			; LLA	2
	DB	$54,<C0066,>C0066	; CALL	C0066
	DB	$78,<D0055,>D0055	; SAB	D0055
;  610: 	return l_buffer[0]
	DB	$28,$02			; LLA	2
	DB	$00			; ZERO
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$5A			; LEAVE
;  611: end
;  612: 
;  613: ; -------------------------------------
;  614: ; Get the device information block from a resident
;  615: def sp_get_dib(l_id)
C0072:					; sp_get_dib()
					; l_id = 2
;  616: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_sp_sta_dib, c_spt_buf)
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$03			; CB	3
	DB	$2C,$80,$1F		; CW	8064
	DB	$54,<C0066,>C0066	; CALL	C0066
	DB	$78,<D0055,>D0055	; SAB	D0055
;  617: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0074,>C0074	; BRFLS	C0074
;  618: 		dsp_err2()
	DB	$54,<C0052,>C0052	; CALL	C0052
	DB	$30			; DROP
;  619: 		memset(0,c_spt_buf,25)
	DB	$00			; ZERO
	DB	$2C,$80,$1F		; CW	8064
	DB	$2A,$19			; CB	25
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
;  620: 	fin
C0074:
C0075:
;  621: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  622: 
;  623: ; -------------------------------------
;  624: ; Get the device control block from a resident
;  625: def sp_get_dcb(l_id)
C0076:					; sp_get_dcb()
					; l_id = 2
;  626: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_sp_sta_dcb, c_spt_buf)
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$01			; CB	1
	DB	$2C,$80,$1F		; CW	8064
	DB	$54,<C0066,>C0066	; CALL	C0066
	DB	$78,<D0055,>D0055	; SAB	D0055
;  627: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0078,>C0078	; BRFLS	C0078
;  628: 		dsp_err2()
	DB	$54,<C0052,>C0052	; CALL	C0052
	DB	$30			; DROP
;  629: 		memset(0,c_spt_buf,32)
	DB	$00			; ZERO
	DB	$2C,$80,$1F		; CW	8064
	DB	$2A,$20			; CB	32
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
;  630: 	fin
C0078:
C0079:
;  631: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  632: 
;  633: ; =====================================
;  634: ; SmartportVHD routines
;  635: 
;  636: ; -------------------------------------
;  637: ; Get the date
;  638: def spvhd_get_date(l_id,lp_date)
C0080:					; spvhd_get_date()
					; l_id = 2
					; lp_date = 4
;  639: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_spvhd_date, lp_date)
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$0A			; CB	10
	DB	$66,$04			; LLW	4
	DB	$54,<C0066,>C0066	; CALL	C0066
	DB	$78,<D0055,>D0055	; SAB	D0055
;  640: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0082,>C0082	; BRFLS	C0082
;  641: 		dsp_err()
	DB	$54,<C0048,>C0048	; CALL	C0048
	DB	$30			; DROP
;  642: 		memset(0,lp_date,4)
	DB	$00			; ZERO
	DB	$66,$04			; LLW	4
	DB	$2A,$04			; CB	4
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
;  643: 	fin
C0082:
C0083:
;  644: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  645: 
;  646: ; -------------------------------------
;  647: ; Locate a spvhd connected to a smartport interface
;  648: ; set g_spvhdid, if no device found g_spvhdid = 255
;  649: ; return 1 if spvhd located, 0 if not
;  650: def spvhd_locate_device()
C0084:					; spvhd_locate_device()
;  651: 	byte l_id
					; l_id = 2
;  652: 	byte l_rc
					; l_rc = 3
;  653: 	byte l_count
					; l_count = 4
;  654: 	
;  655: 	g_spvhdid = 255
	JSR	INTERP
	DB	$58,$05,$00		; ENTER	5,0
	DB	$2A,$FF			; CB	255
	DB	$78,<D0052,>D0052	; SAB	D0052
;  656: 	l_rc = 0
	DB	$00			; ZERO
	DB	$74,$03			; SLB	3
;  657: 	l_id = 1
	DB	$2A,$01			; CB	1
	DB	$74,$02			; SLB	2
;  658: 	
;  659: 	l_count = sp_device_count() 
	DB	$54,<C0070,>C0070	; CALL	C0070
	DB	$74,$04			; SLB	4
;  660: 	;crout()
;  661: 	;prstr(@msg_spdevcount)
;  662: 	;printeger(l_count)
;  663: 	;crout()
;  664: 
;  665: 	if l_count > 0
	DB	$64,$04			; LLB	4
	DB	$00			; ZERO
	DB	$44			; ISGT
	DB	$4C,<C0086,>C0086	; BRFLS	C0086
;  666: 		repeat 
C0089:
;  667: 		
;  668: 			;prstr(@msg_spdevice)
;  669: 			;printeger(l_id)
;  670: 			
;  671: 			; Get the device control block
;  672: 			sp_get_dcb(l_id)
	DB	$64,$02			; LLB	2
	DB	$54,<C0076,>C0076	; CALL	C0076
	DB	$30			; DROP
;  673: 			if g_sperr == 0 and memcmp(@g_spvhd_signature, c_spt_buf+c_spvhd_signaturesize, 6)==0 		
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$26,<D0057,>D0057	; LAA	D0057
	DB	$2C,$80,$1F		; CW	8064
	DB	$2A,$05			; CB	5
	DB	$02			; ADD
	DB	$2A,$06			; CB	6
	DB	$54,<C0026,>C0026	; CALL	C0026
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$4C,<C0090,>C0090	; BRFLS	C0090
;  674: 				;cout(' ')
;  675: 				;prstr(@msg_spvhdfound)
;  676: 				;crout()
;  677: 		
;  678: 				l_rc = 1
	DB	$2A,$01			; CB	1
	DB	$74,$03			; SLB	3
;  679: 				g_spvhdid = l_id
	DB	$64,$02			; LLB	2
	DB	$78,<D0052,>D0052	; SAB	D0052
;  680: 				l_id = l_count
	DB	$64,$04			; LLB	4
	DB	$74,$02			; SLB	2
;  681: 			fin
C0090:
C0091:
;  682: 			
;  683: 			;crout()
;  684: 			l_id = l_id + 1
	DB	$64,$02			; LLB	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$74,$02			; SLB	2
;  685: 		until l_id > l_count
	DB	$64,$02			; LLB	2
	DB	$64,$04			; LLB	4
	DB	$44			; ISGT
	DB	$4C,<C0089,>C0089	; BRFLS	C0089
C0088:
;  686: 	fin
C0086:
C0087:
;  687: 	
;  688: 	return l_rc
	DB	$64,$03			; LLB	3
	DB	$5A			; LEAVE
;  689: end
;  690: 
;  691: ; -------------------------------------
;  692: ; Locate the smartport interface to get the entry point
;  693: ; then locate the spvhd within the smartport residents
;  694: ; set g_spep, if no interface found g_spep = 0
;  695: ; set g_spvhdid, if no device found g_spvhdid = 255
;  696: def spvhd_locate()
C0092:					; spvhd_locate()
;  697: 	word l_ptr
					; l_ptr = 2
;  698: 	word l_slot
					; l_slot = 4
;  699: 	;prstr(@msg_interfacelocate)
;  700: 	g_spep = 0
	JSR	INTERP
	DB	$58,$06,$00		; ENTER	6,0
	DB	$00			; ZERO
	DB	$7A,<D0050,>D0050	; SAW	D0050
;  701: 	
;  702: 	l_slot = 7
	DB	$2A,$07			; CB	7
	DB	$76,$04			; SLW	4
;  703: 	repeat
C0095:
;  704: 	
;  705: 		l_ptr = $C000 ? (l_slot << 8)
	DB	$2C,$00,$C0		; CW	49152
	DB	$66,$04			; LLW	4
	DB	$2A,$08			; CB	8
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$76,$02			; SLW	2
;  706: 
;  707: 		;crout()
;  708: 		;prstr(@msg_spslot)
;  709: 		;printeger(l_slot)
;  710: 		
;  711: 		if (l_ptr).1==$20 and (l_ptr).3==$00 and (l_ptr).5==$03 and (l_ptr).7==$00
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$20			; CB	32
	DB	$40			; ISEQ
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$66,$02			; LLW	2
	DB	$2A,$05			; CB	5
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$03			; CB	3
	DB	$40			; ISEQ
	DB	$66,$02			; LLW	2
	DB	$2A,$07			; CB	7
	DB	$02			; ADD
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$24			; LAND
	DB	$24			; LAND
	DB	$4C,<C0096,>C0096	; BRFLS	C0096
;  712: 			;found a smartport interface
;  713: 			g_spep = l_ptr + 3 + (l_ptr).255
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$66,$02			; LLW	2
	DB	$2A,$FF			; CB	255
	DB	$02			; ADD
	DB	$60			; LB
	DB	$02			; ADD
	DB	$7A,<D0050,>D0050	; SAW	D0050
;  714: 			
;  715: 			;cout(' ')
;  716: 			;prstr(@msg_spep)
;  717: 			;prword(g_spep)
;  718: 		
;  719: 			if spvhd_locate_device() <> 0
	DB	$54,<C0084,>C0084	; CALL	C0084
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0098,>C0098	; BRFLS	C0098
;  720: 				l_slot = 1
	DB	$2A,$01			; CB	1
	DB	$76,$04			; SLW	4
;  721: 			fin
C0098:
C0099:
;  722: 		fin
C0096:
C0097:
;  723: 		l_slot = l_slot -1
	DB	$66,$04			; LLW	4
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$76,$04			; SLW	4
;  724: 	until l_slot == 0
	DB	$66,$04			; LLW	4
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0095,>C0095	; BRFLS	C0095
C0094:
;  725: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  726: 
;  727: 
;  728: ; =====================================
;  729: ; SmartportVHD Manager routines
;  730: 
;  731: ; -------------------------------------
;  732: ; Display rela time clock page
;  733: def spm_rtc()
C0100:					; spm_rtc()
;  734: 	byte j
					; j = 2
;  735: 	byte lp_date[4]
					; lp_date = 3
;  736: 	
;  737: 	spvhd_get_date(g_spvhdid,@lp_date)
	JSR	INTERP
	DB	$58,$07,$00		; ENTER	7,0
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$28,$03			; LLA	3
	DB	$54,<C0080,>C0080	; CALL	C0080
	DB	$30			; DROP
;  738: 	if g_sperr == 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0102,>C0102	; BRFLS	C0102
;  739: 		;memcpy(@lp_date,$BF90,4)
;  740: 		dat_date_unpack(@lp_date)
	DB	$28,$03			; LLA	3
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$30			; DROP
;  741: 		dat_bin2dec(g_day,@label_date+1)
	DB	$68,<D0159,>D0159	; LAB	D0159
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$30			; DROP
;  742: 		if g_month < 12
	DB	$68,<D0160,>D0160	; LAB	D0160
	DB	$2A,$0C			; CB	12
	DB	$46			; ISLT
	DB	$4C,<C0104,>C0104	; BRFLS	C0104
;  743: 			memcpy(@months+1+g_month*3,@label_date+4,3)
	DB	$26,<D0120,>D0120	; LAA	D0120
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$68,<D0160,>D0160	; LAB	D0160
	DB	$2A,$03			; CB	3
	DB	$06			; MUL
	DB	$02			; ADD
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$2A,$04			; CB	4
	DB	$02			; ADD
	DB	$2A,$03			; CB	3
	DB	$54,<C0003,>C0003	; CALL	C0003
	DB	$30			; DROP
;  744: 		fin
C0104:
C0105:
;  745: 		j=20
	DB	$2A,$14			; CB	20
	DB	$74,$02			; SLB	2
;  746: 		if g_year >= 40
	DB	$6A,<D0161,>D0161	; LAW	D0161
	DB	$2A,$28			; CB	40
	DB	$48			; ISGE
	DB	$4C,<C0106,>C0106	; BRFLS	C0106
;  747: 			j=19
	DB	$2A,$13			; CB	19
	DB	$74,$02			; SLB	2
;  748: 		fin
C0106:
C0107:
;  749: 		dat_bin2dec(j,@label_date+8)
	DB	$64,$02			; LLB	2
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$2A,$08			; CB	8
	DB	$02			; ADD
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$30			; DROP
;  750: 		dat_bin2dec(g_year,@label_date+10)		
	DB	$6A,<D0161,>D0161	; LAW	D0161
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$2A,$0A			; CB	10
	DB	$02			; ADD
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$30			; DROP
;  751: 		dat_bin2dec(g_hour,@label_date+13)
	DB	$68,<D0157,>D0157	; LAB	D0157
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$2A,$0D			; CB	13
	DB	$02			; ADD
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$30			; DROP
;  752: 		dat_bin2dec(g_minute,@label_date+16)
	DB	$68,<D0158,>D0158	; LAB	D0158
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$2A,$10			; CB	16
	DB	$02			; ADD
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$30			; DROP
;  753: 		gotoxy(11,19)
	DB	$2A,$0B			; CB	11
	DB	$2A,$13			; CB	19
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
;  754: 		prstr(@label_date)
	DB	$26,<D0102,>D0102	; LAA	D0102
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  755: 	fin
C0102:
C0103:
;  756: 
;  757: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  758: 
;  759: ; =====================================
;  760: ; Let's go !
;  761: 
;  762: spvhd_locate()
START:	JSR	INTERP
	DB	$54,<C0092,>C0092	; CALL	C0092
	DB	$30			; DROP
;  763: if g_spvhdid <> 255 and g_spep <> 0
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$2A,$FF			; CB	255
	DB	$42			; ISNE
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$24			; LAND
	DB	$4C,<C0108,>C0108	; BRFLS	C0108
;  764: 	spm_rtc()
	DB	$54,<C0100,>C0100	; CALL	C0100
	DB	$30			; DROP
;  765: 	if g_sperr == 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0110,>C0110	; BRFLS	C0110
;  766: 		if ^vector_clk == $60
	DB	$2C,$06,$BF		; CW	48902
	DB	$60			; LB
	DB	$2A,$60			; CB	96
	DB	$40			; ISEQ
	DB	$4C,<C0112,>C0112	; BRFLS	C0112
;  767: 			clock_driver_install()
	DB	$54,<C0060,>C0060	; CALL	C0060
	DB	$30			; DROP
;  768: 			if ^vector_clk == $60
	DB	$2C,$06,$BF		; CW	48902
	DB	$60			; LB
	DB	$2A,$60			; CB	96
	DB	$40			; ISEQ
	DB	$4C,<C0114,>C0114	; BRFLS	C0114
;  769: 				gotoxy(7,21)
	DB	$2A,$07			; CB	7
	DB	$2A,$15			; CB	21
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
;  770: 				prstr(@msg_installed)
	DB	$26,<D0074,>D0074	; LAA	D0074
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  771: 			fin			
C0114:
C0115:
;  772: 		fin
C0112:
C0113:
;  773: 	fin
C0110:
C0111:
;  774: fin
C0108:
C0109:
;  775: done
	DB	$00			; ZERO
	DB	$5E			; EXIT
