	.INCLUDE	"interp6502.s"
;    1: ;=============================================================================
;    2: ;Smartport Virtual Hard Drive Manager, version 1.0.0
;    3: ;source for cross compilation with cc65
;    4: ;source code have to be splitted to be compiled natively
;    5: ;
;    6: ;Copyright 2012 Cédric PELTIER, pcedric@hotmail.com
;    7: ;
;    8: ;This file is part of the SmartportVHD project
;    9: ;
;   10: ;SmartportVHD Manager is free software: you can redistribute it and/or modify
;   11: ;it under the terms of the GNU General Public License as published by
;   12: ;the Free Software Foundation version 3
;   13: ;
;   14: ;SmartportVHD Manager is distributed in the hope that it will be useful,
;   15: ;but WITHOUT ANY WARRANTY; without even the implied warranty of
;   16: ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   17: ;GNU General Public License for more details.
;   18: ;
;   19: ;You should have received a copy of the GNU General Public License
;   20: ;along with Smartport VHD. If not, see <http://www.gnu.org/licenses/>.
;   21: ;=============================================================================
;   22: 
;   23: ;
;   24: ; Hardware constants
;   25: ;
;   26: const ttop			  = $0022
					; ttop = 34
;   27: const htab			  = $0024
					; htab = 36
;   28: const vtab			  = $0025
					; vtab = 37
;   29: const outmode		  = $0032
					; outmode = 50
;   30: const csw           = $0036
					; csw = 54
;   31: const speaker       = $C030
					; speaker = 49200
;   32: const showgraphics  = $C050
					; showgraphics = 49232
;   33: const showtext      = $C051
					; showtext = 49233
;   34: const showfull      = $C052
					; showfull = 49234
;   35: const showmix       = $C053
					; showmix = 49235
;   36: const showpage1     = $C054
					; showpage1 = 49236
;   37: const showpage2     = $C055
					; showpage2 = 49237
;   38: const showlores     = $C056
					; showlores = 49238
;   39: const showhires     = $C057
					; showhires = 49239
;   40: const pushbttn1     = $C061
					; pushbttn1 = 49249
;   41: const pushbttn2     = $C062
					; pushbttn2 = 49250
;   42: const pushbttn3     = $C063
					; pushbttn3 = 49251
;   43: const keyboard      = $C000
					; keyboard = 49152
;   44: const keystrobe     = $C010
					; keystrobe = 49168
;   45: const keyenter      = $8D
					; keyenter = 141
;   46: const keyspace      = $A0
					; keyspace = 160
;   47: const keyarrowup    = $8B
					; keyarrowup = 139
;   48: const keyarrowdown  = $8A
					; keyarrowdown = 138
;   49: const keyarrowleft  = $88
					; keyarrowleft = 136
;   50: const keyarrowright = $95
					; keyarrowright = 149
;   51: const keyescape     = $9B
					; keyescape = 155
;   52: const keyctrla      = $81
					; keyctrla = 129
;   53: const keyctrlb      = $82
					; keyctrlb = 130
;   54: const keyctrlc      = $83
					; keyctrlc = 131
;   55: const keyctrld      = $84
					; keyctrld = 132
;   56: const keyctrle      = $85
					; keyctrle = 133
;   57: const keyctrli      = $89
					; keyctrli = 137
;   58: const keyctrlk      = $8B
					; keyctrlk = 139
;   59: const keyctrll      = $8C
					; keyctrll = 140
;   60: const keyctrln      = $8E
					; keyctrln = 142
;   61: const keyctrlo      = $8F
					; keyctrlo = 143
;   62: const keyctrlp      = $90
					; keyctrlp = 144
;   63: const keyctrlq      = $91
					; keyctrlq = 145
;   64: const keyctrlr      = $92
					; keyctrlr = 146
;   65: const keyctrls      = $93
					; keyctrls = 147
;   66: const keyctrlt      = $94
					; keyctrlt = 148
;   67: const keyctrlu      = $95
					; keyctrlu = 149
;   68: const keyctrlv      = $96
					; keyctrlv = 150
;   69: const keyctrlw      = $97
					; keyctrlw = 151
;   70: const keyctrlx      = $98
					; keyctrlx = 152
;   71: const keyctrlz      = $9A
					; keyctrlz = 154
;   72: const keyslash		  = $AF
					; keyslash = 175
;   73: const keydelete     = $FF
					; keydelete = 255
;   74: const getbuff       = $01FF
					; getbuff = 511
;   75: ;text line memory mapping
;   76: word txtscrn[]      = [$0400,$0480,$0500,$0580,$0600,$0680,$0700,$0780]
D0000:					; txtscrn
	DW	$0400
	DW	$0480
	DW	$0500
	DW	$0580
	DW	$0600
	DW	$0680
	DW	$0700
	DW	$0780
;   77: word                = [$0428,$04A8,$0528,$05A8,$0628,$06A8,$0728,$07A8]
	DW	$0428
	DW	$04A8
	DW	$0528
	DW	$05A8
	DW	$0628
	DW	$06A8
	DW	$0728
	DW	$07A8
;   78: word                = [$0450,$04D0,$0550,$05D0,$0650,$06D0,$0750,$07D0]
	DW	$0450
	DW	$04D0
	DW	$0550
	DW	$05D0
	DW	$0650
	DW	$06D0
	DW	$0750
	DW	$07D0
;   79: 
;   80: ;
;   81: ; Prodos constants
;   82: ;
;   83: const c_pdos_machid  = $BF98
					; c_pdos_machid = 49048
;   84: const c_pdos_vectclk = $BF06
					; c_pdos_vectclk = 48902
;   85: const c_pdos_date  = $BF90
					; c_pdos_date = 49040
;   86: 
;   87: ;
;   88: ; Plasma register structure access
;   89: ;
;   90: const areg = 0
					; areg = 0
;   91: const xreg = 1
					; xreg = 1
;   92: const yreg = 2
					; yreg = 2
;   93: const preg = 3
					; preg = 3
;   94: 
;   95: ;
;   96: ; Smartport Constants for commands
;   97: ;
;   98: const c_sp_cmd_status = $00
					; c_sp_cmd_status = 0
;   99: const c_sp_cmdex_status = $40
					; c_sp_cmdex_status = 64
;  100: const c_sp_cmd_readblk = $01
					; c_sp_cmd_readblk = 1
;  101: const c_sp_cmdex_readblk = $41
					; c_sp_cmdex_readblk = 65
;  102: const c_sp_cmd_writeblk = $02
					; c_sp_cmd_writeblk = 2
;  103: const c_sp_cmdex_wrtieblk = $42
					; c_sp_cmdex_wrtieblk = 66
;  104: const c_sp_cmd_format = $03
					; c_sp_cmd_format = 3
;  105: const c_sp_cmdex_format = $43
					; c_sp_cmdex_format = 67
;  106: const c_sp_cmd_control = $04
					; c_sp_cmd_control = 4
;  107: const c_sp_cmdex_control = $44
					; c_sp_cmdex_control = 68
;  108: const c_sp_cmd_init = $05
					; c_sp_cmd_init = 5
;  109: const c_sp_cmdex_init = $45
					; c_sp_cmdex_init = 69
;  110: const c_sp_cmd_open = $06
					; c_sp_cmd_open = 6
;  111: const c_sp_cmdex_open = $46
					; c_sp_cmdex_open = 70
;  112: const c_sp_cmd_close = $07
					; c_sp_cmd_close = 7
;  113: const c_sp_cmdex_close = $47
					; c_sp_cmdex_close = 71
;  114: const c_sp_cmd_read = $08
					; c_sp_cmd_read = 8
;  115: const c_sp_cmdex_read = $48
					; c_sp_cmdex_read = 72
;  116: const c_sp_cmd_write = $09
					; c_sp_cmd_write = 9
;  117: const c_sp_cmdex_write = $49
					; c_sp_cmdex_write = 73
;  118: 
;  119: ;
;  120: ; Smartport Constants for structures access
;  121: ;
;  122: const c_sp_prmcnt = 0
					; c_sp_prmcnt = 0
;  123: const c_sp_id = 1
					; c_sp_id = 1
;  124: const c_sp_buffer = 2
					; c_sp_buffer = 2
;  125: const c_sp_code = 4
					; c_sp_code = 4
;  126: const c_sp_blknum_low = 4
					; c_sp_blknum_low = 4
;  127: const c_sp_blknum_med = 5
					; c_sp_blknum_med = 5
;  128: const c_sp_blknum_hig = 6
					; c_sp_blknum_hig = 6
;  129: const c_sp_bytcnt_low = 4
					; c_sp_bytcnt_low = 4
;  130: const c_sp_bytcnt_hig = 5
					; c_sp_bytcnt_hig = 5
;  131: const c_sp_dib_dsb = 0
					; c_sp_dib_dsb = 0
;  132: const c_sp_dib_size = 1
					; c_sp_dib_size = 1
;  133: const c_sp_dib_string = 4
					; c_sp_dib_string = 4
;  134: const c_sp_dib_type = 20
					; c_sp_dib_type = 20
;  135: const c_sp_dib_subtype = 21
					; c_sp_dib_subtype = 21
;  136: const c_sp_dib_version = 22
					; c_sp_dib_version = 22
;  137: ; following constant are spvhd specifics
;  138: const c_spvhd_major = 0
					; c_spvhd_major = 0
;  139: const c_spvhd_minor = 1
					; c_spvhd_minor = 1
;  140: const c_spvhd_revision = 2
					; c_spvhd_revision = 2
;  141: const c_spvhd_id = 3
					; c_spvhd_id = 3
;  142: const c_spvhd_devcount = 4
					; c_spvhd_devcount = 4
;  143: const c_spvhd_signaturesize = 5
					; c_spvhd_signaturesize = 5
;  144: const c_spvhd_signature = 6
					; c_spvhd_signature = 6
;  145: const c_spvhd_datelow = 0
					; c_spvhd_datelow = 0
;  146: const c_spvhd_datehigh = 1
					; c_spvhd_datehigh = 1
;  147: const c_spvhd_minutes = 2
					; c_spvhd_minutes = 2
;  148: const c_spvhd_hours = 3
					; c_spvhd_hours = 3
;  149: const c_spvhd_param = 0
					; c_spvhd_param = 0
;  150: const c_spvhd_path = 1
					; c_spvhd_path = 1
;  151: 
;  152: ;
;  153: ; Smartport Constants for code field in status command and control command
;  154: ;
;  155: const c_sp_sta_sta = 0
					; c_sp_sta_sta = 0
;  156: const c_sp_sta_dcb = 1
					; c_sp_sta_dcb = 1
;  157: const c_sp_sta_dib = 3
					; c_sp_sta_dib = 3
;  158: ; the following codes are specifics to the smartporvhd
;  159: ; to be used with status and control smartport commands
;  160: const c_spvhd_date = 10
					; c_spvhd_date = 10
;  161: const c_spvhd_explore = 11
					; c_spvhd_explore = 11
;  162: const c_spvhd_nextfile = 12
					; c_spvhd_nextfile = 12
;  163: const c_spvhd_parmsel = 13
					; c_spvhd_parmsel = 13
;  164: const c_spvhd_parmboot = 14
					; c_spvhd_parmboot = 14
;  165: const c_spvhd_parmtemp = 15
					; c_spvhd_parmtemp = 15
;  166: 
;  167: ;
;  168: ; Smartport Manager constants
;  169: ;
;  170: const c_max_device = 10
					; c_max_device = 10
;  171: const c_cfg_blksize = 128
					; c_cfg_blksize = 128
;  172: const c_filename_size = 16
					; c_filename_size = 16
;  173: 
;  174: ;
;  175: ; Fields pages size
;  176: ;
;  177: const c_fld_max_x = 40
					; c_fld_max_x = 40
;  178: const c_fld_max_y = 24
					; c_fld_max_y = 24
;  179: 
;  180: ;
;  181: ; Fields Indexes on the main page
;  182: ;
;  183: const c_fld_quit = 0
					; c_fld_quit = 0
;  184: const c_fld_save = 1
					; c_fld_save = 1
;  185: const c_fld_load = 2
					; c_fld_load = 2
;  186: const c_fld_date = 3
					; c_fld_date = 3
;  187: const c_fld_vdsta = 4
					; c_fld_vdsta = 4
;  188: const c_fld_vdpath = c_fld_vdsta + c_max_device
					; c_fld_vdpath = 14
;  189: ;const c_fld_vdboot = c_fld_vdsta + c_max_device
;  190: 
;  191: ;
;  192: ; Fields Indexes on the disk image selector page
;  193: ;
;  194: const c_fld_parent = 0
					; c_fld_parent = 0
;  195: ;const c_fld_done = 1
;  196: const c_fld_clear = 1
					; c_fld_clear = 1
;  197: const c_fld_abort = 2
					; c_fld_abort = 2
;  198: const c_fld_file = 3
					; c_fld_file = 3
;  199: 
;  200: ;
;  201: ; Fields Indexes on the rtc page
;  202: ;
;  203: const c_fld_abort_rtc = 0
					; c_fld_abort_rtc = 0
;  204: const c_fld_day = 1
					; c_fld_day = 1
;  205: const c_fld_month = 2
					; c_fld_month = 2
;  206: const c_fld_year = 3
					; c_fld_year = 3
;  207: const c_fld_hour = 4
					; c_fld_hour = 4
;  208: const c_fld_minute = 5
					; c_fld_minute = 5
;  209: const c_fld_save_rtc = 6
					; c_fld_save_rtc = 6
;  210: const c_fld_prodos = 7
					; c_fld_prodos = 7
;  211: const c_fld_install = 8
					; c_fld_install = 8
;  212: 
;  213: ; fields page
;  214: const c_fld_page_main = 0
					; c_fld_page_main = 0
;  215: const c_fld_page_selector = 1
					; c_fld_page_selector = 1
;  216: const c_fld_page_rtc = 2
					; c_fld_page_rtc = 2
;  217: const c_fld_page_max = 3
					; c_fld_page_max = 3
;  218: 
;  219: ;
;  220: ; Global variables
;  221: ;
;  222: byte g_perr
D0048:	DS	1			; g_perr
;  223: byte g_key
D0049:	DS	1			; g_key
;  224: 
;  225: word g_spep		;smartport entry point
D0050:	DS	2			; g_spep
;  226: byte g_spvhdid	;spvhd smartport id
D0052:	DS	1			; g_spvhdid
;  227: word g_spsize  ;size of transfered data after smartport calls
D0053:	DS	2			; g_spsize
;  228: byte g_sperr   ;last error code
D0055:	DS	1			; g_sperr
;  229: byte g_dev_selected ;selected device
D0056:	DS	1			; g_dev_selected
;  230: byte g_spvhd_signature[] = "SPVHD"
D0057:					; g_spvhd_signature
	DB	$05
	DB	$53,$50,$56,$48,$44
;  231: 
;  232: byte msg_interfacelocate[] = "Locating smartport interfaces..."
D0063:					; msg_interfacelocate
	DB	$20
	DB	$4C,$6F,$63,$61,$74,$69,$6E,$67
	DB	$20,$73,$6D,$61,$72,$74,$70,$6F
	DB	$72,$74,$20,$69,$6E,$74,$65,$72
	DB	$66,$61,$63,$65,$73,$2E,$2E,$2E
;  233: byte msg_end[]	= "Type a key to exit"
D0096:					; msg_end
	DB	$12
	DB	$54,$79,$70,$65,$20,$61,$20,$6B
	DB	$65,$79,$20,$74,$6F,$20,$65,$78
	DB	$69,$74
;  234: byte msg_rc[] = "RC="
D0115:					; msg_rc
	DB	$03
	DB	$52,$43,$3D
;  235: byte msg_spsize[] = "Size:"
D0119:					; msg_spsize
	DB	$05
	DB	$53,$69,$7A,$65,$3A
;  236: ;                       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;  237: byte msg_title[]     = "       SmartportVHD Manager 1.0.0"
D0125:					; msg_title
	DB	$21
	DB	$20,$20,$20,$20,$20,$20,$20,$53
	DB	$6D,$61,$72,$74,$70,$6F,$72,$74
	DB	$56,$48,$44,$20,$4D,$61,$6E,$61
	DB	$67,$65,$72,$20,$31,$2E,$30,$2E
	DB	$30
;  238: byte msg_copyright[] = "      (c)2012 GPLv3 Cedric PELTIER"
D0159:					; msg_copyright
	DB	$22
	DB	$20,$20,$20,$20,$20,$20,$28,$63
	DB	$29,$32,$30,$31,$32,$20,$47,$50
	DB	$4C,$76,$33,$20,$43,$65,$64,$72
	DB	$69,$63,$20,$50,$45,$4C,$54,$49
	DB	$45,$52
;  239: byte msg_url[]       = "          http://www.spvhd.org"
D0194:					; msg_url
	DB	$1E
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$68,$74,$74,$70,$3A,$2F
	DB	$2F,$77,$77,$77,$2E,$73,$70,$76
	DB	$68,$64,$2E,$6F,$72,$67
;  240: byte msg_asciiart0[] = "               ________________"
D0225:					; msg_asciiart0
	DB	$1F
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$20,$20,$20,$20,$5F
	DB	$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F
	DB	$5F,$5F,$5F,$5F,$5F,$5F,$5F
;  241: byte msg_asciiart1[] = "              /               /!"
D0257:					; msg_asciiart1
	DB	$20
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$20,$20,$20,$2F,$20
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$20,$20,$20,$2F,$21
;  242: byte msg_asciiart2[] = "             / / / / / / / / / !"
D0290:					; msg_asciiart2
	DB	$20
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$20,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$21
;  243: byte msg_asciiart3[] = "            / / / / / / / / / /"
D0323:					; msg_asciiart3
	DB	$1F
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$20,$2F,$20,$2F,$20
	DB	$2F,$20,$2F,$20,$2F,$20,$2F,$20
	DB	$2F,$20,$2F,$20,$2F,$20,$2F
;  244: byte msg_asciiart4[] = "           / / / / / / / / / /"
D0355:					; msg_asciiart4
	DB	$1E
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F
;  245: byte msg_asciiart5[] = "          / / / / / / / / / /"
D0386:					; msg_asciiart5
	DB	$1D
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$2F,$20,$2F,$20,$2F,$20
	DB	$2F,$20,$2F,$20,$2F,$20,$2F,$20
	DB	$2F,$20,$2F,$20,$2F
;  246: byte msg_asciiart6[] = "         / / / / / / / / / /"
D0416:					; msg_asciiart6
	DB	$1C
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F
;  247: byte msg_asciiart7[] = "        / / / / / / / / / /"
D0445:					; msg_asciiart7
	DB	$1B
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$2F,$20,$2F,$20,$2F,$20,$2F,$20
	DB	$2F,$20,$2F,$20,$2F,$20,$2F,$20
	DB	$2F,$20,$2F
;  248: byte msg_asciiart8[] = "       / / / / / / / / / /"
D0473:					; msg_asciiart8
	DB	$1A
	DB	$20,$20,$20,$20,$20,$20,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F,$20,$2F,$20,$2F,$20,$2F
	DB	$20,$2F
;  249: byte msg_asciiart9[] = "      /               / /"
D0500:					; msg_asciiart9
	DB	$19
	DB	$20,$20,$20,$20,$20,$20,$2F,$20
	DB	$20,$20,$20,$20,$20,$20,$20,$20
	DB	$20,$20,$20,$20,$20,$20,$2F,$20
	DB	$2F
;  250: byte msg_asciiartA[] = "     /______________ / /"
D0526:					; msg_asciiartA
	DB	$18
	DB	$20,$20,$20,$20,$20,$2F,$5F,$5F
	DB	$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F
	DB	$5F,$5F,$5F,$5F,$20,$2F,$20,$2F
;  251: byte msg_asciiartB[] = "    !_.....___....._! /"
D0551:					; msg_asciiartB
	DB	$17
	DB	$20,$20,$20,$20,$21,$5F,$2E,$2E
	DB	$2E,$2E,$2E,$5F,$5F,$5F,$2E,$2E
	DB	$2E,$2E,$2E,$5F,$21,$20,$2F
;  252: byte msg_asciiartC[] = "    ! ______________!/"
D0575:					; msg_asciiartC
	DB	$16
	DB	$20,$20,$20,$20,$21,$20,$5F,$5F
	DB	$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F
	DB	$5F,$5F,$5F,$5F,$21,$2F
;  253: 
;  254: byte msg_spvhdlocate[]="    Locating SmartportVHD... "
D0598:					; msg_spvhdlocate
	DB	$1D
	DB	$20,$20,$20,$20,$4C,$6F,$63,$61
	DB	$74,$69,$6E,$67,$20,$53,$6D,$61
	DB	$72,$74,$70,$6F,$72,$74,$56,$48
	DB	$44,$2E,$2E,$2E,$20
;  255: byte msg_spslot[]    = "    Slot:"
D0628:					; msg_spslot
	DB	$09
	DB	$20,$20,$20,$20,$53,$6C,$6F,$74
	DB	$3A
;  256: byte msg_spep[]      = "Entry point at "
D0638:					; msg_spep
	DB	$0F
	DB	$45,$6E,$74,$72,$79,$20,$70,$6F
	DB	$69,$6E,$74,$20,$61,$74,$20
;  257: byte msg_spdevcount[]= "    Devices count:"
D0654:					; msg_spdevcount
	DB	$12
	DB	$20,$20,$20,$20,$44,$65,$76,$69
	DB	$63,$65,$73,$20,$63,$6F,$75,$6E
	DB	$74,$3A
;  258: byte msg_spdevice[]  = "    Device:"
D0673:					; msg_spdevice
	DB	$0B
	DB	$20,$20,$20,$20,$44,$65,$76,$69
	DB	$63,$65,$3A
;  259: byte msg_spvhdfound[]= "SmartportVHD found"
D0685:					; msg_spvhdfound
	DB	$12
	DB	$53,$6D,$61,$72,$74,$70,$6F,$72
	DB	$74,$56,$48,$44,$20,$66,$6F,$75
	DB	$6E,$64
;  260: byte msg_firmware[] =  "    Firmware version "
D0704:					; msg_firmware
	DB	$15
	DB	$20,$20,$20,$20,$46,$69,$72,$6D
	DB	$77,$61,$72,$65,$20,$76,$65,$72
	DB	$73,$69,$6F,$6E,$20
;  261: 
;  262: byte msg_sperr[] = "ERROR "
D0726:					; msg_sperr
	DB	$06
	DB	$45,$52,$52,$4F,$52,$20
;  263: ;byte msg_cfgfile_load[] = "Loading configuration data..."
;  264: 
;  265: byte msg_help[]      = "Use arrows and return to change options"
D0733:					; msg_help
	DB	$27
	DB	$55,$73,$65,$20,$61,$72,$72,$6F
	DB	$77,$73,$20,$61,$6E,$64,$20,$72
	DB	$65,$74,$75,$72,$6E,$20,$74,$6F
	DB	$20,$63,$68,$61,$6E,$67,$65,$20
	DB	$6F,$70,$74,$69,$6F,$6E,$73
;  266: byte msg_title_main[]     = "Main menu"
D0773:					; msg_title_main
	DB	$09
	DB	$4D,$61,$69,$6E,$20,$6D,$65,$6E
	DB	$75
;  267: byte msg_drive[] =  "Virtual device"
D0783:					; msg_drive
	DB	$0E
	DB	$56,$69,$72,$74,$75,$61,$6C,$20
	DB	$64,$65,$76,$69,$63,$65
;  268: byte msg_mark[] = "---"
D0798:					; msg_mark
	DB	$03
	DB	$2D,$2D,$2D
;  269: byte msg_helprtc[] = "Use up and down arrows to adjust date"
D0802:					; msg_helprtc
	DB	$25
	DB	$55,$73,$65,$20,$75,$70,$20,$61
	DB	$6E,$64,$20,$64,$6F,$77,$6E,$20
	DB	$61,$72,$72,$6F,$77,$73,$20,$74
	DB	$6F,$20,$61,$64,$6A,$75,$73,$74
	DB	$20,$64,$61,$74,$65
;  270: byte msg_ok[] = "Ok"
D0840:					; msg_ok
	DB	$02
	DB	$4F,$6B
;  271: byte msg_driver_present[] = "Clock driver active"
D0843:					; msg_driver_present
	DB	$13
	DB	$43,$6C,$6F,$63,$6B,$20,$64,$72
	DB	$69,$76,$65,$72,$20,$61,$63,$74
	DB	$69,$76,$65
;  272: byte msg_installed[] = "Installed"
D0863:					; msg_installed
	DB	$09
	DB	$49,$6E,$73,$74,$61,$6C,$6C,$65
	DB	$64
;  273: byte msg_title_rtc[] = "Real time clock"
D0873:					; msg_title_rtc
	DB	$0F
	DB	$52,$65,$61,$6C,$20,$74,$69,$6D
	DB	$65,$20,$63,$6C,$6F,$63,$6B
;  274: byte msg_no_sprtc1[] = "SmartportRTC not detected, you can"
D0889:					; msg_no_sprtc1
	DB	$22
	DB	$53,$6D,$61,$72,$74,$70,$6F,$72
	DB	$74,$52,$54,$43,$20,$6E,$6F,$74
	DB	$20,$64,$65,$74,$65,$63,$74,$65
	DB	$64,$2C,$20,$79,$6F,$75,$20,$63
	DB	$61,$6E
;  275: byte msg_no_sprtc2[] = "adjust prodos date and time only."
D0924:					; msg_no_sprtc2
	DB	$21
	DB	$61,$64,$6A,$75,$73,$74,$20,$70
	DB	$72,$6F,$64,$6F,$73,$20,$64,$61
	DB	$74,$65,$20,$61,$6E,$64,$20,$74
	DB	$69,$6D,$65,$20,$6F,$6E,$6C,$79
	DB	$2E
;  276: 
;  277: ;
;  278: ; Fields labels
;  279: ;
;  280: byte label_quit[] = "QUIT"
D0958:					; label_quit
	DB	$04
	DB	$51,$55,$49,$54
;  281: byte label_save[] = "SAVE"
D0963:					; label_save
	DB	$04
	DB	$53,$41,$56,$45
;  282: byte label_load[] = "LOAD"
D0968:					; label_load
	DB	$04
	DB	$4C,$4F,$41,$44
;  283: ;byte label_boot[] = "BOOT"
;  284: byte label_parent[] = "PARENT"
D0973:					; label_parent
	DB	$06
	DB	$50,$41,$52,$45,$4E,$54
;  285: byte label_done[] = "DONE"
D0980:					; label_done
	DB	$04
	DB	$44,$4F,$4E,$45
;  286: byte label_clear[] = "CLEAR"
D0985:					; label_clear
	DB	$05
	DB	$43,$4C,$45,$41,$52
;  287: byte label_abort[] = "ABORT"
D0991:					; label_abort
	DB	$05
	DB	$41,$42,$4F,$52,$54
;  288: byte label_disabled[] ="NC"
D0997:					; label_disabled
	DB	$02
	DB	$4E,$43
;  289: byte label_unmounted[]="NM"
D1000:					; label_unmounted
	DB	$02
	DB	$4E,$4D
;  290: byte label_ro[]  ="RO"
D1003:					; label_ro
	DB	$02
	DB	$52,$4F
;  291: byte label_rw[]  ="RW"
D1006:					; label_rw
	DB	$02
	DB	$52,$57
;  292: byte label_null[] = ""
D1009:					; label_null
	DB	$00
;  293: byte label_select[] = "SELECT DISK IMAGE"
D1010:					; label_select
	DB	$11
	DB	$53,$45,$4C,$45,$43,$54,$20,$44
	DB	$49,$53,$4B,$20,$49,$4D,$41,$47
	DB	$45
;  294: ;byte label_date[] = "-- --- ---- --:--"
;  295: byte label_date[] = "DATE"
D1028:					; label_date
	DB	$04
	DB	$44,$41,$54,$45
;  296: byte label_day[] = "--"
D1033:					; label_day
	DB	$02
	DB	$2D,$2D
;  297: byte label_month[] = "---"
D1036:					; label_month
	DB	$03
	DB	$2D,$2D,$2D
;  298: byte label_year[] = "----"
D1040:					; label_year
	DB	$04
	DB	$2D,$2D,$2D,$2D
;  299: byte label_hour[] = "--"
D1045:					; label_hour
	DB	$02
	DB	$2D,$2D
;  300: byte label_minute[] = "--"
D1048:					; label_minute
	DB	$02
	DB	$2D,$2D
;  301: byte label_prodos[] =  "SET PRODOS DATE"
D1051:					; label_prodos
	DB	$0F
	DB	$53,$45,$54,$20,$50,$52,$4F,$44
	DB	$4F,$53,$20,$44,$41,$54,$45
;  302: byte label_install[] = "LOAD RTC DRIVER"
D1067:					; label_install
	DB	$0F
	DB	$4C,$4F,$41,$44,$20,$52,$54,$43
	DB	$20,$44,$52,$49,$56,$45,$52
;  303: 
;  304: ;
;  305: ; Lookup table to display month
;  306: ;
;  307: word months[] = "JANFEBMARAPRMAYJUNJULAOUSEPOCTNOVDEC"
D1083:					; months
	DB	$24
	DB	$4A,$41,$4E,$46,$45,$42,$4D,$41
	DB	$52,$41,$50,$52,$4D,$41,$59,$4A
	DB	$55,$4E,$4A,$55,$4C,$41,$4F,$55
	DB	$53,$45,$50,$4F,$43,$54,$4E,$4F
	DB	$56,$44,$45,$43
;  308: 
;  309: ;
;  310: ; Lookup table to check days per month
;  311: ;
;  312: byte dayspermonth[] = [31,28,31,30,31,30,31,31,30,31,30,31]
D1120:					; dayspermonth
	DB	$1F
	DB	$1C
	DB	$1F
	DB	$1E
	DB	$1F
	DB	$1E
	DB	$1F
	DB	$1F
	DB	$1E
	DB	$1F
	DB	$1E
	DB	$1F
;  313: 
;  314: ;
;  315: ; Fields description for the main page
;  316: ;
;  317: 
;  318: ; x screen positions
;  319: byte fields_main_x[]	= [36,26,31,21]
D1132:					; fields_main_x
	DB	$24
	DB	$1A
	DB	$1F
	DB	$15
;  320: byte = [  0,   0,   0,   0,   0,   0,   0,   0,   0,   0]
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
;  321: byte = [  5,   5,   5,   5,   5,   5,   5,   5,   5,   5]
	DB	$05
	DB	$05
	DB	$05
	DB	$05
	DB	$05
	DB	$05
	DB	$05
	DB	$05
	DB	$05
	DB	$05
;  322: 
;  323: ; y screen positions
;  324: byte fields_main_y[]	= [ 0, 0, 0, 0]
D1156:					; fields_main_y
	DB	$00
	DB	$00
	DB	$00
	DB	$00
;  325: byte = [ 3,  5,  7,  9, 11, 13, 15, 17, 19, 21]
	DB	$03
	DB	$05
	DB	$07
	DB	$09
	DB	$0B
	DB	$0D
	DB	$0F
	DB	$11
	DB	$13
	DB	$15
;  326: byte = [ 3,  5,  7,  9, 11, 13, 15, 17, 19, 21]
	DB	$03
	DB	$05
	DB	$07
	DB	$09
	DB	$0B
	DB	$0D
	DB	$0F
	DB	$11
	DB	$13
	DB	$15
;  327: 
;  328: ; labels
;  329: word fields_main_l[]	= [@label_quit, @label_save, @label_load, @label_date]
D1180:					; fields_main_l
	DW	D0958	; D0958
	DW	D0963	; D0963
	DW	D0968	; D0968
	DW	D1028	; D1028
;  330: word = [@label_disabled, @label_disabled, @label_disabled, @label_disabled]
	DW	D0997	; D0997
	DW	D0997	; D0997
	DW	D0997	; D0997
	DW	D0997	; D0997
;  331: word = [@label_disabled, @label_disabled, @label_disabled, @label_disabled]
	DW	D0997	; D0997
	DW	D0997	; D0997
	DW	D0997	; D0997
	DW	D0997	; D0997
;  332: word = [@label_disabled, @label_disabled]
	DW	D0997	; D0997
	DW	D0997	; D0997
;  333: word = [@label_null, @label_null, @label_null, @label_null, @label_null]
	DW	D1009	; D1009
	DW	D1009	; D1009
	DW	D1009	; D1009
	DW	D1009	; D1009
	DW	D1009	; D1009
;  334: word = [@label_null, @label_null, @label_null, @label_null, @label_null]
	DW	D1009	; D1009
	DW	D1009	; D1009
	DW	D1009	; D1009
	DW	D1009	; D1009
	DW	D1009	; D1009
;  335: 
;  336: ; shortcuts
;  337: byte fields_main_s[] = ['Q','S','L','D',0,0,0,0,0,0,0,0,0,0,'1','2','3','4','5','6','7','8','9','0']
D1228:					; fields_main_s
	DB	$51
	DB	$53
	DB	$4C
	DB	$44
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$31
	DB	$32
	DB	$33
	DB	$34
	DB	$35
	DB	$36
	DB	$37
	DB	$38
	DB	$39
	DB	$30
;  338: 
;  339: ;
;  340: ; Fields description for the disk image selector page
;  341: ;
;  342: 
;  343: ; x screen positions
;  344: byte fields_sel_x[]	= [22,29,35]
D1252:					; fields_sel_x
	DB	$16
	DB	$1D
	DB	$23
;  345: byte = [ 10,  10,  10,  10,  10,  10,  10,  10,  10,  10]
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
;  346: byte = [ 10,  10,  10,  10,  10,  10,  10,  10]
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
	DB	$0A
;  347: 
;  348: ; y screen positions
;  349: byte fields_sel_y[]	= [ 0, 0, 0]
D1273:					; fields_sel_y
	DB	$00
	DB	$00
	DB	$00
;  350: byte = [255, 255, 255, 255, 255, 255, 255, 255, 255, 255]
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
;  351: byte = [255, 255, 255, 255, 255, 255, 255, 255]
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
	DB	$FF
;  352: 
;  353: ; labels
;  354: byte g_filename0[c_filename_size]
D1294:	DS	16			; g_filename0
;  355: byte g_filename1[c_filename_size]
D1310:	DS	16			; g_filename1
;  356: byte g_filename2[c_filename_size]
D1326:	DS	16			; g_filename2
;  357: byte g_filename3[c_filename_size]
D1342:	DS	16			; g_filename3
;  358: byte g_filename4[c_filename_size]
D1358:	DS	16			; g_filename4
;  359: byte g_filename5[c_filename_size]
D1374:	DS	16			; g_filename5
;  360: byte g_filename6[c_filename_size]
D1390:	DS	16			; g_filename6
;  361: byte g_filename7[c_filename_size]
D1406:	DS	16			; g_filename7
;  362: byte g_filename8[c_filename_size]
D1422:	DS	16			; g_filename8
;  363: byte g_filename9[c_filename_size]
D1438:	DS	16			; g_filename9
;  364: byte g_filename10[c_filename_size]
D1454:	DS	16			; g_filename10
;  365: byte g_filename11[c_filename_size]
D1470:	DS	16			; g_filename11
;  366: byte g_filename12[c_filename_size]
D1486:	DS	16			; g_filename12
;  367: byte g_filename13[c_filename_size]
D1502:	DS	16			; g_filename13
;  368: byte g_filename14[c_filename_size]
D1518:	DS	16			; g_filename14
;  369: byte g_filename15[c_filename_size]
D1534:	DS	16			; g_filename15
;  370: byte g_filename16[c_filename_size]
D1550:	DS	16			; g_filename16
;  371: byte g_filename17[c_filename_size]
D1566:	DS	16			; g_filename17
;  372: word fields_sel_l[] = [@label_parent, @label_clear, @label_abort]
D1582:					; fields_sel_l
	DW	D0973	; D0973
	DW	D0985	; D0985
	DW	D0991	; D0991
;  373: word = [@g_filename0, @g_filename1, @g_filename2, @g_filename3, @g_filename4]
	DW	D1294	; D1294
	DW	D1310	; D1310
	DW	D1326	; D1326
	DW	D1342	; D1342
	DW	D1358	; D1358
;  374: word = [@g_filename5, @g_filename6, @g_filename7, @g_filename8, @g_filename9]
	DW	D1374	; D1374
	DW	D1390	; D1390
	DW	D1406	; D1406
	DW	D1422	; D1422
	DW	D1438	; D1438
;  375: word = [@g_filename10, @g_filename11, @g_filename12, @g_filename13, @g_filename14]
	DW	D1454	; D1454
	DW	D1470	; D1470
	DW	D1486	; D1486
	DW	D1502	; D1502
	DW	D1518	; D1518
;  376: word = [@g_filename15, @g_filename16, @g_filename17]
	DW	D1534	; D1534
	DW	D1550	; D1550
	DW	D1566	; D1566
;  377: 
;  378: ; shortcuts
;  379: byte fields_sel_s[] = ['P','C','A',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
D1624:					; fields_sel_s
	DB	$50
	DB	$43
	DB	$41
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
	DB	$00
;  380: 
;  381: ;
;  382: ; Fields description for the clock selector
;  383: ;
;  384: 
;  385: ; x screen positions
;  386: byte fields_rtc_x[]	= [35, 10, 13, 17, 23, 26, 3, 3, 3]
D1645:					; fields_rtc_x
	DB	$23
	DB	$0A
	DB	$0D
	DB	$11
	DB	$17
	DB	$1A
	DB	$03
	DB	$03
	DB	$03
;  387: 
;  388: ; y screen positions
;  389: byte fields_rtc_y[]	= [0, 4, 4, 4, 4, 4, 4, 6, 8]
D1654:					; fields_rtc_y
	DB	$00
	DB	$04
	DB	$04
	DB	$04
	DB	$04
	DB	$04
	DB	$04
	DB	$06
	DB	$08
;  390: 
;  391: ; labels
;  392: word fields_rtc_l[]	= [@label_abort, @label_day, @label_month, @label_year]
D1663:					; fields_rtc_l
	DW	D0991	; D0991
	DW	D1033	; D1033
	DW	D1036	; D1036
	DW	D1040	; D1040
;  393: word = [@label_hour, @label_minute, @label_save, @label_prodos, @label_install]
	DW	D1045	; D1045
	DW	D1048	; D1048
	DW	D0963	; D0963
	DW	D1051	; D1051
	DW	D1067	; D1067
;  394: 
;  395: ; shortcuts
;  396: byte fields_rtc_s[] = ['A','D','M','Y','H',0,'S','P','I']
D1681:					; fields_rtc_s
	DB	$41
	DB	$44
	DB	$4D
	DB	$59
	DB	$48
	DB	$00
	DB	$53
	DB	$50
	DB	$49
;  397: 
;  398: ;
;  399: ; Fields pages descriptions
;  400: ;
;  401: byte fields_pages_c[] = [24, 21, 9]
D1690:					; fields_pages_c
	DB	$18
	DB	$15
	DB	$09
;  402: word fields_pages_x[] = [@fields_main_x, @fields_sel_x, @fields_rtc_x]
D1693:					; fields_pages_x
	DW	D1132	; D1132
	DW	D1252	; D1252
	DW	D1645	; D1645
;  403: word fields_pages_y[] = [@fields_main_y, @fields_sel_y, @fields_rtc_y]
D1699:					; fields_pages_y
	DW	D1156	; D1156
	DW	D1273	; D1273
	DW	D1654	; D1654
;  404: word fields_pages_l[] = [@fields_main_l, @fields_sel_l, @fields_rtc_l]
D1705:					; fields_pages_l
	DW	D1180	; D1180
	DW	D1582	; D1582
	DW	D1663	; D1663
;  405: word fields_pages_s[] = [@fields_main_s, @fields_sel_s, @fields_rtc_s]
D1711:					; fields_pages_s
	DW	D1228	; D1228
	DW	D1624	; D1624
	DW	D1681	; D1681
;  406: 
;  407: ;
;  408: ; Fields globals variables
;  409: ;
;  410: 
;  411: ; currently selected field
;  412: byte fields_selected
D1717:	DS	1			; fields_selected
;  413: ; currently selected page
;  414: byte fields_page_selected
D1718:	DS	1			; fields_page_selected
;  415: ; pointers to fields descriptions for the selected page
;  416: word fields_x
D1719:	DS	2			; fields_x
;  417: word fields_y
D1721:	DS	2			; fields_y
;  418: word fields_l
D1723:	DS	2			; fields_l
;  419: word fields_s
D1725:	DS	2			; fields_s
;  420: 
;  421: ; last selected field for each page
;  422: byte fields_last[c_fld_page_max]
D1727:	DS	3			; fields_last
;  423: 
;  424: ; number of fields on the selected page
;  425: byte fields_count
D1730:	DS	1			; fields_count
;  426: 
;  427: ;
;  428: ; Firmware version informations
;  429: ;
;  430: byte g_version_major
D1731:	DS	1			; g_version_major
;  431: byte g_version_minor
D1732:	DS	1			; g_version_minor
;  432: byte g_version_revision
D1733:	DS	1			; g_version_revision
;  433: byte g_version_stage
D1734:	DS	1			; g_version_stage
;  434: 
;  435: ;
;  436: ; Global buffers 
;  437: ;
;  438: 
;  439: ;buffer to work on the pathname used by the disk image selector
;  440: byte g_pathname[128]
D1735:	DS	128			; g_pathname
;  441: byte g_hour
D1863:	DS	1			; g_hour
;  442: byte g_minute
D1864:	DS	1			; g_minute
;  443: byte g_day
D1865:	DS	1			; g_day
;  444: byte g_month
D1866:	DS	1			; g_month
;  445: word g_year
D1867:	DS	2			; g_year
;  446: 
;  447: ;current file at the top of the directory listing
;  448: byte g_repo_pos
D1869:	DS	1			; g_repo_pos
;  449: 
;  450: byte g_cfg_file[1408] ;1408(c_max_device+1)*c_cfg_blksize
D1870:	DS	1408			; g_cfg_file
;  451: byte g_spt_buf[512]
D3278:	DS	512			; g_spt_buf
;  452: 
;  453: ;display flag for inverse video printing
;  454: byte g_dsp_flag
D3790:	DS	1			; g_dsp_flag
;  455: 
;  456: ;
;  457: ; Helpers
;  458: ;
;  459: ;def getkey()
;  460: ;    return (romcall(0, 0, 0, 0, $FD0C)).1
;  461: ;end
;  462: ;def bell()
;  463: ;    romcall(0, 0, 0, 0, $FBDD)
;  464: ;end
;  465: def home()
C0008:					; home()
;  466:     romcall(0, 0, 0, 0, $FC58)
	JSR	INTERP
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$58,$FC		; CW	64600
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  467: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  468: def gotoxy(x, y)
C0010:					; gotoxy()
					; x = 2
					; y = 4
;  469: 	^($24) = x
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$2A,$24			; CB	36
	DB	$66,$02			; LLW	2
	DB	$70			; SB
;  470: 	romcall(y, 0, 0, 0, $FB5B)
	DB	$66,$04			; LLW	4
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$5B,$FB		; CW	64347
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  471: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  472: def crout()
C0012:					; crout()
;  473: 	cout($8D)
	JSR	INTERP
	DB	$2A,$8D			; CB	141
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  474: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  475: def prbyte(h)
C0014:					; prbyte()
					; h = 2
;  476: 	cout('$')
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$2A,$24			; CB	36
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  477: 	romcall(h, 0, 0, 0, $FDDA)
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$DA,$FD		; CW	64986
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  478: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  479: def prword(h)
C0016:					; prword()
					; h = 2
;  480: 	cout('$')
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$2A,$24			; CB	36
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  481: 	romcall(h >> 8, h, 0, 0, $F941)
	DB	$66,$02			; LLW	2
	DB	$2A,$08			; CB	8
	DB	$1C			; SHR
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2C,$41,$F9		; CW	63809
	DB	$54,<C0000,>C0000	; CALL	C0000
	DB	$30			; DROP
;  482: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  483: def printeger(i)
C0018:					; printeger()
					; i = 2
;  484: 	byte numstr[7]
					; numstr = 4
;  485: 	byte place, sign
					; place = 11
					; sign = 12
;  486: 
;  487: 	place = 6
	JSR	INTERP
	DB	$58,$0D,$01		; ENTER	13,1
	DB	$2A,$06			; CB	6
	DB	$74,$0B			; SLB	11
;  488: 	if i < 0
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$46			; ISLT
	DB	$4C,<C0020,>C0020	; BRFLS	C0020
;  489: 		sign = 1
	DB	$2A,$01			; CB	1
	DB	$74,$0C			; SLB	12
;  490: 		i = -i
	DB	$66,$02			; LLW	2
	DB	$10			; NEG
	DB	$76,$02			; SLW	2
;  491: 	else
	DB	$50,<C0021,>C0021	; JUMP	C0021
C0020:
;  492: 		sign = 0
	DB	$00			; ZERO
	DB	$74,$0C			; SLB	12
;  493: 	fin
C0021:
;  494: 	while i >= 10
C0022:
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$48			; ISGE
	DB	$4C,<C0023,>C0023	; BRFLS	C0023
;  495: 		numstr[place] = i % 10 + '0'
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$0A			; MOD
	DB	$2A,$30			; CB	48
	DB	$02			; ADD
	DB	$70			; SB
;  496: 		i = i / 10
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$08			; DIV
	DB	$76,$02			; SLW	2
;  497: 		place	= place - 1
	DB	$64,$0B			; LLB	11
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$0B			; SLB	11
;  498: 	loop
	DB	$50,<C0022,>C0022	; JUMP	C0022
C0023:
;  499: 	numstr[place] = i + '0'
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$66,$02			; LLW	2
	DB	$2A,$30			; CB	48
	DB	$02			; ADD
	DB	$70			; SB
;  500: 	place	= place - 1
	DB	$64,$0B			; LLB	11
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$0B			; SLB	11
;  501: 	if sign
	DB	$64,$0C			; LLB	12
	DB	$4C,<C0024,>C0024	; BRFLS	C0024
;  502: 		numstr[place] = '-'
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$2A,$2D			; CB	45
	DB	$70			; SB
;  503: 		place	= place - 1
	DB	$64,$0B			; LLB	11
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$0B			; SLB	11
;  504: 	fin
C0024:
C0025:
;  505: 	numstr[place] = 6 - place
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$2A,$06			; CB	6
	DB	$64,$0B			; LLB	11
	DB	$04			; SUB
	DB	$70			; SB
;  506: 	prstr(@numstr[place])
	DB	$28,$04			; LLA	4
	DB	$64,$0B			; LLB	11
	DB	$2E			; IDXB
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  507: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  508: 
;  509: ; =====================================
;  510: ; Memory management routines
;  511: ;
;  512: 
;  513: defn strcpy(srcstr, dststr)
C0026:					; strcpy()
					; srcstr = 2
					; dststr = 4
;  514:     byte strlen
					; strlen = 6
;  515: 
;  516:     strlen = ^srcstr
	LDA	#7
	STA	FRMSZ
	LDA	#2
	STA	NPARMS
	JSR	_ENTER
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	LDY	#$06
	STA	(FP),Y
;  517:     while (srcstr).[strlen] == $8D or (srcstr).[strlen] == $A0
C0028:
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDY	#$06
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$8D
	LDY	#$00
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$06
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$A0
	LDY	#$00
	CMP	ESTKL-4,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-4,X
	BEQ	:++
:	LDY	#$00
:	TYA
	ORA	ESTKL-2,X
	BNE	:+
	TYA
	ORA	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
	TYA
:
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0029
:
;  518:         strlen = strlen - 1
	LDY	#$06
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	EOR	#$FF
	ADC	ESTKH-2,X
	TAY
	LDA	ESTKL-2,X
	LDY	#$06
	STA	(FP),Y
;  519:     loop
	JMP	C0028
C0029:
;  520:     ^dststr = strlen
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDY	#$06
	LDA	(FP),Y
	LDY	#$00
	STA	(ESTK-2,X)
;  521:     return memcpy(srcstr + 1, dststr + 1, strlen)
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDY	#$06
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0003
	PLA
	TAX
	DEX
	DEX
	JMP	_LEAVE
;  522: end
;  523: 
;  524: ; Compare two memory block
;  525: ; return 0 if the content match
;  526: deft memcmp(lp_src1, lp_src2, l_len)
C0030:					; memcmp()
					; lp_src1 = 2
					; lp_src2 = 4
					; l_len = 6
;  527: 	byte i
					; i = 8
;  528: 	i = 0
	LDA	#9
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDA	#$00
	TAY
	JSR	_PUSHYA
	LDY	#$08
	JSR	_SLB
;  529: 	while i < l_len
C0032:
	LDY	#$08
	JSR	_LLB
	LDY	#$06
	JSR	_LLW
	JSR	ISLT
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0033
:
;  530: 		if ^(lp_src1+i) <> ^(lp_src2+i)
	LDY	#$02
	JSR	_LLW
	LDY	#$08
	JSR	_LLB
	JSR	ADD
	JSR	LB
	LDY	#$04
	JSR	_LLW
	LDY	#$08
	JSR	_LLB
	JSR	ADD
	JSR	LB
	JSR	ISNE
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0034
:
;  531: 			return 1
	LDA	#$01
	LDY	#$00
	JSR	_PUSHYA
	JMP	_LEAVE
;  532: 		fin
C0034:
C0035:
;  533: 		i = i + 1
	LDY	#$08
	JSR	_LLB
	LDA	#$01
	LDY	#$00
	JSR	_PUSHYA
	JSR	ADD
	LDY	#$08
	JSR	_SLB
;  534: 	loop
	JMP	C0032
C0033:
;  535: 	return 0
	LDA	#$00
	TAY
	JSR	_PUSHYA
	JMP	_LEAVE
;  536: end
;  537: 
;  538: ; =====================================
;  539: ; ProDOS routines
;  540: 
;  541: ;def prodos_online(unit,buf)
;  542: ;    byte params[4]
;  543: ;
;  544: ;    params.0  = 2
;  545: ;    params.1  = unit
;  546: ;    params:2  = buf
;  547: ;    g_perr      = syscall($C5, @params)
;  548: ;    return g_perr
;  549: ;end
;  550: ;def prodos_getpfx(path)
;  551: ;    byte params[3]
;  552: 
;  553: ;    ^path    = 0
;  554: ;    params.0 = 1
;  555: ;    params:1 = path
;  556: ;    g_perr     = syscall($C7, @params)
;  557: ;    return path
;  558: ;end
;  559: ;def prodos_setpfx(path)
;  560: ;    byte params[3]
;  561: 
;  562: ;    params.0 = 1
;  563: ;    params:1 = path
;  564: ;    g_perr     = syscall($C6, @params)
;  565: ;    return path
;  566: ;end
;  567: ;def prodos_open(path, buff)
;  568: ;    byte params[6]
;  569: 
;  570: ;    params.0 = 3
;  571: ;    params:1 = path
;  572: ;    params:3 = buff
;  573: ;    g_perr     = syscall($C8, @params)
;  574: ;    return params.5
;  575: ;end
;  576: ;def prodos_close(refnum)
;  577: ;    byte params[2]
;  578: 
;  579: ;    params.0 = 1
;  580: ;    params.1 = refnum
;  581: ;    g_perr     = syscall($CC, @params)
;  582: ;    return g_perr
;  583: ;end
;  584: ;def prodos_read(refnum, buff, len)
;  585: ;    byte params[8]
;  586: 
;  587: ;    params.0 = 4
;  588: ;    params.1 = refnum
;  589: ;    params:2 = buff
;  590: ;    params:4 = len
;  591: ;    params:6 = 0
;  592: ;    g_perr     = syscall($CA, @params)
;  593: ;    return params:6
;  594: ;end
;  595: ;def prodos_write(refnum, buff, len)
;  596: ;    byte params[8]
;  597: 
;  598: ;    params.0 = 4
;  599: ;    params.1 = refnum
;  600: ;    params:2 = buff
;  601: ;    params:4 = len
;  602: ;    params:6 = 0
;  603: ;    g_perr     = syscall($CB, @params)
;  604: ;    return params:6
;  605: ;end
;  606: ;def prodos_create(path, access, type, aux)
;  607: ;    byte params[12]
;  608: 
;  609: ;    params.0  = 7
;  610: ;    params:1  = path
;  611: ;    params.3  = access
;  612: ;    params.4  = type
;  613: ;    params:5  = aux
;  614: ;    params.7  = $1
;  615: ;    params:8  = 0
;  616: ;    params:10 = 0
;  617: ;    g_perr      = syscall($C0, @params)
;  618: ;    return g_perr
;  619: ;end
;  620: ;def prodos_destroy(path)
;  621: ;    byte params[12]
;  622: 
;  623: ;    params.0 = 1
;  624: ;    params:1 = path
;  625: ;    g_perr     = syscall($C1, @params)
;  626: ;    return g_perr
;  627: ;end
;  628: ;def prodos_newline(refnum, emask, nlchar)
;  629: ;    byte params[4]
;  630: 
;  631: ;    params.0 = 3
;  632: ;    params.1 = refnum
;  633: ;    params.2 = emask
;  634: ;    params.3 = nlchar
;  635: ;    g_perr     = syscall($C9, @params)
;  636: ;    return g_perr
;  637: ;end
;  638: 
;  639: ; =====================================
;  640: ; Keyboard routines
;  641: 
;  642: def getkey()
C0036:					; getkey()
;  643:     repeat
	JSR	INTERP
C0039:
;  644:     until ^keyboard >= 128
	DB	$2C,$00,$C0		; CW	49152
	DB	$60			; LB
	DB	$2A,$80			; CB	128
	DB	$48			; ISGE
	DB	$4C,<C0039,>C0039	; BRFLS	C0039
C0038:
;  645:     return ^keystrobe
	DB	$2C,$10,$C0		; CW	49168
	DB	$60			; LB
	DB	$5C			; RET
;  646: end
;  647: 
;  648: ; =====================================
;  649: ; data routines
;  650: 
;  651: ; -------------------------------------
;  652: ; Get a pointer on the dcb of a virtual device
;  653: defn dat_dcb_pointer(l_devnum)
C0040:					; dat_dcb_pointer()
					; l_devnum = 2
;  654: 	return @g_cfg_file + l_devnum * c_cfg_blksize
	LDA	#4
	STA	FRMSZ
	LDA	#1
	STA	NPARMS
	JSR	_ENTER
	LDA	#<D1870
	LDY	#>D1870
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	#$80
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	MUL
	PLA
	TAX
	LDA	ESTKL-4,X
	LDY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
;  655: end
;  656: 
;  657: ; -------------------------------------
;  658: ; Go to the parent folder
;  659: def dat_path_sub(lp_path)
C0042:					; dat_path_sub()
					; lp_path = 2
;  660: 	byte i
					; i = 4
;  661: 	
;  662: 	if ^lp_path == 0
	JSR	INTERP
	DB	$58,$05,$01		; ENTER	5,1
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0044,>C0044	; BRFLS	C0044
;  663: 		return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  664: 	fin
C0044:
C0045:
;  665: 
;  666: 	; remove the ending separator
;  667: 	if ^(lp_path + ^lp_path) == $2F
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$2F			; CB	47
	DB	$40			; ISEQ
	DB	$4C,<C0046,>C0046	; BRFLS	C0046
;  668: 		^lp_path = ^lp_path - 1
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$70			; SB
;  669: 	fin
C0046:
C0047:
;  670: 	
;  671: 	;remove the final filename but keep an ending separator
;  672: 	;as it's a folder	
;  673: 	while ^lp_path > 0 and ^(lp_path + ^lp_path) <> $2F
C0048:
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$44			; ISGT
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$2F			; CB	47
	DB	$42			; ISNE
	DB	$24			; LAND
	DB	$4C,<C0049,>C0049	; BRFLS	C0049
;  674: 		^lp_path = ^lp_path -1
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$70			; SB
;  675: 	loop
	DB	$50,<C0048,>C0048	; JUMP	C0048
C0049:
;  676: 	
;  677: 	;add the ending separator if path size is zero
;  678: 	if ^lp_path == 0
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0050,>C0050	; BRFLS	C0050
;  679: 		^(lp_path + 1) = $2F
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$2A,$2F			; CB	47
	DB	$70			; SB
;  680: 		^lp_path = ^lp_path + 1
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$70			; SB
;  681: 	fin
C0050:
C0051:
;  682: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  683: 
;  684: ; -------------------------------------
;  685: ; Concatenate a filename to a pathname
;  686: def dat_path_add(lp_path,lp_file)
C0052:					; dat_path_add()
					; lp_path = 2
					; lp_file = 4
;  687: 	byte i
					; i = 6
;  688: 	byte j
					; j = 7
;  689: 	
;  690: 	j = ^lp_file
	JSR	INTERP
	DB	$58,$08,$02		; ENTER	8,2
	DB	$66,$04			; LLW	4
	DB	$60			; LB
	DB	$74,$07			; SLB	7
;  691: 	if j == 0
	DB	$64,$07			; LLB	7
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0054,>C0054	; BRFLS	C0054
;  692: 		return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  693: 	fin
C0054:
C0055:
;  694: 	
;  695: 	i = ^lp_path
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$74,$06			; SLB	6
;  696: 	if i == 0
	DB	$64,$06			; LLB	6
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0056,>C0056	; BRFLS	C0056
;  697: 		i = 1
	DB	$2A,$01			; CB	1
	DB	$74,$06			; SLB	6
;  698: 		^(lp_path+i) = $2F
	DB	$66,$02			; LLW	2
	DB	$64,$06			; LLB	6
	DB	$02			; ADD
	DB	$2A,$2F			; CB	47
	DB	$70			; SB
;  699: 	fin
C0056:
C0057:
;  700: 	
;  701: 	;if the current pathname isn't a folder
;  702: 	;remove the filename to replace it by the new one
;  703: 	if ^(lp_path+i) <> $2F
	DB	$66,$02			; LLW	2
	DB	$64,$06			; LLB	6
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$2F			; CB	47
	DB	$42			; ISNE
	DB	$4C,<C0058,>C0058	; BRFLS	C0058
;  704: 		dat_path_sub(lp_path)
	DB	$66,$02			; LLW	2
	DB	$54,<C0042,>C0042	; CALL	C0042
	DB	$30			; DROP
;  705: 		i = ^lp_path
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$74,$06			; SLB	6
;  706: 	fin
C0058:
C0059:
;  707: 	
;  708: 	;if the concatened filename is a folder starting by a separator
;  709: 	;discard the ending separator from the pathname 
;  710: 	if ^(lp_file+1) == $2F
	DB	$66,$04			; LLW	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$2F			; CB	47
	DB	$40			; ISEQ
	DB	$4C,<C0060,>C0060	; BRFLS	C0060
;  711: 		i = i - 1
	DB	$64,$06			; LLB	6
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$06			; SLB	6
;  712: 	fin
C0060:
C0061:
;  713: 	
;  714: 	; concat file name	
;  715: 	while j>0
C0062:
	DB	$64,$07			; LLB	7
	DB	$00			; ZERO
	DB	$44			; ISGT
	DB	$4C,<C0063,>C0063	; BRFLS	C0063
;  716: 		^(lp_path+i+j) = ^(lp_file+j)
	DB	$66,$02			; LLW	2
	DB	$64,$06			; LLB	6
	DB	$02			; ADD
	DB	$64,$07			; LLB	7
	DB	$02			; ADD
	DB	$66,$04			; LLW	4
	DB	$64,$07			; LLB	7
	DB	$02			; ADD
	DB	$60			; LB
	DB	$70			; SB
;  717: 		j = j - 1
	DB	$64,$07			; LLB	7
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$07			; SLB	7
;  718: 	loop
	DB	$50,<C0062,>C0062	; JUMP	C0062
C0063:
;  719: 	^lp_path = i + ^lp_file 		
	DB	$66,$02			; LLW	2
	DB	$64,$06			; LLB	6
	DB	$66,$04			; LLW	4
	DB	$60			; LB
	DB	$02			; ADD
	DB	$70			; SB
;  720: 
;  721: 	; add separator if the concatened filename is a folder
;  722: 	if ^(lp_file+1) == $2F
	DB	$66,$04			; LLW	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$2F			; CB	47
	DB	$40			; ISEQ
	DB	$4C,<C0064,>C0064	; BRFLS	C0064
;  723: 		^lp_path = ^lp_path + 1
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$70			; SB
;  724: 		^(lp_path + ^lp_path) = $2F
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$02			; ADD
	DB	$2A,$2F			; CB	47
	DB	$70			; SB
;  725: 	fin
C0064:
C0065:
;  726: 	return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  727: end
;  728: 
;  729: ; -------------------------------------
;  730: ; Remove the leading character of the string
;  731: def dat_right(lp_ptr)
C0066:					; dat_right()
					; lp_ptr = 2
;  732: 	byte i
					; i = 4
;  733: 	if ^lp_ptr == 0
	JSR	INTERP
	DB	$58,$05,$01		; ENTER	5,1
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0068,>C0068	; BRFLS	C0068
;  734: 		return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  735: 	fin
C0068:
C0069:
;  736: 	if ^lp_ptr == 1
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0070,>C0070	; BRFLS	C0070
;  737: 		^lp_ptr = 0
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$70			; SB
;  738: 		return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  739: 	fin
C0070:
C0071:
;  740: 	for i=2 to ^lp_ptr
	DB	$2A,$02			; CB	2
C0073:
	DB	$6C,$04			; DLB	4
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$3A,<C0072,>C0072	; BRGT	C0072
	DB	$0C			; INCR
;  741: 		(lp_ptr).[i-1] = (lp_ptr).[i]
	DB	$66,$02			; LLW	2
	DB	$64,$04			; LLB	4
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$2E			; IDXB
	DB	$66,$02			; LLW	2
	DB	$64,$04			; LLB	4
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$70			; SB
;  742: 	next
	DB	$50,<C0073,>C0073	; JUMP	C0073
C0072:
	DB	$30			; DROP
;  743: 	^lp_ptr = ^lp_ptr - 1
	DB	$66,$02			; LLW	2
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$70			; SB
;  744: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  745: 
;  746: ; -------------------------------------
;  747: ; Translate a binary byte to decimal ascii
;  748: def dat_bin2dec(l_src,lp_dst)
C0074:					; dat_bin2dec()
					; l_src = 2
					; lp_dst = 4
;  749: 	byte i
					; i = 6
;  750: 	i = l_src / 10
	JSR	INTERP
	DB	$58,$07,$02		; ENTER	7,2
	DB	$66,$02			; LLW	2
	DB	$2A,$0A			; CB	10
	DB	$08			; DIV
	DB	$74,$06			; SLB	6
;  751: 	if i < 10
	DB	$64,$06			; LLB	6
	DB	$2A,$0A			; CB	10
	DB	$46			; ISLT
	DB	$4C,<C0076,>C0076	; BRFLS	C0076
;  752: 		^lp_dst = '0' + i
	DB	$66,$04			; LLW	4
	DB	$2A,$30			; CB	48
	DB	$64,$06			; LLB	6
	DB	$02			; ADD
	DB	$70			; SB
;  753: 	else
	DB	$50,<C0077,>C0077	; JUMP	C0077
C0076:
;  754: 		^lp_dst = '?'
	DB	$66,$04			; LLW	4
	DB	$2A,$3F			; CB	63
	DB	$70			; SB
;  755: 	fin
C0077:
;  756: 	i = l_src - i * 10
	DB	$66,$02			; LLW	2
	DB	$64,$06			; LLB	6
	DB	$2A,$0A			; CB	10
	DB	$06			; MUL
	DB	$04			; SUB
	DB	$74,$06			; SLB	6
;  757: 	^(lp_dst+1) = '0' + i
	DB	$66,$04			; LLW	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$2A,$30			; CB	48
	DB	$64,$06			; LLB	6
	DB	$02			; ADD
	DB	$70			; SB
;  758: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  759: 
;  760: ; -------------------------------------
;  761: ; Update dayspermonth[1] from g_year
;  762: def dat_check_leapyear()
C0078:					; dat_check_leapyear()
;  763: 	word i
					; i = 2
;  764: 	word j
					; j = 4
;  765: 	word k
					; k = 6
;  766: 	dayspermonth[1] = 28
	JSR	INTERP
	DB	$58,$08,$00		; ENTER	8,0
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$2A,$01			; CB	1
	DB	$2E			; IDXB
	DB	$2A,$1C			; CB	28
	DB	$70			; SB
;  767: 	i = g_year-((g_year/4)*4)
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$04			; CB	4
	DB	$08			; DIV
	DB	$2A,$04			; CB	4
	DB	$06			; MUL
	DB	$04			; SUB
	DB	$76,$02			; SLW	2
;  768: 	j = g_year-((g_year/100)*100)
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$64			; CB	100
	DB	$08			; DIV
	DB	$2A,$64			; CB	100
	DB	$06			; MUL
	DB	$04			; SUB
	DB	$76,$04			; SLW	4
;  769: 	if i==0 and j<>0 
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$66,$04			; LLW	4
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$24			; LAND
	DB	$4C,<C0080,>C0080	; BRFLS	C0080
;  770: 		dayspermonth[1] = 29
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$2A,$01			; CB	1
	DB	$2E			; IDXB
	DB	$2A,$1D			; CB	29
	DB	$70			; SB
;  771: 	else
	DB	$50,<C0081,>C0081	; JUMP	C0081
C0080:
;  772: 		k = g_year-((g_year/400)*400)
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2C,$90,$01		; CW	400
	DB	$08			; DIV
	DB	$2C,$90,$01		; CW	400
	DB	$06			; MUL
	DB	$04			; SUB
	DB	$76,$06			; SLW	6
;  773: 		if k == 0
	DB	$66,$06			; LLW	6
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0082,>C0082	; BRFLS	C0082
;  774: 			dayspermonth[1] = 29
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$2A,$01			; CB	1
	DB	$2E			; IDXB
	DB	$2A,$1D			; CB	29
	DB	$70			; SB
;  775: 		fin
C0082:
C0083:
;  776: 	fin
C0081:
;  777: 	if g_month == 1 and g_day > dayspermonth[1]
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$2A,$01			; CB	1
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$44			; ISGT
	DB	$24			; LAND
	DB	$4C,<C0084,>C0084	; BRFLS	C0084
;  778: 		g_day = dayspermonth[1]
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$2A,$01			; CB	1
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$78,<D1865,>D1865	; SAB	D1865
;  779: 	fin
C0084:
C0085:
;  780: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  781: 
;  782: ; -------------------------------------
;  783: ; Check global date and time variable
;  784: ; and reset them if something is wrong
;  785: def dat_check_date()
C0086:					; dat_check_date()
;  786: 	if (g_month<12 and g_day > dayspermonth[g_month]) or g_month>=12 or g_year>99 or g_hour>23 or g_minute>59
	JSR	INTERP
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$0C			; CB	12
	DB	$46			; ISLT
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$44			; ISGT
	DB	$24			; LAND
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$0C			; CB	12
	DB	$48			; ISGE
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$63			; CB	99
	DB	$44			; ISGT
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$2A,$17			; CB	23
	DB	$44			; ISGT
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$2A,$3B			; CB	59
	DB	$44			; ISGT
	DB	$22			; LOR
	DB	$22			; LOR
	DB	$22			; LOR
	DB	$22			; LOR
	DB	$4C,<C0088,>C0088	; BRFLS	C0088
;  787: 		g_day = 25
	DB	$2A,$19			; CB	25
	DB	$78,<D1865,>D1865	; SAB	D1865
;  788: 		g_month = 11
	DB	$2A,$0B			; CB	11
	DB	$78,<D1866,>D1866	; SAB	D1866
;  789: 		g_year = 12
	DB	$2A,$0C			; CB	12
	DB	$7A,<D1867,>D1867	; SAW	D1867
;  790: 		g_hour = 0
	DB	$00			; ZERO
	DB	$78,<D1863,>D1863	; SAB	D1863
;  791: 		g_minute = 0
	DB	$00			; ZERO
	DB	$78,<D1864,>D1864	; SAB	D1864
;  792: 		dayspermonth[1] = 29
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$2A,$01			; CB	1
	DB	$2E			; IDXB
	DB	$2A,$1D			; CB	29
	DB	$70			; SB
;  793: 	fin
C0088:
C0089:
;  794: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  795: 
;  796: ; -------------------------------------
;  797: ; Pack global date and time into a prodos date
;  798: def dat_date_pack(lp_date)
C0090:					; dat_date_pack()
					; lp_date = 2
;  799: 	byte i
					; i = 4
;  800: 	i = g_month + 1
	JSR	INTERP
	DB	$58,$05,$01		; ENTER	5,1
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$74,$04			; SLB	4
;  801: 	(lp_date).3 = g_hour
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$70			; SB
;  802: 	(lp_date).2 = g_minute
	DB	$66,$02			; LLW	2
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$70			; SB
;  803: 	(lp_date).1 = (g_year << 1) ? (i >> 3)
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$01			; CB	1
	DB	$1A			; SHL
	DB	$64,$04			; LLB	4
	DB	$2A,$03			; CB	3
	DB	$1C			; SHR
	DB	$16			; IOR
	DB	$70			; SB
;  804: 	(lp_date).0 = g_day ? (i << 5)
	DB	$66,$02			; LLW	2
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$64,$04			; LLB	4
	DB	$2A,$05			; CB	5
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$70			; SB
;  805: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  806: 
;  807: ; -------------------------------------
;  808: ; Update global date and time from a prodos date
;  809: def dat_date_unpack(lp_date)
C0092:					; dat_date_unpack()
					; lp_date = 2
;  810: 	g_hour = (lp_date).3
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$60			; LB
	DB	$78,<D1863,>D1863	; SAB	D1863
;  811: 	g_minute = (lp_date).2
	DB	$66,$02			; LLW	2
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$60			; LB
	DB	$78,<D1864,>D1864	; SAB	D1864
;  812: 	g_day = (lp_date).0 & 31
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$1F			; CB	31
	DB	$14			; BAND
	DB	$78,<D1865,>D1865	; SAB	D1865
;  813: 	g_month = ( ( (lp_date).0 >> 5) ? ( ( (lp_date).1 & 1) << 3) ) -1 
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$05			; CB	5
	DB	$1C			; SHR
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$14			; BAND
	DB	$2A,$03			; CB	3
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$78,<D1866,>D1866	; SAB	D1866
;  814: 	g_year = (lp_date).1 >> 1
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$1C			; SHR
	DB	$7A,<D1867,>D1867	; SAW	D1867
;  815: 	dat_check_leapyear()
	DB	$54,<C0078,>C0078	; CALL	C0078
	DB	$30			; DROP
;  816: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  817: 
;  818: ; -------------------------------------
;  819: ; Extract firmware version informations
;  820: def dat_versiondib_unpack(lp_version)
C0094:					; dat_versiondib_unpack()
					; lp_version = 2
;  821: 	g_version_major = (lp_version).1 >> 4
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$04			; CB	4
	DB	$1C			; SHR
	DB	$78,<D1731,>D1731	; SAB	D1731
;  822: 	g_version_minor = ((lp_version).0 >> 4) ? ((lp_version).1 << 4)
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$04			; CB	4
	DB	$1C			; SHR
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$04			; CB	4
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$78,<D1732,>D1732	; SAB	D1732
;  823: 	g_version_stage = (lp_version).0 & 15
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$2A,$0F			; CB	15
	DB	$14			; BAND
	DB	$78,<D1734,>D1734	; SAB	D1734
;  824: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  825: 
;  826: ; -------------------------------------
;  827: ; Extract firmware version informations
;  828: def dat_versiondcb_unpack(lp_version)
C0096:					; dat_versiondcb_unpack()
					; lp_version = 2
;  829: 	g_version_major = (lp_version).c_spvhd_major
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$78,<D1731,>D1731	; SAB	D1731
;  830: 	g_version_minor = (lp_version).c_spvhd_minor
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$78,<D1732,>D1732	; SAB	D1732
;  831: 	g_version_revision = (lp_version).c_spvhd_revision
	DB	$66,$02			; LLW	2
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$60			; LB
	DB	$78,<D1733,>D1733	; SAB	D1733
;  832: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  833: 
;  834: ; =====================================
;  835: ; Low level display routines
;  836: 
;  837: ; Apple II french characters
;  838: ; 00xxxxxx 00-3F 000-063 maj invert 
;  839: ; 00 àABCDEFGHIJKLMNO
;  840: ; 10 PQRSTUVWXYZ°ç§^_
;  841: ; 20 !"£$%&'()*+,-./
;  842: ; 30 0123456789:;<=>?
;  843: ; 01xxxxxx 40-7F 064-127 maj flash
;  844: ; 40 àABCDEFGHIJKLMNO
;  845: ; 50 PQRSTUVWXYZ°ç§^_
;  846: ; 60 !"£$%&'()*+,-./
;  847: ; 70 0123456789:;<=>?
;  848: ; 10xxxxxx 80-BF 128-191 maj normal
;  849: ; 80 àABCDEFGHIJKLMNO
;  850: ; 90 PQRSTUVWXYZ°ç§^_
;  851: ; A0 !"£$%&'()*+,-./
;  852: ; B0 0123456789:;<=>?
;  853: ; 110xxxxx C0-DF maj normal
;  854: ; C0 àABCDEFGHIJKLMNO
;  855: ; D0 PQRSTUVWXYZ°ç§^_
;  856: ; 111xxxxx E0-FF 224-255 min normal
;  857: ; E0 `abcdefghijklmno
;  858: ; F0 pqrstuvwxyzéùè"
;  859: 
;  860: ; -------------------------------------
;  861: ; Display a string on the screen
;  862: defn dsp_print(x,y,msg)
C0098:					; dsp_print()
					; x = 2
					; y = 4
					; msg = 6
;  863: 	byte i
					; i = 8
;  864: 	byte c
					; c = 9
;  865: 	word lp_ptr
					; lp_ptr = 10
;  866: 	lp_ptr = txtscrn[y]
	LDA	#12
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDA	#<D0000
	LDY	#>D0000
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	ASL
	ROL	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:	TAY
	LDA	(ESTK-2,X)
	STA	ESTKH-2,X
	TYA
	STA	ESTKL-2,X
	LDY	ESTKH-2,X
	TYA
	LDY	#$0B
	STA	(FP),Y
	DEY
	LDA	ESTKL-2,X
	STA	(FP),Y
;  867: 	if ^msg > 0
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0100
:
;  868: 		if g_dsp_flag == 255
	LDA	D3790
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$FF
	LDY	#$00
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0102
:
;  869: 			for i = 1 to ^msg
	LDA	#$01
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
C0105:
	LDA	ESTKL-2,X
	LDY	#$08
	STA	(FP),Y
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	CMP	ESTKL-2,X
	TYA
	SBC	ESTKH-2,X
	BPL	:+
	JMP	C0104
:
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:
;  870: 				(lp_ptr).[x+i-1] = (msg).[i] ? 128
	LDY	#$0B
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	ESTKL-6,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	EOR	#$FF
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	ESTKL-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	ESTKL-6,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-8,X
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	LDA	ESTKH-8,X
	ADC	ESTKH-6,X
	STA	ESTKH-6,X
	LDA	(ESTK-6,X)
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDA	#$80
	LDY	#$00
	ORA	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	ORA	ESTKH-6,X
	TAY
	LDA	ESTKL-6,X
	STA	(ESTK-4,X)
;  871: 			next
	JMP	C0105
C0104:
;  872: 		else
	JMP	C0103
C0102:
;  873: 			for i = 1 to ^msg
	LDA	#$01
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
C0107:
	LDA	ESTKL-2,X
	LDY	#$08
	STA	(FP),Y
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	CMP	ESTKL-2,X
	TYA
	SBC	ESTKH-2,X
	BPL	:+
	JMP	C0106
:
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:
;  874: 				c = (msg).[i] ? 128
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$80
	LDY	#$00
	ORA	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ORA	ESTKH-4,X
	TAY
	LDA	ESTKL-4,X
	LDY	#$09
	STA	(FP),Y
;  875: 				;translate lower case to upper case for inversed video 
;  876: 				if c >= $E0
	LDY	#$09
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$E0
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDY	#$FF
	LDA	ESTKL-4,X
	CMP	ESTKL-6,X
	LDA	ESTKH-4,X
	SBC	ESTKH-6,X
	BPL	:+
	INY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0108
:
;  877: 					c = c ^ 96
	LDY	#$09
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$60
	LDY	#$00
	EOR	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	EOR	ESTKH-4,X
	TAY
	LDA	ESTKL-4,X
	LDY	#$09
	STA	(FP),Y
;  878: 				fin
C0108:
C0109:
;  879: 				(lp_ptr).[x+i-1] = c & g_dsp_flag
	LDY	#$0B
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	ESTKL-6,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	EOR	#$FF
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	ESTKL-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDY	#$09
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDA	D3790
	LDY	#$00
	AND	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	AND	ESTKH-6,X
	TAY
	LDA	ESTKL-6,X
	STA	(ESTK-4,X)
;  880: 			next
	JMP	C0107
C0106:
;  881: 		fin
C0103:
;  882: 	fin
C0100:
C0101:
;  883: end
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
;  884: 
;  885: ; -------------------------------------
;  886: ; Display a pattern on the screen
;  887: defn dsp_fill(x,y,l,c)
C0110:					; dsp_fill()
					; x = 2
					; y = 4
					; l = 6
					; c = 8
;  888: 	byte i
					; i = 10
;  889: 	word lp_ptr
					; lp_ptr = 11
;  890: 	lp_ptr = txtscrn[y]
	LDA	#13
	STA	FRMSZ
	LDA	#4
	STA	NPARMS
	JSR	_ENTER
	LDA	#<D0000
	LDY	#>D0000
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	ASL
	ROL	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:	TAY
	LDA	(ESTK-2,X)
	STA	ESTKH-2,X
	TYA
	STA	ESTKL-2,X
	LDY	ESTKH-2,X
	TYA
	LDY	#$0C
	STA	(FP),Y
	DEY
	LDA	ESTKL-2,X
	STA	(FP),Y
;  891: 	c = (c ? 128) & g_dsp_flag
	LDY	#$09
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$80
	LDY	#$00
	ORA	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ORA	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDA	D3790
	LDY	#$00
	AND	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	AND	ESTKH-2,X
	TAY
	TYA
	LDY	#$09
	STA	(FP),Y
	DEY
	LDA	ESTKL-2,X
	STA	(FP),Y
;  892: 	if l > 0
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0112
:
;  893: 		l = l - 1
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	EOR	#$FF
	ADC	ESTKH-2,X
	TAY
	TYA
	LDY	#$07
	STA	(FP),Y
	DEY
	LDA	ESTKL-2,X
	STA	(FP),Y
;  894: 		for i = 0 to l
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
C0115:
	LDA	ESTKL-2,X
	LDY	#$0A
	STA	(FP),Y
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	LDY	ESTKH-4,X
	CMP	ESTKL-2,X
	TYA
	SBC	ESTKH-2,X
	BPL	:+
	JMP	C0114
:
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:
;  895: 			(lp_ptr).[x+i] = c
	LDY	#$0C
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	ESTKL-6,X
	LDY	#$0A
	LDA	(FP),Y
	LDY	#$00
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	ESTKL-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDY	#$09
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	STA	(ESTK-4,X)
;  896: 		next
	JMP	C0115
C0114:
;  897: 	fin
C0112:
C0113:
;  898: end
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
;  899: 
;  900: ; -------------------------------------
;  901: ; Repeat a character to screen
;  902: ;defn dsp_repeat(char,n)
;  903: ;	byte i
;  904: ;	for i = 1 to n
;  905: ;		cout(char)
;  906: ;	next
;  907: ;end
;  908: 
;  909: ; -------------------------------------
;  910: ; Display last error code
;  911: def dsp_err()
C0116:					; dsp_err()
;  912: 	if g_sperr <> 0
	JSR	INTERP
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0118,>C0118	; BRFLS	C0118
;  913: 		gotoxy(0,0)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
;  914: 		^outmode = $3F
	DB	$2A,$32			; CB	50
	DB	$2A,$3F			; CB	63
	DB	$70			; SB
;  915: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  916: 		prstr(@msg_sperr)
	DB	$26,<D0726,>D0726	; LAA	D0726
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  917: 		prbyte(g_sperr)
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$54,<C0014,>C0014	; CALL	C0014
	DB	$30			; DROP
;  918: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  919: 		^outmode = $FF
	DB	$2A,$32			; CB	50
	DB	$2A,$FF			; CB	255
	DB	$70			; SB
;  920: 		getkey()
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$30			; DROP
;  921: 	fin
C0118:
C0119:
;  922: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  923: 
;  924: ; -------------------------------------
;  925: ; Display last error code
;  926: def dsp_err2()
C0120:					; dsp_err2()
;  927: 	if g_sperr <> 0
	JSR	INTERP
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0122,>C0122	; BRFLS	C0122
;  928: 		^outmode = $3F
	DB	$2A,$32			; CB	50
	DB	$2A,$3F			; CB	63
	DB	$70			; SB
;  929: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  930: 		prstr(@msg_sperr)
	DB	$26,<D0726,>D0726	; LAA	D0726
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  931: 		prbyte(g_sperr)
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$54,<C0014,>C0014	; CALL	C0014
	DB	$30			; DROP
;  932: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
;  933: 		^outmode = $FF
	DB	$2A,$32			; CB	50
	DB	$2A,$FF			; CB	255
	DB	$70			; SB
;  934: 	fin
C0122:
C0123:
;  935: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  936: 
;  937: ; -------------------------------------
;  938: def dsp_err_abort()
C0124:					; dsp_err_abort()
;  939: 	if g_sperr <> 0
	JSR	INTERP
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0126,>C0126	; BRFLS	C0126
;  940: 		home()
	DB	$54,<C0008,>C0008	; CALL	C0008
	DB	$30			; DROP
;  941: 		gotoxy(15,12)
	DB	$2A,$0F			; CB	15
	DB	$2A,$0C			; CB	12
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
;  942: 		prstr(@msg_sperr)
	DB	$26,<D0726,>D0726	; LAA	D0726
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
;  943: 		prbyte(g_sperr)
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$54,<C0014,>C0014	; CALL	C0014
	DB	$30			; DROP
;  944: 		g_key = getkey()
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$78,<D0049,>D0049	; SAB	D0049
;  945: 	fin
C0126:
C0127:
;  946: end
	DB	$00			; ZERO
	DB	$5C			; RET
;  947: 
;  948: ; -------------------------------------
;  949: ; Display a progress bar
;  950: def dsp_pbar(l_progress,l_total,l_filler)
C0128:					; dsp_pbar()
					; l_progress = 2
					; l_total = 4
					; l_filler = 6
;  951: 	word l_size
					; l_size = 8
;  952: 	if l_progress == 0
	JSR	INTERP
	DB	$58,$0A,$03		; ENTER	10,3
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0130,>C0130	; BRFLS	C0130
;  953: 		l_size = 40
	DB	$2A,$28			; CB	40
	DB	$76,$08			; SLW	8
;  954: 	elsif l_progress >= l_total
	DB	$50,<C0131,>C0131	; JUMP	C0131
C0130:
	DB	$66,$02			; LLW	2
	DB	$66,$04			; LLW	4
	DB	$48			; ISGE
	DB	$4C,<C0132,>C0132	; BRFLS	C0132
;  955: 		l_size = 40
	DB	$2A,$28			; CB	40
	DB	$76,$08			; SLW	8
;  956: 	else
	DB	$50,<C0131,>C0131	; JUMP	C0131
C0132:
;  957: 		l_size = 40 * l_progress / l_total
	DB	$2A,$28			; CB	40
	DB	$66,$02			; LLW	2
	DB	$06			; MUL
	DB	$66,$04			; LLW	4
	DB	$08			; DIV
	DB	$76,$08			; SLW	8
;  958: 	fin
C0131:
;  959: 	dsp_fill(0,22,l_size,l_filler)
	DB	$00			; ZERO
	DB	$2A,$16			; CB	22
	DB	$66,$08			; LLW	8
	DB	$66,$06			; LLW	6
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
;  960: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
;  961: 
;  962: ; -------------------------------------
;  963: ; Page away animation
;  964: ; scroll each line of the text screen 
;  965: ; with a constant acceleration
;  966: ; leaving a blank screen at the end
;  967: ; using assembly because native plasma is not fast enough to move bytes
;  968: asm dsp_page_away(l_ptr)
C0133:					; dsp_page_away()
					; l_ptr = 2
;  969: 			LDY   #$02
	LDA	#4
	STA	FRMSZ
	LDA	#1
	STA	NPARMS
	JSR	_ENTER
			LDY   #$02
;  970: 			LDA   (FP),Y
			LDA   (FP),Y
;  971: 			STA   txtscr1+1
			STA   txtscr1+1
;  972: 			STA   txtscr2+1
			STA   txtscr2+1
;  973: 			INY
			INY
;  974: 			LDA   (FP),Y
			LDA   (FP),Y
;  975: 			STA   txtscr1+2
			STA   txtscr1+2
;  976: 			STA   txtscr2+2
			STA   txtscr2+2
;  977: 			TXA
			TXA
;  978: 			PHA
			PHA
;  979: 
;  980: ;Initialize how to handle the sync on vbl
;  981: ;IIe vbl is low
;  982: 			LDA	#128
			LDA	#128
;  983: 			STA	l_vbleor
			STA	l_vbleor
;  984: 			SEC
			SEC
;  985: 			JSR	$FE1F
			JSR	$FE1F
;  986: 			BCC	vblhigh
			BCC	vblhigh
;  987: 			LDA	$FBC0
			LDA	$FBC0
;  988: 			BNE	start
			BNE	start
;  989: vblhigh:
vblhigh:
;  990: ;//c, IIc+ and IIgs vbl are high
;  991: 			LDA	#0
			LDA	#0
;  992: 			STA	l_vbleor
			STA	l_vbleor
;  993: 			BEQ	start
			BEQ	start
;  994: 
;  995: ;local asm variable			
;  996: l_speed:	DS		24
l_speed:	DS		24
;  997: l_line: 	DB		0 
l_line: 	DB		0 
;  998: l_line_spd: DB	0
l_line_spd: DB	0
;  999: l_column: DB	0
l_column: DB	0
; 1000: i:			DB		0
i:			DB		0
; 1001: j:			DB		0
j:			DB		0
; 1002: ll:		DB		0
ll:		DB		0
; 1003: l_vbleor: DB   0
l_vbleor: DB   0
; 1004: 			
; 1005: start:
start:
; 1006: ;we don't want interrupts during the animation
; 1007: ;especially on the //c and IIc+ where the internal isr
; 1008: ;is reseting the vbl preventing any sync by polling
; 1009: 			SEI
			SEI
; 1010: 			CLD
			CLD
; 1011: 			LDA	#0
			LDA	#0
; 1012: 			LDY	#23
			LDY	#23
; 1013: 
; 1014: ;init starting speed for each line			
; 1015: bl1:		STA	l_speed,Y
bl1:		STA	l_speed,Y
; 1016: 			DEY
			DEY
; 1017: 			BPL	bl1
			BPL	bl1
; 1018: 			
; 1019: 			LDA	#1			
			LDA	#1			
; 1020: 			STA	l_line
			STA	l_line
; 1021: 
; 1022: 			LDA	#34
			LDA	#34
; 1023: 			STA	ll
			STA	ll
; 1024: 			
; 1025: ;for ll = 1 to 34
; 1026: bl2:		LDA	#0
bl2:		LDA	#0
; 1027: 			STA	i
			STA	i
; 1028: 			
; 1029: ;sync on VBL on each frame to keep an average constant speed
; 1030: ;we doesn't care to do a very clean sync as we want only to keep 
; 1031: ;the same animation speed whatever is the cpu speed
; 1032: 			LDA	$FBC0
			LDA	$FBC0
; 1033: 			BNE	no2c1
			BNE	no2c1
; 1034: 			STA	$C07F
			STA	$C07F
; 1035: 			STA	$C05B ;enable //c and IIc+ vbl int, even if we are only polling
			STA	$C05B ;enable //c and IIc+ vbl int, even if we are only polling
; 1036: 			STA	$C07E
			STA	$C07E
; 1037: 			BEQ	no2c1
			BEQ	no2c1
; 1038: vblloop:
vblloop:
; 1039: 			STA	$C030	; why not listening to the nice orchestra of the sync ? prrirrruirrrirrr
			STA	$C030	; why not listening to the nice orchestra of the sync ? prrirrruirrrirrr
; 1040: 						; ok, it was only to be sure we are looping on the vbl during tests
; 1041: no2c1:
no2c1:
; 1042: 			LDA	$C019
			LDA	$C019
; 1043: 			EOR	l_vbleor
			EOR	l_vbleor
; 1044: 			BPL	vblloop
			BPL	vblloop
; 1045: 			
; 1046: 			LDA	$FBC0
			LDA	$FBC0
; 1047: 			BNE	no2c2
			BNE	no2c2
; 1048: 			STA	$C07F
			STA	$C07F
; 1049: 			STA	$C05A ;disable //c and IIc+ vbl int
			STA	$C05A ;disable //c and IIc+ vbl int
; 1050: 			STA	$C07E
			STA	$C07E
; 1051: no2c2:
no2c2:
; 1052: ;end of the vbl sync
; 1053: 
; 1054: ;for i = 0 to 23			
; 1055: bl3:
bl3:
; 1056: 
; 1057: 			LDY	i
			LDY	i
; 1058: 			CPY	#24
			CPY	#24
; 1059: 			BCS	el3
			BCS	el3
; 1060: 			LDX	l_speed,Y
			LDX	l_speed,Y
; 1061: 			CPY	l_line ;increase speed of line above l_line only
			CPY	l_line ;increase speed of line above l_line only
; 1062: 			BCS	j1
			BCS	j1
; 1063: 			CPX	#6	;keep the speed at 6 bytes per frame max
			CPX	#6	;keep the speed at 6 bytes per frame max
; 1064: 			BCS	j1
			BCS	j1
; 1065: 			INX			;increase the speed of the current line
			INX			;increase the speed of the current line
; 1066: j1:		TXA
j1:		TXA
; 1067: 			STA	l_speed,Y
			STA	l_speed,Y
; 1068: 			LSR
			LSR
; 1069: 			STA	l_line_spd
			STA	l_line_spd
; 1070: 			
; 1071: ;compute pointers for the current line			
; 1072: 			TYA
			TYA
; 1073: 			ASL
			ASL
; 1074: 			TAX
			TAX
; 1075: txtscr1:	LDA	$FFFF,X
txtscr1:	LDA	$FFFF,X
; 1076: 			STA	l_era+1
			STA	l_era+1
; 1077: 			STA	l_dst+1
			STA	l_dst+1
; 1078: 			INX
			INX
; 1079: txtscr2:	LDA	$FFFF,X
txtscr2:	LDA	$FFFF,X
; 1080: 			STA	l_era+2
			STA	l_era+2
; 1081: 			STA	l_dst+2
			STA	l_dst+2
; 1082: 			
; 1083: 			CLC
			CLC
; 1084: 			LDA	l_line_spd
			LDA	l_line_spd
; 1085: 			ADC	l_dst+1
			ADC	l_dst+1
; 1086: 			STA	l_src+1
			STA	l_src+1
; 1087: 			LDA	#0
			LDA	#0
; 1088: 			ADC	l_dst+2
			ADC	l_dst+2
; 1089: 			STA	l_src+2
			STA	l_src+2
; 1090: 
; 1091: ;scroll the content of the current line
; 1092: 			SEC
			SEC
; 1093: 			LDA	#39
			LDA	#39
; 1094: 			SBC	l_line_spd
			SBC	l_line_spd
; 1095: 			STA	l_column
			STA	l_column
; 1096: 			LDY	#255
			LDY	#255
; 1097: bl4:		INY
bl4:		INY
; 1098: l_src:	LDA	$FFFF,Y
l_src:	LDA	$FFFF,Y
; 1099: l_dst:	STA	$FFFF,Y
l_dst:	STA	$FFFF,Y
; 1100: 			CPY	l_column
			CPY	l_column
; 1101: 			BNE	bl4
			BNE	bl4
; 1102: ;erase the end of the line
; 1103: 			LDA	#$A0
			LDA	#$A0
; 1104: 			BNE	sl5	
			BNE	sl5	
; 1105: bl5:		INY
bl5:		INY
; 1106: l_era:	STA	$FFFF,Y
l_era:	STA	$FFFF,Y
; 1107: sl5:		CPY	#39
sl5:		CPY	#39
; 1108: 			BNE	bl5
			BNE	bl5
; 1109: 			INC	i
			INC	i
; 1110: 			JMP	bl3
			JMP	bl3
; 1111: 
; 1112: el3:		LDX	l_line
el3:		LDX	l_line
; 1113: 			CPX	#24
			CPX	#24
; 1114: 			BCS	j3
			BCS	j3
; 1115: 			INX
			INX
; 1116: 			STX	l_line
			STX	l_line
; 1117: j3:
j3:
; 1118: 			DEC	ll
			DEC	ll
; 1119: 			BEQ	el2
			BEQ	el2
; 1120: 			JMP	bl2
			JMP	bl2
; 1121: el2:
el2:
; 1122: 			CLI
			CLI
; 1123: 			PLA
			PLA
; 1124: 			TAX
			TAX
; 1125: end
	JSR	_PUSHYA
	JMP	_LEAVE
; 1126: 
; 1127: ; -------------------------------------
; 1128: ; Page away animation
; 1129: ; the source code is very nicer than the asm version :)
; 1130: defn dsp_page_away0()
C0135:					; dsp_page_away0()
; 1131: 	home()
	JSR	C0008
	INX
	INX
; 1132: end
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	RTS
; 1133: ;	byte l_speed[24]
; 1134: ;	byte l_line
; 1135: ;	byte l_line_speed
; 1136: ;	byte i
; 1137: ;	byte j
; 1138: ;	byte l
; 1139: ;
; 1140: ;	word lp_ptr
; 1141: ;	for i = 0 to 23
; 1142: ;		l_speed[i]=0
; 1143: ;	next
; 1144: ;	l_line = 0
; 1145: ;
; 1146: ;	for l = 1 to 34
; 1147: ;	
; 1148: ;		;scroll each line of the screen
; 1149: ;		;accordingly to relative speed
; 1150: ;		for i = 0 to 23
; 1151: ;			
; 1152: ;			;update the speed of the current line
; 1153: ;			if i < l_line
; 1154: ;				if l_speed[i]<=5
; 1155: ;					l_speed[i] = l_speed[i] + 1
; 1156: ;				fin
; 1157: ;			fin
; 1158: ;			
; 1159: ;			;scroll the current line
; 1160: ;			lp_ptr = txtscrn[i]
; 1161: ;			l_line_speed = l_speed[i] 
; 1162: ;			for j = l_line_speed to 39
; 1163: ;				^(lp_ptr+j-l_line_speed) = ^(lp_ptr+j)
; 1164: ;			next
; 1165: ;			
; 1166: ;			;erase the reminder of the current line
; 1167: ;			if l_line_speed > 0 			
; 1168: ;				for j = 39-l_line_speed to 39
; 1169: ;					^(lp_ptr+j) = $A0
; 1170: ;				next
; 1171: ;			fin
; 1172: ;			
; 1173: ;		next
; 1174: ;	
; 1175: ;		;allow acceleration of following line
; 1176: ;		;for the deformation effect
; 1177: ;		if l_line < 24
; 1178: ;			l_line = l_line + 1
; 1179: ;		fin
; 1180: ;		
; 1181: ;	next
; 1182: ;	
; 1183: ;end
; 1184: 
; 1185: ; =====================================
; 1186: ; Fields routines
; 1187: 
; 1188: ; -------------------------------------
; 1189: ; Display a field
; 1190: deft fld_display(l_field)
C0137:					; fld_display()
					; l_field = 2
; 1191: 	byte l_len
					; l_len = 4
; 1192: 	byte l_chr
					; l_chr = 5
; 1193: 	word lp_ptr
					; lp_ptr = 6
; 1194: 	if (fields_y).[l_field] < c_fld_max_y and (fields_x).[l_field] < c_fld_max_x
	LDA	#8
	STA	FRMSZ
	LDA	#1
	STA	NPARMS
	JSR	_ENTER
	LDA	D1721
	LDY	D1721+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXB
	JSR	LB
	LDA	#$18
	LDY	#$00
	JSR	_PUSHYA
	JSR	ISLT
	LDA	D1719
	LDY	D1719+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXB
	JSR	LB
	LDA	#$28
	LDY	#$00
	JSR	_PUSHYA
	JSR	ISLT
	JSR	LAND
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0139
:
; 1195: 		if l_field == fields_selected
	LDY	#$02
	JSR	_LLW
	LDA	D1717
	LDY	#$00
	JSR	_PUSHYA
	JSR	ISEQ
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0141
:
; 1196: 			g_dsp_flag = 63
	LDA	#$3F
	LDY	#$00
;	_PUSHYA		JSR	_PULLA
	STA	D3790
; 1197: 		fin
C0141:
C0142:
; 1198: 		lp_ptr = (fields_l):[l_field]
	LDA	D1723
	LDY	D1723+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXW
	JSR	LW
	LDY	#$06
	JSR	_SLW
; 1199: 		l_len = ^lp_ptr 
	LDY	#$06
	JSR	_LLW
	JSR	LB
	LDY	#$04
	JSR	_SLB
; 1200: 		if l_len + (fields_x).[l_field] >= c_fld_max_x
	LDY	#$04
	JSR	_LLB
	LDA	D1719
	LDY	D1719+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXB
	JSR	LB
	JSR	ADD
	LDA	#$28
	LDY	#$00
	JSR	_PUSHYA
	JSR	ISGE
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0143
:
; 1201: 			^lp_ptr = c_fld_max_x - (fields_x).[l_field]
	LDY	#$06
	JSR	_LLW
	LDA	#$28
	LDY	#$00
	JSR	_PUSHYA
	LDA	D1719
	LDY	D1719+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXB
	JSR	LB
	JSR	SUB
	JSR	SB
; 1202: 		fin
C0143:
C0144:
; 1203: 		dsp_print((fields_x).[l_field],(fields_y).[l_field],(fields_l):[l_field])
	LDA	D1719
	LDY	D1719+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXB
	JSR	LB
	LDA	D1721
	LDY	D1721+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXB
	JSR	LB
	LDA	D1723
	LDY	D1723+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXW
	JSR	LW
	JSR	C0098
	INX				; DROP
	INX
; 1204: 		^lp_ptr = l_len 
	LDY	#$06
	JSR	_LLW
	LDY	#$04
	JSR	_LLB
	JSR	SB
; 1205: 		g_dsp_flag = 255
	LDA	#$FF
	LDY	#$00
;	_PUSHYA		JSR	_PULLA
	STA	D3790
; 1206: 	fin
C0139:
C0140:
; 1207: end
	LDA	#$00
	TAY
	JSR	_PUSHYA
	JMP	_LEAVE
; 1208: 
; 1209: ; -------------------------------------
; 1210: ; Select a field
; 1211: def fld_select(l_field)
C0145:					; fld_select()
					; l_field = 2
; 1212: 		byte fprev
					; fprev = 4
; 1213: 		fprev = fields_selected 		
	JSR	INTERP
	DB	$58,$05,$01		; ENTER	5,1
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$74,$04			; SLB	4
; 1214: 		fields_selected = l_field
	DB	$66,$02			; LLW	2
	DB	$78,<D1717,>D1717	; SAB	D1717
; 1215: 		if fprev <> 255
	DB	$64,$04			; LLB	4
	DB	$2A,$FF			; CB	255
	DB	$42			; ISNE
	DB	$4C,<C0147,>C0147	; BRFLS	C0147
; 1216: 			fld_display(fprev)
	DB	$64,$04			; LLB	4
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1217: 		fin
C0147:
C0148:
; 1218: 		fld_display(l_field)
	DB	$66,$02			; LLW	2
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1219: 		fields_last[fields_page_selected] = fields_selected 
	DB	$26,<D1727,>D1727	; LAA	D1727
	DB	$68,<D1718,>D1718	; LAB	D1718
	DB	$2E			; IDXB
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$70			; SB
; 1220: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1221: 
; 1222: ; -------------------------------------
; 1223: ; Disable a field and remove it from the screen
; 1224: def fld_disable(l_field,l_char)
C0149:					; fld_disable()
					; l_field = 2
					; l_char = 4
; 1225: 	byte i
					; i = 6
; 1226: 	byte l
					; l = 7
; 1227: 	if (fields_y).[l_field] < c_fld_max_y and (fields_x).[l_field] < c_fld_max_x
	JSR	INTERP
	DB	$58,$08,$02		; ENTER	8,2
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$2A,$18			; CB	24
	DB	$46			; ISLT
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$2A,$28			; CB	40
	DB	$46			; ISLT
	DB	$24			; LAND
	DB	$4C,<C0151,>C0151	; BRFLS	C0151
; 1228: 		if l_field == fields_selected
	DB	$66,$02			; LLW	2
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$40			; ISEQ
	DB	$4C,<C0153,>C0153	; BRFLS	C0153
; 1229: 			fields_selected = 0
	DB	$00			; ZERO
	DB	$78,<D1717,>D1717	; SAB	D1717
; 1230: 		fin
C0153:
C0154:
; 1231: 		l = ^((fields_l):[l_field])
	DB	$6A,<D1723,>D1723	; LAW	D1723
	DB	$66,$02			; LLW	2
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$60			; LB
	DB	$74,$07			; SLB	7
; 1232: 		dsp_fill( (fields_x).[l_field], (fields_y).[l_field], l, l_char)
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$07			; LLB	7
	DB	$66,$04			; LLW	4
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 1233: 	fin
C0151:
C0152:
; 1234: 	(fields_y).[l_field] = (fields_y).[l_field] ? 128
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$2A,$80			; CB	128
	DB	$16			; IOR
	DB	$70			; SB
; 1235: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1236: 
; 1237: ; -------------------------------------
; 1238: ; Enable a field and display it to the screen
; 1239: def fld_enable(l_field)
C0155:					; fld_enable()
					; l_field = 2
; 1240: 	(fields_y).[l_field] = (fields_y).[l_field] & 127
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$2A,$7F			; CB	127
	DB	$14			; BAND
	DB	$70			; SB
; 1241: 	fld_display(l_field)
	DB	$66,$02			; LLW	2
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1242: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1243: 
; 1244: ; -------------------------------------
; 1245: ; Select the specified page
; 1246: def fld_page(l_page,l_field)
C0157:					; fld_page()
					; l_page = 2
					; l_field = 4
; 1247: 	fields_x = fields_pages_x:[l_page]
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$26,<D1693,>D1693	; LAA	D1693
	DB	$66,$02			; LLW	2
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$7A,<D1719,>D1719	; SAW	D1719
; 1248: 	fields_y = fields_pages_y:[l_page]
	DB	$26,<D1699,>D1699	; LAA	D1699
	DB	$66,$02			; LLW	2
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$7A,<D1721,>D1721	; SAW	D1721
; 1249: 	fields_l = fields_pages_l:[l_page]
	DB	$26,<D1705,>D1705	; LAA	D1705
	DB	$66,$02			; LLW	2
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$7A,<D1723,>D1723	; SAW	D1723
; 1250: 	fields_s = fields_pages_s:[l_page]
	DB	$26,<D1711,>D1711	; LAA	D1711
	DB	$66,$02			; LLW	2
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$7A,<D1725,>D1725	; SAW	D1725
; 1251: 	fields_count = fields_pages_c[l_page]
	DB	$26,<D1690,>D1690	; LAA	D1690
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$78,<D1730,>D1730	; SAB	D1730
; 1252: 	fields_page_selected = l_page
	DB	$66,$02			; LLW	2
	DB	$78,<D1718,>D1718	; SAB	D1718
; 1253: 	fields_selected = l_field
	DB	$66,$04			; LLW	4
	DB	$78,<D1717,>D1717	; SAB	D1717
; 1254: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1255: 
; 1256: ; -------------------------------------
; 1257: ; Get the field previously selected for a page if possible
; 1258: def fld_last(l_page,l_field)
C0159:					; fld_last()
					; l_page = 2
					; l_field = 4
; 1259: 	byte i
					; i = 6
; 1260: 	i = fields_last[l_page]
	JSR	INTERP
	DB	$58,$07,$02		; ENTER	7,2
	DB	$26,<D1727,>D1727	; LAA	D1727
	DB	$66,$02			; LLW	2
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$74,$06			; SLB	6
; 1261: 	if i == 255
	DB	$64,$06			; LLB	6
	DB	$2A,$FF			; CB	255
	DB	$40			; ISEQ
	DB	$4C,<C0161,>C0161	; BRFLS	C0161
; 1262: 		i = l_field
	DB	$66,$04			; LLW	4
	DB	$74,$06			; SLB	6
; 1263: 	fin
C0161:
C0162:
; 1264: 	return  i
	DB	$64,$06			; LLB	6
	DB	$5A			; LEAVE
; 1265: end
; 1266: 
; 1267: ; -------------------------------------
; 1268: ; Display a state field
; 1269: deft fld_display_state(l_field)
C0163:					; fld_display_state()
					; l_field = 2
; 1270: 	word lp_ptr
					; lp_ptr = 4
; 1271: 	byte l_devnum
					; l_devnum = 6
; 1272: ;	byte l_field_boot
; 1273: 	l_devnum = l_field + 1 - c_fld_vdsta
	LDA	#7
	STA	FRMSZ
	LDA	#1
	STA	NPARMS
	JSR	_ENTER
	LDY	#$02
	JSR	_LLW
	LDA	#$01
	LDY	#$00
	JSR	_PUSHYA
	JSR	ADD
	LDA	#$04
	LDY	#$00
	JSR	_PUSHYA
	JSR	SUB
	LDY	#$06
	JSR	_SLB
; 1274: ;	l_field_boot = l_field - c_fld_vdsta + c_fld_vdboot
; 1275: 	if l_devnum <= c_max_device
	LDY	#$06
	JSR	_LLB
	LDA	#$0A
	LDY	#$00
	JSR	_PUSHYA
	JSR	ISLE
	JSR	_PULLYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0165
:
; 1276: 		lp_ptr = dat_dcb_pointer(l_devnum)
	LDY	#$06
	JSR	_LLB
	JSR	C0040
	LDY	#$04
	JSR	_SLW
; 1277: 		case ^lp_ptr & 3
	LDY	#$04
	JSR	_LLW
	JSR	LB
	LDA	#$03
	LDY	#$00
	JSR	_PUSHYA
	JSR	BAND
; 1278: 			of 1
	LDA	#$01
	LDY	#$00
;	_PUSHYA		JSR	_PULLYA
	CMP	ESTKL,X
	BNE	:+
	TYA
	CMP	ESTKH,X
	BEQ	:++
:	JMP	C0168
:
; 1279: 				(fields_l):[l_field] = @label_unmounted
	LDA	D1723
	LDY	D1723+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXW
	LDA	#<D1000
	LDY	#>D1000
	JSR	_PUSHYA
	JSR	SW
; 1280: ;				fld_disable(l_field_boot,'.')
; 1281: 			of 2
	JMP	C0167
C0168:
	LDA	#$02
	LDY	#$00
;	_PUSHYA		JSR	_PULLYA
	CMP	ESTKL,X
	BNE	:+
	TYA
	CMP	ESTKH,X
	BEQ	:++
:	JMP	C0169
:
; 1282: 				(fields_l):[l_field] = @label_ro
	LDA	D1723
	LDY	D1723+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXW
	LDA	#<D1003
	LDY	#>D1003
	JSR	_PUSHYA
	JSR	SW
; 1283: ;				fld_enable(l_field_boot)
; 1284: 			of 3
	JMP	C0167
C0169:
	LDA	#$03
	LDY	#$00
;	_PUSHYA		JSR	_PULLYA
	CMP	ESTKL,X
	BNE	:+
	TYA
	CMP	ESTKH,X
	BEQ	:++
:	JMP	C0170
:
; 1285: 				(fields_l):[l_field] = @label_rw
	LDA	D1723
	LDY	D1723+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXW
	LDA	#<D1006
	LDY	#>D1006
	JSR	_PUSHYA
	JSR	SW
; 1286: ;				fld_enable(l_field_boot)
; 1287: 			otherwise
	JMP	C0167
C0170:
; 1288: 				(fields_l):[l_field] = @label_disabled
	LDA	D1723
	LDY	D1723+1
	JSR	_PUSHYA
	LDY	#$02
	JSR	_LLW
	JSR	IDXW
	LDA	#<D0997
	LDY	#>D0997
	JSR	_PUSHYA
	JSR	SW
; 1289: ;				fld_disable(l_field_boot,'.')
; 1290: 		shut
C0167:
	INX				; DROP
	INX
; 1291: 		fld_display(l_field)
	LDY	#$02
	JSR	_LLW
	JSR	C0137
	INX				; DROP
	INX
; 1292: 	fin
C0165:
C0166:
; 1293: end
	LDA	#$00
	TAY
	JSR	_PUSHYA
	JMP	_LEAVE
; 1294: 
; 1295: ; -------------------------------------
; 1296: ; Compute absolute delta between two bytes
; 1297: defn fld_delta(a,b)
C0172:					; fld_delta()
					; a = 2
					; b = 4
; 1298: 	if a > b
	LDA	#6
	STA	FRMSZ
	LDA	#2
	STA	NPARMS
	JSR	_ENTER
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	LDY	ESTKH-4,X
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0174
:
; 1299: 		return a - b
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	LDY	ESTKH-4,X
	EOR	#$FF
	SEC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	EOR	#$FF
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1300: 	fin
C0174:
C0175:
; 1301: 	return b - a 
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	LDY	ESTKH-4,X
	EOR	#$FF
	SEC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	EOR	#$FF
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1302: end
; 1303: 
; 1304: ; -------------------------------------
; 1305: ; Compute distance weight between the current fields and another one
; 1306: defn fld_distance(i)
C0176:					; fld_distance()
					; i = 2
; 1307: 	byte d1
					; d1 = 4
; 1308: 	byte d2
					; d2 = 5
; 1309: 	d1 = fld_delta((fields_x).[fields_selected],(fields_x).[i])
	LDA	#6
	STA	FRMSZ
	LDA	#1
	STA	NPARMS
	JSR	_ENTER
	LDA	D1719
	LDY	D1719+1
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	D1717
	LDY	#$00
	STY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	D1719
	LDY	D1719+1
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	TXA
	PHA
	SEC
	SBC	#4
	TAX
	JSR	C0172
	PLA
	TAX
	LDA	ESTKL-2,X
	LDY	#$04
	STA	(FP),Y
; 1310: 	d2 = fld_delta((fields_y).[fields_selected],(fields_y).[i])
	LDA	D1721
	LDY	D1721+1
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	D1717
	LDY	#$00
	STY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	D1721
	LDY	D1721+1
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	TXA
	PHA
	SEC
	SBC	#4
	TAX
	JSR	C0172
	PLA
	TAX
	LDA	ESTKL-2,X
	LDY	#$05
	STA	(FP),Y
; 1311: 	; fields on the same axes are privileged
; 1312: 	if d1 == 0
	LDY	#$04
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0178
:
; 1313: 		return d2 >> 1
	LDY	#$05
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$01
	LDY	#$00
	TAY
	BEQ	:++
	LDA	ESTKH-2,X
:	CMP	#$80
	ROR
	ROR	ESTKL-2,X
	DEY
	BNE	:-
	STA	ESTKH-2,X
:
	DEX
	DEX
	JMP	_LEAVE
; 1314: 	elsif d2 == 0
	JMP	C0179
C0178:
	LDY	#$05
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0180
:
; 1315: 		return d1 >> 1
	LDY	#$04
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$01
	LDY	#$00
	TAY
	BEQ	:++
	LDA	ESTKH-2,X
:	CMP	#$80
	ROR
	ROR	ESTKL-2,X
	DEY
	BNE	:-
	STA	ESTKH-2,X
:
	DEX
	DEX
	JMP	_LEAVE
; 1316: 	fin
C0180:
C0179:
; 1317: 	return d1 + d2
	LDY	#$04
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$05
	LDA	(FP),Y
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1318: end
; 1319: 
; 1320: ; -------------------------------------
; 1321: ; Check if a field can receive focus
; 1322: defn fld_check(i)
C0181:					; fld_check()
					; i = 2
; 1323: 	if	i <> fields_selected and (fields_y).[i] < c_fld_max_y and (fields_x).[i] < c_fld_max_x
	LDA	#4
	STA	FRMSZ
	LDA	#1
	STA	NPARMS
	JSR	_ENTER
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	D1717
	LDY	#$00
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	D1721
	LDY	D1721+1
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-6,X
	LDA	(FP),Y
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$18
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDY	#$00
	LDA	ESTKL-4,X
	CMP	ESTKL-6,X
	LDA	ESTKH-4,X
	SBC	ESTKH-6,X
	BPL	:+
	DEY
:	TYA
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	D1719
	LDY	D1719+1
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-8,X
	LDA	(FP),Y
	CLC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	LDA	ESTKH-8,X
	ADC	ESTKH-6,X
	STA	ESTKH-6,X
	LDA	(ESTK-6,X)
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDA	#$28
	LDY	#$00
	STA	ESTKL-8,X
	STY	ESTKH-8,X
	LDY	#$00
	LDA	ESTKL-6,X
	CMP	ESTKL-8,X
	LDA	ESTKH-6,X
	SBC	ESTKH-8,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BEQ	:+++
:	LDY	#$FF
	LDA	ESTKL-4,X
	BNE	:+
	LDA	ESTKH-4,X
	BNE	:+
	INY
:	TYA
:
	CMP	#$00
	BNE	:+
	CPY	#$00
	BEQ	:+++
:	LDY	#$FF
	LDA	ESTKL-2,X
	BNE	:+
	LDA	ESTKH-2,X
	BNE	:+
	INY
:	TYA
:
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0183
:
; 1324: 		return 1
	LDA	#$01
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1325: 	fin
C0183:
C0184:
; 1326: 	return 0
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1327: end
; 1328: 
; 1329: ; -------------------------------------
; 1330: ; Manage fields shorcuts
; 1331: defn fld_shorcuts()
C0185:					; fld_shorcuts()
; 1332: 	byte i
					; i = 2
; 1333: 	if g_key <> $8D
	LDA	#3
	STA	FRMSZ
	LDA	#0
	STA	NPARMS
	JSR	_ENTER
	LDA	D0049
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$8D
	LDY	#$00
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0187
:
; 1334: 		g_key = g_key & 127
	LDA	D0049
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$7F
	LDY	#$00
	AND	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	AND	ESTKH-2,X
	TAY
	LDA	ESTKL-2,X
	STA	D0049
; 1335: 		for i = 0 to fields_count-1
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
C0190:
	LDA	ESTKL-2,X
	LDY	#$02
	STA	(FP),Y
	LDA	D1730
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	EOR	#$FF
	ADC	ESTKH-4,X
	TAY
	LDA	ESTKL-4,X
	CMP	ESTKL-2,X
	TYA
	SBC	ESTKH-2,X
	BPL	:+
	JMP	C0189
:
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:
; 1336: 			if (fields_s).[i] == g_key
	LDA	D1725
	LDY	D1725+1
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	D0049
	LDY	#$00
	CMP	ESTKL-4,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-4,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0191
:
; 1337: 				; select the field
; 1338: 				fld_select(i)
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	TXA
	PHA
	SEC
	SBC	#4
	TAX
	JSR	C0145
	PLA
	TAX
; 1339: 				; and execute its action
; 1340: 				g_key = $8D
	LDA	#$8D
	LDY	#$00
	STA	D0049
; 1341: 				return
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1342: 			fin
C0191:
C0192:
; 1343: 		next
	JMP	C0190
C0189:
; 1344: 		g_key = g_key ? 128
	LDA	D0049
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$80
	LDY	#$00
	ORA	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ORA	ESTKH-2,X
	TAY
	LDA	ESTKL-2,X
	STA	D0049
; 1345: 	fin
C0187:
C0188:
; 1346: 	return
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1347: end
; 1348: ; -------------------------------------
; 1349: ; Manage fields navigation
; 1350: def fld_navigation()
C0193:					; fld_navigation()
; 1351: 	byte x
					; x = 2
; 1352: 	byte y
					; y = 3
; 1353: 	byte dw
					; dw = 4
; 1354: 	byte dwnext
					; dwnext = 5
; 1355: 	byte fnext
					; fnext = 6
; 1356: 	byte i
					; i = 7
; 1357: 	byte check
					; check = 8
; 1358: 	
; 1359: 	x = (fields_x).[fields_selected]
	JSR	INTERP
	DB	$58,$09,$00		; ENTER	9,0
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$74,$02			; SLB	2
; 1360: 	y = (fields_y).[fields_selected]
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$74,$03			; SLB	3
; 1361: 	dwnext = 255
	DB	$2A,$FF			; CB	255
	DB	$74,$05			; SLB	5
; 1362: 	fnext = 255
	DB	$2A,$FF			; CB	255
	DB	$74,$06			; SLB	6
; 1363: 	if g_key == keyarrowup and y == 0
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8B			; CB	139
	DB	$40			; ISEQ
	DB	$64,$03			; LLB	3
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$4C,<C0195,>C0195	; BRFLS	C0195
; 1364: 		return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1365: 	fin
C0195:
C0196:
; 1366: 	if g_key == keyarrowleft and x == 0
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$88			; CB	136
	DB	$40			; ISEQ
	DB	$64,$02			; LLB	2
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$4C,<C0197,>C0197	; BRFLS	C0197
; 1367: 		return
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1368: 	fin
C0197:
C0198:
; 1369: 
; 1370: 	for i = 0 to fields_count-1
	DB	$00			; ZERO
C0200:
	DB	$6C,$07			; DLB	7
	DB	$68,<D1730,>D1730	; LAB	D1730
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$3A,<C0199,>C0199	; BRGT	C0199
	DB	$0C			; INCR
; 1371: 		if fld_check(i)==1
	DB	$64,$07			; LLB	7
	DB	$54,<C0181,>C0181	; CALL	C0181
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0201,>C0201	; BRFLS	C0201
; 1372: 			check = 0
	DB	$00			; ZERO
	DB	$74,$08			; SLB	8
; 1373: 			case g_key
	DB	$68,<D0049,>D0049	; LAB	D0049
; 1374: 				of keyarrowup
	DB	$2A,$8B			; CB	139
	DB	$3E,<C0204,>C0204	; BRNE	C0204
; 1375: 					; locate the closest fields going upward
; 1376: 					if (fields_y).[i] < y
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$64,$07			; LLB	7
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$03			; LLB	3
	DB	$46			; ISLT
	DB	$4C,<C0205,>C0205	; BRFLS	C0205
; 1377: 						check = 1
	DB	$2A,$01			; CB	1
	DB	$74,$08			; SLB	8
; 1378: 					fin
C0205:
C0206:
; 1379: 				of keyarrowdown
	DB	$50,<C0203,>C0203	; JUMP	C0203
C0204:
	DB	$2A,$8A			; CB	138
	DB	$3E,<C0207,>C0207	; BRNE	C0207
; 1380: 					; locate the closest fields going downward
; 1381: 					if (fields_y).[i] > y 
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$64,$07			; LLB	7
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$03			; LLB	3
	DB	$44			; ISGT
	DB	$4C,<C0208,>C0208	; BRFLS	C0208
; 1382: 						check = 1
	DB	$2A,$01			; CB	1
	DB	$74,$08			; SLB	8
; 1383: 					fin
C0208:
C0209:
; 1384: 				of keyarrowleft
	DB	$50,<C0203,>C0203	; JUMP	C0203
C0207:
	DB	$2A,$88			; CB	136
	DB	$3E,<C0210,>C0210	; BRNE	C0210
; 1385: 					; locate the closest fields going to the left
; 1386: 					if (fields_x).[i] < x 
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$64,$07			; LLB	7
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$02			; LLB	2
	DB	$46			; ISLT
	DB	$4C,<C0211,>C0211	; BRFLS	C0211
; 1387: 						check = 2
	DB	$2A,$02			; CB	2
	DB	$74,$08			; SLB	8
; 1388: 					fin
C0211:
C0212:
; 1389: 				of keyarrowright
	DB	$50,<C0203,>C0203	; JUMP	C0203
C0210:
	DB	$2A,$95			; CB	149
	DB	$3E,<C0213,>C0213	; BRNE	C0213
; 1390: 					; locate the closest fields going to the right
; 1391: 					if (fields_x).[i] > x 
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$64,$07			; LLB	7
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$02			; LLB	2
	DB	$44			; ISGT
	DB	$4C,<C0214,>C0214	; BRFLS	C0214
; 1392: 						check = 2
	DB	$2A,$02			; CB	2
	DB	$74,$08			; SLB	8
; 1393: 					fin
C0214:
C0215:
; 1394: 			shut
	DB	$50,<C0203,>C0203	; JUMP	C0203
C0213:
C0203:
	DB	$30			; DROP
; 1395: 			if check <> 0
	DB	$64,$08			; LLB	8
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0217,>C0217	; BRFLS	C0217
; 1396: 				dw = fld_distance(i)
	DB	$64,$07			; LLB	7
	DB	$54,<C0176,>C0176	; CALL	C0176
	DB	$74,$04			; SLB	4
; 1397: 				if dw < dwnext
	DB	$64,$04			; LLB	4
	DB	$64,$05			; LLB	5
	DB	$46			; ISLT
	DB	$4C,<C0219,>C0219	; BRFLS	C0219
; 1398: 					dwnext = dw
	DB	$64,$04			; LLB	4
	DB	$74,$05			; SLB	5
; 1399: 					fnext = i
	DB	$64,$07			; LLB	7
	DB	$74,$06			; SLB	6
; 1400: 				elsif dw == dwnext
	DB	$50,<C0220,>C0220	; JUMP	C0220
C0219:
	DB	$64,$04			; LLB	4
	DB	$64,$05			; LLB	5
	DB	$40			; ISEQ
	DB	$4C,<C0221,>C0221	; BRFLS	C0221
; 1401: 					case check
	DB	$64,$08			; LLB	8
; 1402: 						of 1
	DB	$2A,$01			; CB	1
	DB	$3E,<C0223,>C0223	; BRNE	C0223
; 1403: 							if fld_delta((fields_x).[i],x) < fld_delta((fields_x).[fnext],x)
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$64,$07			; LLB	7
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$02			; LLB	2
	DB	$54,<C0172,>C0172	; CALL	C0172
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$64,$06			; LLB	6
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$02			; LLB	2
	DB	$54,<C0172,>C0172	; CALL	C0172
	DB	$46			; ISLT
	DB	$4C,<C0224,>C0224	; BRFLS	C0224
; 1404: 								fnext = i
	DB	$64,$07			; LLB	7
	DB	$74,$06			; SLB	6
; 1405: 							fin
C0224:
C0225:
; 1406: 						of 2
	DB	$50,<C0222,>C0222	; JUMP	C0222
C0223:
	DB	$2A,$02			; CB	2
	DB	$3E,<C0226,>C0226	; BRNE	C0226
; 1407: 							if fld_delta((fields_y).[i],y) < fld_delta((fields_y).[fnext],y)
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$64,$07			; LLB	7
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$03			; LLB	3
	DB	$54,<C0172,>C0172	; CALL	C0172
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$64,$06			; LLB	6
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$64,$03			; LLB	3
	DB	$54,<C0172,>C0172	; CALL	C0172
	DB	$46			; ISLT
	DB	$4C,<C0227,>C0227	; BRFLS	C0227
; 1408: 								fnext = i
	DB	$64,$07			; LLB	7
	DB	$74,$06			; SLB	6
; 1409: 							fin
C0227:
C0228:
; 1410: 					shut
	DB	$50,<C0222,>C0222	; JUMP	C0222
C0226:
C0222:
	DB	$30			; DROP
; 1411: 				fin
C0221:
C0220:
; 1412: 			fin
C0217:
C0218:
; 1413: 		fin
C0201:
C0202:
; 1414: 	next
	DB	$50,<C0200,>C0200	; JUMP	C0200
C0199:
	DB	$30			; DROP
; 1415: 		
; 1416: 	if fnext <> 255
	DB	$64,$06			; LLB	6
	DB	$2A,$FF			; CB	255
	DB	$42			; ISNE
	DB	$4C,<C0230,>C0230	; BRFLS	C0230
; 1417: 		fld_select(fnext)
	DB	$64,$06			; LLB	6
	DB	$54,<C0145,>C0145	; CALL	C0145
	DB	$30			; DROP
; 1418: 	fin
C0230:
C0231:
; 1419: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1420: 
; 1421: ; -------------------------------------
; 1422: ; Display date and time on the rtc page
; 1423: def fld_date_time()
C0232:					; fld_date_time()
; 1424: 	byte j
					; j = 2
; 1425: 	j = 0
	JSR	INTERP
	DB	$58,$03,$00		; ENTER	3,0
	DB	$00			; ZERO
	DB	$74,$02			; SLB	2
; 1426: 	dat_check_date()
	DB	$54,<C0086,>C0086	; CALL	C0086
	DB	$30			; DROP
; 1427: 	dat_bin2dec(g_day,@label_day+1)
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$26,<D1033,>D1033	; LAA	D1033
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$54,<C0074,>C0074	; CALL	C0074
	DB	$30			; DROP
; 1428: 	if g_month < 12
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$0C			; CB	12
	DB	$46			; ISLT
	DB	$4C,<C0234,>C0234	; BRFLS	C0234
; 1429: 		memcpy(@months+1+g_month*3,@label_month+1,3)
	DB	$26,<D1083,>D1083	; LAA	D1083
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$03			; CB	3
	DB	$06			; MUL
	DB	$02			; ADD
	DB	$26,<D1036,>D1036	; LAA	D1036
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$2A,$03			; CB	3
	DB	$54,<C0003,>C0003	; CALL	C0003
	DB	$30			; DROP
; 1430: 	fin
C0234:
C0235:
; 1431: 	j = 20
	DB	$2A,$14			; CB	20
	DB	$74,$02			; SLB	2
; 1432: 	if g_year >= 40
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$28			; CB	40
	DB	$48			; ISGE
	DB	$4C,<C0236,>C0236	; BRFLS	C0236
; 1433: 		j = 19
	DB	$2A,$13			; CB	19
	DB	$74,$02			; SLB	2
; 1434: 	fin
C0236:
C0237:
; 1435: 	dat_bin2dec(j,@label_year+1)
	DB	$64,$02			; LLB	2
	DB	$26,<D1040,>D1040	; LAA	D1040
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$54,<C0074,>C0074	; CALL	C0074
	DB	$30			; DROP
; 1436: 	dat_bin2dec(g_year,@label_year+3)		
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$26,<D1040,>D1040	; LAA	D1040
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$54,<C0074,>C0074	; CALL	C0074
	DB	$30			; DROP
; 1437: 	dat_bin2dec(g_hour,@label_hour+1)
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$26,<D1045,>D1045	; LAA	D1045
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$54,<C0074,>C0074	; CALL	C0074
	DB	$30			; DROP
; 1438: 	dat_bin2dec(g_minute,@label_minute+1)
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$26,<D1048,>D1048	; LAA	D1048
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$54,<C0074,>C0074	; CALL	C0074
	DB	$30			; DROP
; 1439: 	
; 1440: 	fld_display(c_fld_day)
	DB	$2A,$01			; CB	1
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1441: 	fld_display(c_fld_month)
	DB	$2A,$02			; CB	2
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1442: 	fld_display(c_fld_year)
	DB	$2A,$03			; CB	3
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1443: 	fld_display(c_fld_hour)
	DB	$2A,$04			; CB	4
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1444: 	fld_display(c_fld_minute)
	DB	$2A,$05			; CB	5
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1445: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1446: 
; 1447: ; -------------------------------------
; 1448: ; Initialize field manager
; 1449: def fld_init()
C0238:					; fld_init()
; 1450: 	byte i;
					; i = 2
; 1451: 	for i = 0 to c_fld_page_max-1
	JSR	INTERP
	DB	$58,$03,$00		; ENTER	3,0
	DB	$00			; ZERO
C0241:
	DB	$6C,$02			; DLB	2
	DB	$2A,$03			; CB	3
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$3A,<C0240,>C0240	; BRGT	C0240
	DB	$0C			; INCR
; 1452: 		fields_last[i] = 255
	DB	$26,<D1727,>D1727	; LAA	D1727
	DB	$64,$02			; LLB	2
	DB	$2E			; IDXB
	DB	$2A,$FF			; CB	255
	DB	$70			; SB
; 1453: 	next
	DB	$50,<C0241,>C0241	; JUMP	C0241
C0240:
	DB	$30			; DROP
; 1454: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1455: 
; 1456: ; =====================================
; 1457: ; Clock routines
; 1458: 
; 1459: ; Clock driver for Prodos 8 before beeing patched
; 1460: ; small is beautifull ;-)
; 1461: asm clock_driver()
C0242:					; clock_driver()
; 1462: 	JSR 0
	JSR 0
; 1463: 	DB 0	;status command
	DB 0	;status command
; 1464: 	DW 0	;pointer to parameter list
	DW 0	;pointer to parameter list
; 1465: 	RTS
	RTS
; 1466: ;parameter list
; 1467: 	DB 3 	;parameter count
	DB 3 	;parameter count
; 1468: 	DB 0	;spvhd id
	DB 0	;spvhd id
; 1469: 	DW $BF90 ;destination buffer pointer
	DW $BF90 ;destination buffer pointer
; 1470: 	DB 10 ;clock request
	DB 10 ;clock request
; 1471: end
	JSR	_PUSHYA
	RTS
; 1472: 
; 1473: ;Copy the data into Prodos 8 memory driver area
; 1474: asm clock_driver_copy()
C0244:					; clock_driver_copy()
; 1475: 	PHA
	PHA
; 1476: 	TXA
	TXA
; 1477: 	PHA
	PHA
; 1478: 	TYA
	TYA
; 1479: 	PHA
	PHA
; 1480: 	LDY $3E
	LDY $3E
; 1481: 	LDA $C08B
	LDA $C08B
; 1482: 	LDA $C08B
	LDA $C08B
; 1483: l:
l:
; 1484: 	LDA ($3C),Y
	LDA ($3C),Y
; 1485: 	STA ($42),Y
	STA ($42),Y
; 1486: 	DEY
	DEY
; 1487: 	BPL l
	BPL l
; 1488: 	
; 1489: 	LDA $C082
	LDA $C082
; 1490: 	PLA
	PLA
; 1491: 	TAY
	TAY
; 1492: 	PLA
	PLA
; 1493: 	TAX
	TAX
; 1494: 	PLA
	PLA
; 1495: end
	JSR	_PUSHYA
	RTS
; 1496: 
; 1497: ; Patch the clock driver and install it
; 1498: ; don't work in threaded or native mode
; 1499: ; as only pcode mode is able to address
; 1500: ; code namespace curently
; 1501: def clock_driver_install()
C0246:					; clock_driver_install()
; 1502: 	word location
					; location = 2
; 1503: 	if ^c_pdos_vectclk == $60
	JSR	INTERP
	DB	$58,$04,$00		; ENTER	4,0
	DB	$2C,$06,$BF		; CW	48902
	DB	$60			; LB
	DB	$2A,$60			; CB	96
	DB	$40			; ISEQ
	DB	$4C,<C0248,>C0248	; BRFLS	C0248
; 1504: 		; relocate the driver code
; 1505: 		location = *(c_pdos_vectclk+1)
	DB	$2C,$06,$BF		; CW	48902
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$62			; LW
	DB	$76,$02			; SLW	2
; 1506: 		clock_driver:1 = g_spep
	DB	$26,<C0242,>C0242	; LAA	C0242
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$72			; SW
; 1507: 		clock_driver:4 = location+7
	DB	$26,<C0242,>C0242	; LAA	C0242
	DB	$2A,$04			; CB	4
	DB	$02			; ADD
	DB	$66,$02			; LLW	2
	DB	$2A,$07			; CB	7
	DB	$02			; ADD
	DB	$72			; SW
; 1508: 		clock_driver.8 = g_spvhdid
	DB	$26,<C0242,>C0242	; LAA	C0242
	DB	$2A,$08			; CB	8
	DB	$02			; ADD
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$70			; SB
; 1509: 		; copy it over the Prodos clock driver
; 1510: 		*($3C) = @clock_driver
	DB	$2A,$3C			; CB	60
	DB	$26,<C0242,>C0242	; LAA	C0242
	DB	$72			; SW
; 1511: 		^($3E) = 15
	DB	$2A,$3E			; CB	62
	DB	$2A,$0F			; CB	15
	DB	$70			; SB
; 1512: 		*($42) = location 
	DB	$2A,$42			; CB	66
	DB	$66,$02			; LLW	2
	DB	$72			; SW
; 1513: 		clock_driver_copy()
	DB	$54,<C0244,>C0244	; CALL	C0244
	DB	$30			; DROP
; 1514: 		; activate the clock
; 1515: 		;^c_pdos_machid = ^c_pdos_machid ? 1
; 1516: 		^c_pdos_vectclk = $4C	
	DB	$2C,$06,$BF		; CW	48902
	DB	$2A,$4C			; CB	76
	DB	$70			; SB
; 1517: 	fin
C0248:
C0249:
; 1518: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1519: 
; 1520: ; =====================================
; 1521: ; Smartport routines
; 1522: 
; 1523: ; -------------------------------------
; 1524: ; Smartport driver call
; 1525: asm sp_call(l_spe, l_spcmd, l_spprm)
C0250:					; sp_call()
					; l_spe = 2
					; l_spcmd = 4
					; l_spprm = 6
; 1526: 	LDY     #$02
	LDA	#8
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDY     #$02
; 1527: 	LDA     (FP),Y
	LDA     (FP),Y
; 1528: 	STA     SPEP2
	STA     SPEP2
; 1529: 	INY
	INY
; 1530: 	LDA     (FP),Y
	LDA     (FP),Y
; 1531: 	STA     SPEP2+1
	STA     SPEP2+1
; 1532: 	INY
	INY
; 1533: 	LDA     (FP),Y
	LDA     (FP),Y
; 1534: 	STA     SPCMD2
	STA     SPCMD2
; 1535: 	INY
	INY
; 1536: 	INY
	INY
; 1537: 	LDA     (FP),Y
	LDA     (FP),Y
; 1538: 	STA     SPPRM2
	STA     SPPRM2
; 1539: 	INY
	INY
; 1540: 	LDA     (FP),Y
	LDA     (FP),Y
; 1541: 	STA     SPPRM2+1
	STA     SPPRM2+1
; 1542: 	TXA
	TXA
; 1543: 	PHA
	PHA
; 1544: 	DB	$20
	DB	$20
; 1545: SPEP2:	DW	0000
SPEP2:	DW	0000
; 1546: SPCMD2:	DB	00
SPCMD2:	DB	00
; 1547: SPPRM2:	DW	0000
SPPRM2:	DW	0000
; 1548: 	PHP
	PHP
; 1549: 	STA	  sp_call_regs
	STA	  sp_call_regs
; 1550: 	STX	  sp_call_regs+1
	STX	  sp_call_regs+1
; 1551: 	STY	  sp_call_regs+2
	STY	  sp_call_regs+2
; 1552: 	PLA
	PLA
; 1553: 	STA	  sp_call_regs+3
	STA	  sp_call_regs+3
; 1554: 	JMP	  sp_call_end
	JMP	  sp_call_end
; 1555: sp_call_regs:
sp_call_regs:
; 1556: 	DB		  $00
	DB		  $00
; 1557: 	DB		  $00
	DB		  $00
; 1558: 	DB		  $00
	DB		  $00
; 1559: 	DB		  $00
	DB		  $00
; 1560: sp_call_end:
sp_call_end:
; 1561: 	PLA
	PLA
; 1562: 	TAX
	TAX
; 1563: 	LDA     #<sp_call_regs
	LDA     #<sp_call_regs
; 1564: 	LDY     #>sp_call_regs
	LDY     #>sp_call_regs
; 1565: ;	STA     ESTKL,X
; 1566: ;	STY     ESTKH,X
; 1567: end
	JSR	_PUSHYA
	JMP	_LEAVE
; 1568: 
; 1569: ; -------------------------------------
; 1570: ; Send status or control commands
; 1571: ; id smartportid of the target resident
; 1572: ; cmd  either sp_cmd_status or sp_cmd_ctrl
; 1573: ; code either sp_status, sp_dcb, sp_dib, or spvhd_*
; 1574: ; buffer pointer to the buffer for smartport data
; 1575: ; g_spsize is filled with the size of transfered data
; 1576: ; Return error code, 0 when no error
; 1577: def sp_util(l_id,l_cmd,l_code,l_buffer)
C0252:					; sp_util()
					; l_id = 2
					; l_cmd = 4
					; l_code = 6
					; l_buffer = 8
; 1578: 	word l_rs
					; l_rs = 10
; 1579: 	byte l_params[5]
					; l_params = 12
; 1580: 	if l_id <> 255 and g_spep <> 0
	JSR	INTERP
	DB	$58,$11,$04		; ENTER	17,4
	DB	$66,$02			; LLW	2
	DB	$2A,$FF			; CB	255
	DB	$42			; ISNE
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$24			; LAND
	DB	$4C,<C0254,>C0254	; BRFLS	C0254
; 1581: 		l_params.c_sp_prmcnt = 3
	DB	$28,$0C			; LLA	12
	DB	$2A,$03			; CB	3
	DB	$70			; SB
; 1582: 		l_params.c_sp_id = l_id
	DB	$28,$0D			; LLA	13
	DB	$66,$02			; LLW	2
	DB	$70			; SB
; 1583: 		l_params:c_sp_buffer = l_buffer
	DB	$28,$0E			; LLA	14
	DB	$66,$08			; LLW	8
	DB	$72			; SW
; 1584: 		l_params.c_sp_code = l_code
	DB	$28,$10			; LLA	16
	DB	$66,$06			; LLW	6
	DB	$70			; SB
; 1585: 		l_rs = sp_call(g_spep, l_cmd, @l_params)
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$66,$04			; LLW	4
	DB	$28,$0C			; LLA	12
	DB	$54,<C0250,>C0250	; CALL	C0250
	DB	$76,$0A			; SLW	10
; 1586: 		;g_spsize = ^($3D) ? (^($3E)<<8)
; 1587: 		;return ^($3C) ;return error code
; 1588: 		;A=error code
; 1589: 		;X=lsb of transfered size
; 1590: 		;Y=msb of transfered size
; 1591: 		g_spsize = (l_rs).xreg ? (((l_rs).yreg)<<8)
	DB	$66,$0A			; LLW	10
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$66,$0A			; LLW	10
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$08			; CB	8
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$7A,<D0053,>D0053	; SAW	D0053
; 1592: 		return (l_rs).areg ;return error code
	DB	$66,$0A			; LLW	10
	DB	$60			; LB
	DB	$5A			; LEAVE
; 1593: 	fin
C0254:
C0255:
; 1594: 	return 255
	DB	$2A,$FF			; CB	255
	DB	$5A			; LEAVE
; 1595: end
; 1596: 
; 1597: ; -------------------------------------
; 1598: ; Init the whole smartport chain
; 1599: ; Return error code, 0 when no error
; 1600: def sp_init()
C0256:					; sp_init()
; 1601: 	word l_rs
					; l_rs = 2
; 1602: 	byte l_params[2]
					; l_params = 4
; 1603: 	if g_spep <> 0
	JSR	INTERP
	DB	$58,$06,$00		; ENTER	6,0
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0258,>C0258	; BRFLS	C0258
; 1604: 		l_params.c_sp_prmcnt = 1
	DB	$28,$04			; LLA	4
	DB	$2A,$01			; CB	1
	DB	$70			; SB
; 1605: 		l_params.c_sp_id = 0
	DB	$28,$05			; LLA	5
	DB	$00			; ZERO
	DB	$70			; SB
; 1606: 		l_rs = sp_call(g_spep, c_sp_cmd_init, @l_params)
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$2A,$05			; CB	5
	DB	$28,$04			; LLA	4
	DB	$54,<C0250,>C0250	; CALL	C0250
	DB	$76,$02			; SLW	2
; 1607: 		return ^(l_rs);
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$5A			; LEAVE
; 1608: 		;return ^($3C) ;return error code
; 1609: 	fin
C0258:
C0259:
; 1610: 	return 255
	DB	$2A,$FF			; CB	255
	DB	$5A			; LEAVE
; 1611: end
; 1612: 
; 1613: ; -------------------------------------
; 1614: ; Ask number of devices on the current smartport interface
; 1615: ; return the number of smartport resident
; 1616: def sp_device_count()
C0260:					; sp_device_count()
; 1617: 	byte l_buffer[8]
					; l_buffer = 2
; 1618: 	byte l_rc
					; l_rc = 10
; 1619: 	l_buffer.0 = 0
	JSR	INTERP
	DB	$58,$0B,$00		; ENTER	11,0
	DB	$28,$02			; LLA	2
	DB	$00			; ZERO
	DB	$70			; SB
; 1620: 	g_sperr = sp_util(0, c_sp_cmd_status, c_sp_sta_sta, @l_buffer)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$28,$02			; LLA	2
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1621: 	return l_buffer[0]
	DB	$28,$02			; LLA	2
	DB	$00			; ZERO
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$5A			; LEAVE
; 1622: end
; 1623: 
; 1624: ; -------------------------------------
; 1625: ; Get the device information block from a resident
; 1626: def sp_get_dib(l_id)
C0262:					; sp_get_dib()
					; l_id = 2
; 1627: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_sp_sta_dib, @g_spt_buf)
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$03			; CB	3
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1628: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0264,>C0264	; BRFLS	C0264
; 1629: 		dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1630: 		memset(0, @g_spt_buf, 25)
	DB	$00			; ZERO
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$19			; CB	25
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
; 1631: 	fin
C0264:
C0265:
; 1632: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1633: 
; 1634: ; -------------------------------------
; 1635: ; Get the device control block from a resident
; 1636: def sp_get_dcb(l_id)
C0266:					; sp_get_dcb()
					; l_id = 2
; 1637: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_sp_sta_dcb, @g_spt_buf)
	JSR	INTERP
	DB	$58,$04,$01		; ENTER	4,1
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$01			; CB	1
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1638: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0268,>C0268	; BRFLS	C0268
; 1639: 		dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1640: 		memset(0, @g_spt_buf, 32)
	DB	$00			; ZERO
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$20			; CB	32
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
; 1641: 	fin
C0268:
C0269:
; 1642: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1643: 
; 1644: ; =====================================
; 1645: ; SmartportVHD routines
; 1646: 
; 1647: ; -------------------------------------
; 1648: ; Get the date
; 1649: def spvhd_get_date(l_id,lp_date)
C0270:					; spvhd_get_date()
					; l_id = 2
					; lp_date = 4
; 1650: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_spvhd_date, lp_date)
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$0A			; CB	10
	DB	$66,$04			; LLW	4
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1651: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0272,>C0272	; BRFLS	C0272
; 1652: 		;dsp_err()
; 1653: 		memset(0,lp_date,4)
	DB	$00			; ZERO
	DB	$66,$04			; LLW	4
	DB	$2A,$04			; CB	4
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
; 1654: 	fin
C0272:
C0273:
; 1655: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1656: 
; 1657: ; -------------------------------------
; 1658: ; Set the date
; 1659: def spvhd_set_date(l_id,lp_date)
C0274:					; spvhd_set_date()
					; l_id = 2
					; lp_date = 4
; 1660: 	g_spt_buf:0 = 4
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$26,<(D3278+0),>(D3278+0)	; LAA	D3278+0
	DB	$2A,$04			; CB	4
	DB	$72			; SW
; 1661: 	memcpy(lp_date, @g_spt_buf+2, 4)
	DB	$66,$04			; LLW	4
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$2A,$04			; CB	4
	DB	$54,<C0003,>C0003	; CALL	C0003
	DB	$30			; DROP
; 1662: 	g_sperr = sp_util(l_id, c_sp_cmd_control, c_spvhd_date, @g_spt_buf)
	DB	$66,$02			; LLW	2
	DB	$2A,$04			; CB	4
	DB	$2A,$0A			; CB	10
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1663: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0276,>C0276	; BRFLS	C0276
; 1664: 		dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1665: 	fin
C0276:
C0277:
; 1666: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1667: 
; 1668: ; -------------------------------------
; 1669: ; Start repository exploration
; 1670: def spvhd_explore(l_id,lp_path)
C0278:					; spvhd_explore()
					; l_id = 2
					; lp_path = 4
; 1671: 	strcpy(lp_path,@g_spt_buf+2);
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$66,$04			; LLW	4
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$54,<C0026,>C0026	; CALL	C0026
	DB	$30			; DROP
; 1672: 	g_spt_buf.0 = g_spt_buf.2 + 1
	DB	$26,<(D3278+0),>(D3278+0)	; LAA	D3278+0
	DB	$26,<(D3278+2),>(D3278+2)	; LAA	D3278+2
	DB	$60			; LB
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$70			; SB
; 1673: 	g_spt_buf.1 = 0
	DB	$26,<(D3278+1),>(D3278+1)	; LAA	D3278+1
	DB	$00			; ZERO
	DB	$70			; SB
; 1674: 	g_sperr = sp_util(l_id, c_sp_cmd_control, c_spvhd_explore, @g_spt_buf)
	DB	$66,$02			; LLW	2
	DB	$2A,$04			; CB	4
	DB	$2A,$0B			; CB	11
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1675: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0280,>C0280	; BRFLS	C0280
; 1676: 		dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1677: 	fin
C0280:
C0281:
; 1678: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1679: 
; 1680: ; -------------------------------------
; 1681: ; Get information about the next file
; 1682: ; in the current exploration
; 1683: defn spvhd_nextfile(l_id,lp_name,lp_size)
C0282:					; spvhd_nextfile()
					; l_id = 2
					; lp_name = 4
					; lp_size = 6
; 1684: 	byte i
					; i = 8
; 1685: 	g_sperr = sp_util(l_id, c_sp_cmd_status, c_spvhd_nextfile, @g_spt_buf)
	LDA	#9
	STA	FRMSZ
	LDA	#3
	STA	NPARMS
	JSR	_ENTER
	LDY	#$03
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$0C
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDA	#<D3278
	LDY	#>D3278
	STA	ESTKL-8,X
	STY	ESTKH-8,X
	TXA
	PHA
	SEC
	SBC	#8
	TAX
	JSR	C0252
	PLA
	TAX
	LDA	ESTKL-2,X
	STA	D0055
; 1686: 	if g_sperr == 0
	LDA	D0055
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0284
:
; 1687: 		if lp_name <> 0
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0286
:
; 1688: 			; copy the filename
; 1689: 			i = 0
	LDA	#$00
	TAY
	LDY	#$08
	STA	(FP),Y
; 1690: 			;usage of g_spt_buf.[4] instead of g_sp_buf.4 is required for threaded and native code
; 1691: 			if g_spt_buf.[4] & $10 <> 0
	LDA	#<D3278
	LDY	#>D3278
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$04
	LDY	#$00
	STY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$10
	LDY	#$00
	AND	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	AND	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0288
:
; 1692: 				;this is a directory
; 1693: 				i = 1
	LDA	#$01
	LDY	#$00
	LDY	#$08
	STA	(FP),Y
; 1694: 			fin
C0288:
C0289:
; 1695: 			strcpy(@g_spt_buf+5, lp_name+i)
	LDA	#<D3278
	LDY	#>D3278
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$05
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	TXA
	PHA
	SEC
	SBC	#4
	TAX
	JSR	C0026
	PLA
	TAX
; 1696: 			if i <> 0
	LDY	#$08
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0290
:
; 1697: 				;add pathname separator at the start of the folder name
; 1698: 				^lp_name = (lp_name).1 + 1
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	LDA	ESTKL-4,X
	STA	(ESTK-2,X)
; 1699: 				(lp_name).1 = $2F
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDA	#$2F
	LDY	#$00
	STA	(ESTK-2,X)
; 1700: 			fin
C0290:
C0291:
; 1701: 		fin
C0286:
C0287:
; 1702: 		if lp_size <> 0
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0292
:
; 1703: 			; copy the file size in ascii format
; 1704: 			^lp_size = 10
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$0A
	LDY	#$00
	STA	(ESTK-2,X)
; 1705: 			memcpy(@g_spt_buf+ 6 + g_spt_buf.[5], lp_size+1, 10)
	LDA	#<D3278
	LDY	#>D3278
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$06
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDA	#<D3278
	LDY	#>D3278
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$05
	LDY	#$00
	STY	ESTKH-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	STY	ESTKH-2,X
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDA	#$0A
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0003
	PLA
	TAX
; 1706: 		fin
C0292:
C0293:
; 1707: 	else
	JMP	C0285
C0284:
; 1708: 		dsp_err2()
	JSR	C0120
	INX
	INX
; 1709: 		memset(0, @g_spt_buf, 32)
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#<D3278
	LDY	#>D3278
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$20
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0002
	PLA
	TAX
; 1710: 		if lp_name <> 0
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0294
:
; 1711: 			^lp_name = 0
	LDY	#$05
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	STA	(ESTK-2,X)
; 1712: 		fin
C0294:
C0295:
; 1713: 		if lp_size <> 0
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$00
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$FF
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0296
:
; 1714: 			memset($2020, lp_size + 1, 10)
	LDA	#$20
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-4,X
	LDA	(FP),Y
	STA	ESTKL-4,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDA	#$0A
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0002
	PLA
	TAX
; 1715: 			^lp_size = 10
	LDY	#$07
	LDA	(FP),Y
	DEY
	STA	ESTKH-2,X
	LDA	(FP),Y
	STA	ESTKL-2,X
	LDA	#$0A
	LDY	#$00
	STA	(ESTK-2,X)
; 1716: 		fin
C0296:
C0297:
; 1717: 	fin
C0285:
; 1718: end
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 1719: 
; 1720: ; -------------------------------------
; 1721: ; Select a virtual device, from 1 to 10
; 1722: def spvhd_sel_vd(l_id,l_devnum)
C0298:					; spvhd_sel_vd()
					; l_id = 2
					; l_devnum = 4
; 1723: 	g_spt_buf:0 = 1
	JSR	INTERP
	DB	$58,$06,$02		; ENTER	6,2
	DB	$26,<(D3278+0),>(D3278+0)	; LAA	D3278+0
	DB	$2A,$01			; CB	1
	DB	$72			; SW
; 1724: 	g_spt_buf.2 = l_devnum
	DB	$26,<(D3278+2),>(D3278+2)	; LAA	D3278+2
	DB	$66,$04			; LLW	4
	DB	$70			; SB
; 1725: 	g_sperr = sp_util(l_id, c_sp_cmd_control, c_spvhd_parmsel, @g_spt_buf)
	DB	$66,$02			; LLW	2
	DB	$2A,$04			; CB	4
	DB	$2A,$0D			; CB	13
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1726: 	if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0300,>C0300	; BRFLS	C0300
; 1727: 		dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1728: 	fin
C0300:
C0301:
; 1729: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1730: 
; 1731: ; -------------------------------------
; 1732: ; Get parameters for a virtual device
; 1733: ; to the configuration file in memory
; 1734: def spvhd_get_parm(l_id,l_devnum)
C0302:					; spvhd_get_parm()
					; l_id = 2
					; l_devnum = 4
; 1735: 	word l_ptr
					; l_ptr = 6
; 1736: 	spvhd_sel_vd(l_id,l_devnum)
	JSR	INTERP
	DB	$58,$08,$02		; ENTER	8,2
	DB	$66,$02			; LLW	2
	DB	$66,$04			; LLW	4
	DB	$54,<C0298,>C0298	; CALL	C0298
	DB	$30			; DROP
; 1737: 	if g_sperr == 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0304,>C0304	; BRFLS	C0304
; 1738: 		l_ptr = dat_dcb_pointer(l_devnum)
	DB	$66,$04			; LLW	4
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$76,$06			; SLW	6
; 1739: 		g_sperr = sp_util(l_id, c_sp_cmd_status, c_spvhd_parmboot, l_ptr)
	DB	$66,$02			; LLW	2
	DB	$00			; ZERO
	DB	$2A,$0E			; CB	14
	DB	$66,$06			; LLW	6
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1740: 		if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0306,>C0306	; BRFLS	C0306
; 1741: 			dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1742: 			memset(0,l_ptr,32)
	DB	$00			; ZERO
	DB	$66,$06			; LLW	6
	DB	$2A,$20			; CB	32
	DB	$54,<C0002,>C0002	; CALL	C0002
	DB	$30			; DROP
; 1743: 		fin
C0306:
C0307:
; 1744: 	fin
C0304:
C0305:
; 1745: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1746: 
; 1747: ; -------------------------------------
; 1748: ; Set parameters for a virtual device
; 1749: ; from the configuration file in memory
; 1750: def spvhd_set_parm(l_id,l_devnum)
C0308:					; spvhd_set_parm()
					; l_id = 2
					; l_devnum = 4
; 1751: 	word l_ptr
					; l_ptr = 6
; 1752: 	spvhd_sel_vd(l_id,l_devnum)
	JSR	INTERP
	DB	$58,$08,$02		; ENTER	8,2
	DB	$66,$02			; LLW	2
	DB	$66,$04			; LLW	4
	DB	$54,<C0298,>C0298	; CALL	C0298
	DB	$30			; DROP
; 1753: 	if g_sperr == 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0310,>C0310	; BRFLS	C0310
; 1754: 		;send the configuration data
; 1755: 		l_ptr = dat_dcb_pointer(l_devnum)
	DB	$66,$04			; LLW	4
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$76,$06			; SLW	6
; 1756: 		;set the full length of the data
; 1757: 		g_spt_buf:0 = (l_ptr).1 + 2
	DB	$26,<(D3278+0),>(D3278+0)	; LAA	D3278+0
	DB	$66,$06			; LLW	6
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$72			; SW
; 1758: 		; copy the data
; 1759: 		memcpy(l_ptr, @g_spt_buf+2, g_spt_buf:0)
	DB	$66,$06			; LLW	6
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$26,<(D3278+0),>(D3278+0)	; LAA	D3278+0
	DB	$62			; LW
	DB	$54,<C0003,>C0003	; CALL	C0003
	DB	$30			; DROP
; 1760: 		g_sperr = sp_util(l_id, c_sp_cmd_control, c_spvhd_parmboot, @g_spt_buf)
	DB	$66,$02			; LLW	2
	DB	$2A,$04			; CB	4
	DB	$2A,$0E			; CB	14
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1761: 		if g_sperr <> 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0312,>C0312	; BRFLS	C0312
; 1762: 			dsp_err2()
	DB	$54,<C0120,>C0120	; CALL	C0120
	DB	$30			; DROP
; 1763: 		fin
C0312:
C0313:
; 1764: 	fin
C0310:
C0311:
; 1765: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1766: 
; 1767: ; -------------------------------------
; 1768: ; Locate a spvhd connected to a smartport interface
; 1769: ; set g_spvhdid, if no device found g_spvhdid = 255
; 1770: ; return 1 if spvhd located, 0 if not
; 1771: def spvhd_locate_device()
C0314:					; spvhd_locate_device()
; 1772: 	byte l_id
					; l_id = 2
; 1773: 	byte l_rc
					; l_rc = 3
; 1774: 	byte l_count
					; l_count = 4
; 1775: 	
; 1776: 	g_spvhdid = 255
	JSR	INTERP
	DB	$58,$05,$00		; ENTER	5,0
	DB	$2A,$FF			; CB	255
	DB	$78,<D0052,>D0052	; SAB	D0052
; 1777: 	l_rc = 0
	DB	$00			; ZERO
	DB	$74,$03			; SLB	3
; 1778: 	l_id = 1
	DB	$2A,$01			; CB	1
	DB	$74,$02			; SLB	2
; 1779: 	
; 1780: 	l_count = sp_device_count() 
	DB	$54,<C0260,>C0260	; CALL	C0260
	DB	$74,$04			; SLB	4
; 1781: 	prstr(@msg_spdevcount)
	DB	$26,<D0654,>D0654	; LAA	D0654
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1782: 	printeger(l_count)
	DB	$64,$04			; LLB	4
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1783: 	crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 1784: 	prstr(@msg_spdevice)
	DB	$26,<D0673,>D0673	; LAA	D0673
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1785: 
; 1786: 	if l_count > 0
	DB	$64,$04			; LLB	4
	DB	$00			; ZERO
	DB	$44			; ISGT
	DB	$4C,<C0316,>C0316	; BRFLS	C0316
; 1787: 		repeat 
C0319:
; 1788: 		
; 1789: 			printeger(l_id)
	DB	$64,$02			; LLB	2
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1790:          cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1791: 			
; 1792: 			; Get the device control block
; 1793: 			sp_get_dcb(l_id)
	DB	$64,$02			; LLB	2
	DB	$54,<C0266,>C0266	; CALL	C0266
	DB	$30			; DROP
; 1794: 			if g_sperr == 0 and memcmp(@g_spvhd_signature, @g_spt_buf + c_spvhd_signaturesize, 6)==0 		
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$26,<D0057,>D0057	; LAA	D0057
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$05			; CB	5
	DB	$02			; ADD
	DB	$2A,$06			; CB	6
	DB	$54,<C0030,>C0030	; CALL	C0030
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$4C,<C0320,>C0320	; BRFLS	C0320
; 1795: 
; 1796: 				prstr(@msg_spvhdfound)
	DB	$26,<D0685,>D0685	; LAA	D0685
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1797: 				crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 1798: 				
; 1799: 				;extract version information from the dcb
; 1800: 				dat_versiondcb_unpack(@g_spt_buf)
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0096,>C0096	; CALL	C0096
	DB	$30			; DROP
; 1801: 				prstr(@msg_firmware)
	DB	$26,<D0704,>D0704	; LAA	D0704
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1802: 				printeger(g_version_major)
	DB	$68,<D1731,>D1731	; LAB	D1731
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1803: 				cout('.')
	DB	$2A,$2E			; CB	46
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1804: 				printeger(g_version_minor)
	DB	$68,<D1732,>D1732	; LAB	D1732
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1805: 				cout('.')
	DB	$2A,$2E			; CB	46
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1806: 				printeger(g_version_revision)
	DB	$68,<D1733,>D1733	; LAB	D1733
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1807: 	
; 1808: 				l_rc = 1
	DB	$2A,$01			; CB	1
	DB	$74,$03			; SLB	3
; 1809: 				g_spvhdid = l_id
	DB	$64,$02			; LLB	2
	DB	$78,<D0052,>D0052	; SAB	D0052
; 1810: 				l_id = l_count
	DB	$64,$04			; LLB	4
	DB	$74,$02			; SLB	2
; 1811: 			fin
C0320:
C0321:
; 1812: 			
; 1813: 			crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 1814: 			l_id = l_id + 1
	DB	$64,$02			; LLB	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$74,$02			; SLB	2
; 1815: 		until l_id > l_count
	DB	$64,$02			; LLB	2
	DB	$64,$04			; LLB	4
	DB	$44			; ISGT
	DB	$4C,<C0319,>C0319	; BRFLS	C0319
C0318:
; 1816: 	fin
C0316:
C0317:
; 1817: 	
; 1818: 	return l_rc
	DB	$64,$03			; LLB	3
	DB	$5A			; LEAVE
; 1819: end
; 1820: 
; 1821: ; -------------------------------------
; 1822: ; Locate the smartport interface to get the entry point
; 1823: ; then locate the spvhd within the smartport residents
; 1824: ; set g_spep, if no interface found g_spep = 0
; 1825: ; set g_spvhdid, if no device found g_spvhdid = 255
; 1826: def spvhd_locate()
C0322:					; spvhd_locate()
; 1827: 	word l_ptr
					; l_ptr = 2
; 1828: 	word l_slot
					; l_slot = 4
; 1829: 	cout(' ')
	JSR	INTERP
	DB	$58,$06,$00		; ENTER	6,0
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1830: 	cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1831: 	cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1832: 	cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1833: 	prstr(@msg_interfacelocate)
	DB	$26,<D0063,>D0063	; LAA	D0063
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1834: 	crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 1835: 	prstr(@msg_spslot)
	DB	$26,<D0628,>D0628	; LAA	D0628
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1836: 	g_spep = 0
	DB	$00			; ZERO
	DB	$7A,<D0050,>D0050	; SAW	D0050
; 1837: 	
; 1838: 	l_slot = 7
	DB	$2A,$07			; CB	7
	DB	$76,$04			; SLW	4
; 1839: 	repeat
C0325:
; 1840: 	
; 1841: 		l_ptr = $C000 ? (l_slot << 8)
	DB	$2C,$00,$C0		; CW	49152
	DB	$66,$04			; LLW	4
	DB	$2A,$08			; CB	8
	DB	$1A			; SHL
	DB	$16			; IOR
	DB	$76,$02			; SLW	2
; 1842: 
; 1843: 		printeger(l_slot)
	DB	$66,$04			; LLW	4
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1844: 		cout(' ')
	DB	$2A,$20			; CB	32
	DB	$54,<C0004,>C0004	; CALL	C0004
	DB	$30			; DROP
; 1845: 		
; 1846: 		if (l_ptr).1==$20 and (l_ptr).3==$00 and (l_ptr).5==$03 and (l_ptr).7==$00
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$20			; CB	32
	DB	$40			; ISEQ
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$66,$02			; LLW	2
	DB	$2A,$05			; CB	5
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$03			; CB	3
	DB	$40			; ISEQ
	DB	$66,$02			; LLW	2
	DB	$2A,$07			; CB	7
	DB	$02			; ADD
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$24			; LAND
	DB	$24			; LAND
	DB	$4C,<C0326,>C0326	; BRFLS	C0326
; 1847: 			;found a smartport interface
; 1848: 			g_spep = l_ptr + 3 + (l_ptr).255
	DB	$66,$02			; LLW	2
	DB	$2A,$03			; CB	3
	DB	$02			; ADD
	DB	$66,$02			; LLW	2
	DB	$2A,$FF			; CB	255
	DB	$02			; ADD
	DB	$60			; LB
	DB	$02			; ADD
	DB	$7A,<D0050,>D0050	; SAW	D0050
; 1849: 
; 1850: 			prstr(@msg_spep)
	DB	$26,<D0638,>D0638	; LAA	D0638
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 1851: 			prword(g_spep)
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$54,<C0016,>C0016	; CALL	C0016
	DB	$30			; DROP
; 1852: 			crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 1853: 			
; 1854: 			if spvhd_locate_device() <> 0
	DB	$54,<C0314,>C0314	; CALL	C0314
	DB	$00			; ZERO
	DB	$42			; ISNE
	DB	$4C,<C0328,>C0328	; BRFLS	C0328
; 1855: 				l_slot = 1
	DB	$2A,$01			; CB	1
	DB	$76,$04			; SLW	4
; 1856: 			fin
C0328:
C0329:
; 1857: 		fin
C0326:
C0327:
; 1858: 		l_slot = l_slot -1
	DB	$66,$04			; LLW	4
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$76,$04			; SLW	4
; 1859: 	until l_slot == 0
	DB	$66,$04			; LLW	4
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0325,>C0325	; BRFLS	C0325
C0324:
; 1860: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1861: 
; 1862: ; -------------------------------------
; 1863: ; Load the configuration file from the smartportvhd
; 1864: ; use g_spvhdid
; 1865: def spvhd_cfg_load(l_pb)
C0330:					; spvhd_cfg_load()
					; l_pb = 2
; 1866: 	byte l_devnum
					; l_devnum = 4
; 1867: 	byte l_max
					; l_max = 5
; 1868: 	l_max = c_max_device+1
	JSR	INTERP
	DB	$58,$06,$01		; ENTER	6,1
	DB	$2A,$0A			; CB	10
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$74,$05			; SLB	5
; 1869: 	if l_pb == 1
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0332,>C0332	; BRFLS	C0332
; 1870: 		dsp_pbar(0,l_max,'=')
	DB	$00			; ZERO
	DB	$64,$05			; LLB	5
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1871: 		g_dsp_flag = 63
	DB	$2A,$3F			; CB	63
	DB	$78,<D3790,>D3790	; SAB	D3790
; 1872: 		dsp_pbar(1,l_max,'=')
	DB	$2A,$01			; CB	1
	DB	$64,$05			; LLB	5
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1873: 	fin
C0332:
C0333:
; 1874: 	; load the dcb as the first block of parameters
; 1875: 	g_sperr = sp_util(g_spvhdid, c_sp_cmd_status, c_sp_sta_dcb, @g_cfg_file)
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$00			; ZERO
	DB	$2A,$01			; CB	1
	DB	$26,<D1870,>D1870	; LAA	D1870
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1876: 	dsp_err()
	DB	$54,<C0116,>C0116	; CALL	C0116
	DB	$30			; DROP
; 1877: 	for l_devnum = 1 to c_max_device
	DB	$2A,$01			; CB	1
C0335:
	DB	$6C,$04			; DLB	4
	DB	$2A,$0A			; CB	10
	DB	$3A,<C0334,>C0334	; BRGT	C0334
	DB	$0C			; INCR
; 1878: 		if l_pb == 1
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0336,>C0336	; BRFLS	C0336
; 1879: 			dsp_pbar(l_devnum+1,l_max,'=')
	DB	$64,$04			; LLB	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$64,$05			; LLB	5
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1880: 		fin
C0336:
C0337:
; 1881: 		spvhd_get_parm(g_spvhdid, l_devnum)
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$64,$04			; LLB	4
	DB	$54,<C0302,>C0302	; CALL	C0302
	DB	$30			; DROP
; 1882: 		dsp_err()
	DB	$54,<C0116,>C0116	; CALL	C0116
	DB	$30			; DROP
; 1883: 	next
	DB	$50,<C0335,>C0335	; JUMP	C0335
C0334:
	DB	$30			; DROP
; 1884: 	if l_pb == 1
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0338,>C0338	; BRFLS	C0338
; 1885: 		g_dsp_flag = 255
	DB	$2A,$FF			; CB	255
	DB	$78,<D3790,>D3790	; SAB	D3790
; 1886: 		dsp_pbar(0,l_max,'=')
	DB	$00			; ZERO
	DB	$64,$05			; LLB	5
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1887: 	fin
C0338:
C0339:
; 1888: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1889: 
; 1890: ; -------------------------------------
; 1891: ; Save the configuration file to the smartportvhd
; 1892: ; use g_spvhdid
; 1893: def spvhd_cfg_save()
C0340:					; spvhd_cfg_save()
; 1894: 	byte l_devnum
					; l_devnum = 2
; 1895: 	byte l_max
					; l_max = 3
; 1896: 	byte i
					; i = 4
; 1897: 	l_max = c_max_device+1
	JSR	INTERP
	DB	$58,$05,$00		; ENTER	5,0
	DB	$2A,$0A			; CB	10
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$74,$03			; SLB	3
; 1898: 	g_dsp_flag = 63
	DB	$2A,$3F			; CB	63
	DB	$78,<D3790,>D3790	; SAB	D3790
; 1899: 	dsp_pbar(1,l_max,'=')
	DB	$2A,$01			; CB	1
	DB	$64,$03			; LLB	3
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1900: 	; store the dcb as the first block of parameters
; 1901: 	memcpy(@g_cfg_file, @g_spt_buf+2, c_cfg_blksize)
	DB	$26,<D1870,>D1870	; LAA	D1870
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$2A,$02			; CB	2
	DB	$02			; ADD
	DB	$2A,$80			; CB	128
	DB	$54,<C0003,>C0003	; CALL	C0003
	DB	$30			; DROP
; 1902: 	g_spt_buf:0 = c_cfg_blksize
	DB	$26,<(D3278+0),>(D3278+0)	; LAA	D3278+0
	DB	$2A,$80			; CB	128
	DB	$72			; SW
; 1903: 	g_sperr = sp_util(g_spvhdid, c_sp_cmd_control, c_sp_sta_dcb, @g_spt_buf)
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$2A,$04			; CB	4
	DB	$2A,$01			; CB	1
	DB	$26,<D3278,>D3278	; LAA	D3278
	DB	$54,<C0252,>C0252	; CALL	C0252
	DB	$78,<D0055,>D0055	; SAB	D0055
; 1904: 	dsp_err()
	DB	$54,<C0116,>C0116	; CALL	C0116
	DB	$30			; DROP
; 1905: 	for l_devnum = 1 to c_max_device
	DB	$2A,$01			; CB	1
C0343:
	DB	$6C,$02			; DLB	2
	DB	$2A,$0A			; CB	10
	DB	$3A,<C0342,>C0342	; BRGT	C0342
	DB	$0C			; INCR
; 1906: 		dsp_pbar(l_devnum+1,l_max,'=')
	DB	$64,$02			; LLB	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$64,$03			; LLB	3
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1907: 		spvhd_set_parm(g_spvhdid, l_devnum)
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$64,$02			; LLB	2
	DB	$54,<C0308,>C0308	; CALL	C0308
	DB	$30			; DROP
; 1908: 		dsp_err()
	DB	$54,<C0116,>C0116	; CALL	C0116
	DB	$30			; DROP
; 1909: 	next
	DB	$50,<C0343,>C0343	; JUMP	C0343
C0342:
	DB	$30			; DROP
; 1910: 	g_dsp_flag = 255
	DB	$2A,$FF			; CB	255
	DB	$78,<D3790,>D3790	; SAB	D3790
; 1911: 	dsp_pbar(0,l_max,'=')
	DB	$00			; ZERO
	DB	$64,$03			; LLB	3
	DB	$2A,$3D			; CB	61
	DB	$54,<C0128,>C0128	; CALL	C0128
	DB	$30			; DROP
; 1912: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1913: 
; 1914: ; =====================================
; 1915: ; SmartportVHD Manager routines
; 1916: 
; 1917: ; -------------------------------------
; 1918: ; Display virtual device informations
; 1919: ; l_devnum from 1 to c_max_drive
; 1920: def spm_device(l_devnum)
C0344:					; spm_device()
					; l_devnum = 2
; 1921: 	byte y
					; y = 4
; 1922: 	byte i
					; i = 5
; 1923: 	word lp_ptr
					; lp_ptr = 6
; 1924: 	
; 1925: 	; pointer to the dcb for this device
; 1926: 	lp_ptr = dat_dcb_pointer(l_devnum)
	JSR	INTERP
	DB	$58,$08,$01		; ENTER	8,1
	DB	$66,$02			; LLW	2
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$76,$06			; SLW	6
; 1927: 	
; 1928: 	y = l_devnum * 2
	DB	$66,$02			; LLW	2
	DB	$2A,$02			; CB	2
	DB	$06			; MUL
	DB	$74,$04			; SLB	4
; 1929: 	;if l_devnum & 1 ==1
; 1930: 	;	^outmode = $3F
; 1931: 	;	gotoxy(0,y)
; 1932: 	;	cout(' ')
; 1933: 	;	gotoxy(0,y+1)
; 1934: 	;	cout(' ')
; 1935: 	;	^outmode = $FF
; 1936: 	;fin
; 1937: 	
; 1938: 	; display template
; 1939: 	dsp_print(0,y,@msg_mark)
	DB	$00			; ZERO
	DB	$64,$04			; LLB	4
	DB	$26,<D0798,>D0798	; LAA	D0798
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 1940: 	dsp_print(3,y,@msg_drive)
	DB	$2A,$03			; CB	3
	DB	$64,$04			; LLB	4
	DB	$26,<D0783,>D0783	; LAA	D0783
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 1941: 	gotoxy(4 + msg_drive.0,y)
	DB	$2A,$04			; CB	4
	DB	$26,<(D0783+0),>(D0783+0)	; LAA	D0783+0
	DB	$60			; LB
	DB	$02			; ADD
	DB	$64,$04			; LLB	4
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
; 1942: 	printeger(l_devnum)
	DB	$66,$02			; LLW	2
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 1943: 	
; 1944: 	; boot field, display conditionned by the state field
; 1945: 	;i = c_fld_vdboot + l_devnum - 1
; 1946: 	;(fields_x).[i] = 36
; 1947: 	;(fields_y).[i] = y
; 1948: 	;(fields_l):[i] = @label_boot
; 1949: 
; 1950: 	; state field
; 1951: 	i = c_fld_vdsta + l_devnum - 1
	DB	$2A,$04			; CB	4
	DB	$66,$02			; LLW	2
	DB	$02			; ADD
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$05			; SLB	5
; 1952: 	(fields_x).[i] = 0
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$64,$05			; LLB	5
	DB	$2E			; IDXB
	DB	$00			; ZERO
	DB	$70			; SB
; 1953: 	(fields_y).[i] = y+1
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$64,$05			; LLB	5
	DB	$2E			; IDXB
	DB	$64,$04			; LLB	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$70			; SB
; 1954: 	fld_display_state(i)
	DB	$64,$05			; LLB	5
	DB	$54,<C0163,>C0163	; CALL	C0163
	DB	$30			; DROP
; 1955: 
; 1956: 	; pathname field
; 1957: 	i = c_fld_vdpath + l_devnum - 1
	DB	$2A,$0E			; CB	14
	DB	$66,$02			; LLW	2
	DB	$02			; ADD
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$74,$05			; SLB	5
; 1958: 	(fields_x).[i] = 3
	DB	$6A,<D1719,>D1719	; LAW	D1719
	DB	$64,$05			; LLB	5
	DB	$2E			; IDXB
	DB	$2A,$03			; CB	3
	DB	$70			; SB
; 1959: 	(fields_y).[i] = y+1
	DB	$6A,<D1721,>D1721	; LAW	D1721
	DB	$64,$05			; LLB	5
	DB	$2E			; IDXB
	DB	$64,$04			; LLB	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$70			; SB
; 1960: 	if (lp_ptr).c_spvhd_path > 0
	DB	$66,$06			; LLW	6
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$00			; ZERO
	DB	$44			; ISGT
	DB	$4C,<C0346,>C0346	; BRFLS	C0346
; 1961: 		(fields_l):[i] = lp_ptr + c_spvhd_path
	DB	$6A,<D1723,>D1723	; LAW	D1723
	DB	$64,$05			; LLB	5
	DB	$1E			; IDXW
	DB	$66,$06			; LLW	6
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$72			; SW
; 1962: 	else
	DB	$50,<C0347,>C0347	; JUMP	C0347
C0346:
; 1963: 		(fields_l):[i] = @label_select
	DB	$6A,<D1723,>D1723	; LAW	D1723
	DB	$64,$05			; LLB	5
	DB	$1E			; IDXW
	DB	$26,<D1010,>D1010	; LAA	D1010
	DB	$72			; SW
; 1964: 	fin
C0347:
; 1965: 	fld_display(i)
	DB	$64,$05			; LLB	5
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1966: 
; 1967: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1968: 
; 1969: ; -------------------------------------
; 1970: ; Display main screen
; 1971: def spm_main()
C0348:					; spm_main()
; 1972: 	byte i
					; i = 2
; 1973: 	byte j
					; j = 3
; 1974: 	
; 1975: 	fld_page(c_fld_page_main,fld_last(c_fld_page_main,c_fld_vdpath))
	JSR	INTERP
	DB	$58,$04,$00		; ENTER	4,0
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$2A,$0E			; CB	14
	DB	$54,<C0159,>C0159	; CALL	C0159
	DB	$54,<C0157,>C0157	; CALL	C0157
	DB	$30			; DROP
; 1976: 	dsp_print(0,0,@msg_title_main)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$26,<D0773,>D0773	; LAA	D0773
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 1977: 	dsp_fill(0,1,40,'=')
	DB	$00			; ZERO
	DB	$2A,$01			; CB	1
	DB	$2A,$28			; CB	40
	DB	$2A,$3D			; CB	61
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 1978: 	dsp_fill(0,22,40,'=')
	DB	$00			; ZERO
	DB	$2A,$16			; CB	22
	DB	$2A,$28			; CB	40
	DB	$2A,$3D			; CB	61
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 1979: 	dsp_print(0,23,@msg_help)
	DB	$00			; ZERO
	DB	$2A,$17			; CB	23
	DB	$26,<D0733,>D0733	; LAA	D0733
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 1980: 	for i = 1 to c_max_device
	DB	$2A,$01			; CB	1
C0351:
	DB	$6C,$02			; DLB	2
	DB	$2A,$0A			; CB	10
	DB	$3A,<C0350,>C0350	; BRGT	C0350
	DB	$0C			; INCR
; 1981: 		spm_device(i)
	DB	$64,$02			; LLB	2
	DB	$54,<C0344,>C0344	; CALL	C0344
	DB	$30			; DROP
; 1982: 	next
	DB	$50,<C0351,>C0351	; JUMP	C0351
C0350:
	DB	$30			; DROP
; 1983: 	fld_display(c_fld_quit)
	DB	$00			; ZERO
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1984: 	fld_display(c_fld_save)
	DB	$2A,$01			; CB	1
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1985: 	fld_display(c_fld_load)
	DB	$2A,$02			; CB	2
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1986: 	fld_display(c_fld_date)
	DB	$2A,$03			; CB	3
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 1987: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 1988: 
; 1989: ; -------------------------------------
; 1990: ; Display the current pathname of the disk image selector
; 1991: def spm_pathname()
C0352:					; spm_pathname()
; 1992: 	dsp_fill(0,2,40,' ')
	JSR	INTERP
	DB	$00			; ZERO
	DB	$2A,$02			; CB	2
	DB	$2A,$28			; CB	40
	DB	$2A,$20			; CB	32
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 1993: 	dsp_print(0,2,@g_pathname)
	DB	$00			; ZERO
	DB	$2A,$02			; CB	2
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 1994: 	;blank the remaining of the line
; 1995: 	;if g_pathname.0 < 40
; 1996: 	;	dsp_fill(g_pathname.0,2,40-g_pathname.0,' ')
; 1997: 	;fin
; 1998: end
	DB	$00			; ZERO
	DB	$5C			; RET
; 1999: 
; 2000: ; -------------------------------------
; 2001: ; Display the current folder
; 2002: defn spm_repository()
C0354:					; spm_repository()
; 2003: 	byte i
					; i = 2
; 2004: 	byte l_field
					; l_field = 3
; 2005: 	byte k
					; k = 4
; 2006: 	byte l
					; l = 5
; 2007: 	byte l_size[11]
					; l_size = 6
; 2008: 	spm_pathname()
	LDA	#17
	STA	FRMSZ
	LDA	#0
	STA	NPARMS
	JSR	_ENTER
	JSR	C0352
	INX
	INX
; 2009: 	spvhd_explore(g_spvhdid,@g_pathname)
	LDA	D0052
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#<D1735
	LDY	#>D1735
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	TXA
	PHA
	SEC
	SBC	#4
	TAX
	JSR	C0278
	PLA
	TAX
; 2010: 	if g_sperr == 0
	LDA	D0055
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0356
:
; 2011: 		i = g_repo_pos
	LDA	D1869
	LDY	#$00
	LDY	#$02
	STA	(FP),Y
; 2012: 		while i>0
C0358:
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0359
:
; 2013: 			spvhd_nextfile(g_spvhdid,0,0)
	LDA	D0052
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$00
	TAY
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0282
	PLA
	TAX
; 2014: 			i = i - 1
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$01
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	EOR	#$FF
	ADC	ESTKH-2,X
	TAY
	LDA	ESTKL-2,X
	LDY	#$02
	STA	(FP),Y
; 2015: 		loop
	JMP	C0358
C0359:
; 2016: 		i = 0
	LDA	#$00
	TAY
	LDY	#$02
	STA	(FP),Y
; 2017: 		;flag set to 0 when no more file are to be displayed
; 2018: 		k = 1
	LDA	#$01
	LDY	#$00
	LDY	#$04
	STA	(FP),Y
; 2019: 		while i < 18
C0360:
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$12
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDY	#$00
	LDA	ESTKL-2,X
	CMP	ESTKL-4,X
	LDA	ESTKH-2,X
	SBC	ESTKH-4,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0361
:
; 2020: 		 	l_field = i + c_fld_file
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$03
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	LDA	ESTKL-2,X
	LDY	#$03
	STA	(FP),Y
; 2021: 		 	if k > 0
	LDY	#$04
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0362
:
; 2022: 		 		l = ^(fields_sel_l[l_field])
	LDA	#<D1582
	LDY	#>D1582
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-4,X
	ASL
	ROL	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:	TAY
	LDA	(ESTK-2,X)
	STA	ESTKH-2,X
	TYA
	STA	ESTKL-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	LDY	#$05
	STA	(FP),Y
; 2023: 				spvhd_nextfile(g_spvhdid,fields_sel_l[l_field],@l_size)
	LDA	D0052
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#<D1582
	LDY	#>D1582
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-6,X
	ASL
	ROL	ESTKH-6,X
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	LDA	ESTKH-6,X
	ADC	ESTKH-4,X
	STA	ESTKH-4,X
	LDA	(ESTK-4,X)
	INC	ESTKL-4,X
	BNE	:+
	INC	ESTKH-4,X
:	TAY
	LDA	(ESTK-4,X)
	STA	ESTKH-4,X
	TYA
	STA	ESTKL-4,X
	LDA	#$06
	CLC
	ADC	FPL
	STA	ESTKL-6,X
	LDA	#$00
	ADC	FPH
	STA	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0282
	PLA
	TAX
; 2024: 				if g_sperr == 0
	LDA	D0055
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0364
:
; 2025: 					k = ^(fields_sel_l[l_field])
	LDA	#<D1582
	LDY	#>D1582
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-4,X
	ASL
	ROL	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:	TAY
	LDA	(ESTK-2,X)
	STA	ESTKH-2,X
	TYA
	STA	ESTKL-2,X
	LDA	(ESTK-2,X)
	LDY	#$00
	LDY	#$04
	STA	(FP),Y
; 2026: 					if k > 0
	LDY	#$04
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	TYA
	LDY	#$00
	SBC	ESTKH-2,X
	BPL	:+
	DEY
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0366
:
; 2027: 						dsp_print(0,i+4,@l_size)
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$04
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDA	#$06
	CLC
	ADC	FPL
	STA	ESTKL-6,X
	LDA	#$00
	ADC	FPH
	STA	ESTKH-6,X
	TXA
	PHA
	SEC
	SBC	#6
	TAX
	JSR	C0098
	PLA
	TAX
; 2028: 						dsp_fill(11,i+4,40-l-11,' ')
	LDA	#$0B
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$04
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDA	#$28
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDY	#$05
	LDA	(FP),Y
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	EOR	#$FF
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	#$0B
	LDY	#$00
	EOR	#$FF
	SEC
	ADC	ESTKL-6,X
	STA	ESTKL-6,X
	TYA
	EOR	#$FF
	ADC	ESTKH-6,X
	TAY
	STY	ESTKH-6,X
	LDA	#$20
	LDY	#$00
	STA	ESTKL-8,X
	STY	ESTKH-8,X
	TXA
	PHA
	SEC
	SBC	#8
	TAX
	JSR	C0110
	PLA
	TAX
; 2029: 						fields_sel_x[l_field] = 11
	LDA	#<D1252
	LDY	#>D1252
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	#$0B
	LDY	#$00
	STA	(ESTK-2,X)
; 2030: 						fields_sel_y[l_field] = i+4
	LDA	#<D1273
	LDY	#>D1273
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$04
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	LDA	ESTKL-4,X
	STA	(ESTK-2,X)
; 2031: 						fld_display(l_field)
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	TXA
	PHA
	SEC
	SBC	#2
	TAX
	JSR	C0137
	PLA
	TAX
; 2032: 					else
	JMP	C0367
C0366:
; 2033: 						; restore field length before disabling it
; 2034: 						^(fields_sel_l[l_field]) = l
	LDA	#<D1582
	LDY	#>D1582
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STY	ESTKH-4,X
	ASL
	ROL	ESTKH-4,X
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	LDA	ESTKH-4,X
	ADC	ESTKH-2,X
	STA	ESTKH-2,X
	LDA	(ESTK-2,X)
	INC	ESTKL-2,X
	BNE	:+
	INC	ESTKH-2,X
:	TAY
	LDA	(ESTK-2,X)
	STA	ESTKH-2,X
	TYA
	STA	ESTKL-2,X
	LDY	#$05
	LDA	(FP),Y
	LDY	#$00
	STA	(ESTK-2,X)
; 2035: 					fin
C0367:
; 2036: 				else
	JMP	C0365
C0364:
; 2037: 					k = 0
	LDA	#$00
	TAY
	LDY	#$04
	STA	(FP),Y
; 2038: 				fin
C0365:
; 2039: 			fin
C0362:
C0363:
; 2040: 			if k == 0
	LDY	#$04
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$00
	TAY
	CMP	ESTKL-2,X
	BNE	:+
	TYA
	LDY	#$FF
	CMP	ESTKH-2,X
	BEQ	:++
:	LDY	#$00
:	TYA
	CMP	#$00
	BNE	:+
	CPY	#$00
	BNE	:+
	JMP	C0368
:
; 2041: 				dsp_fill(0,i+4,10,' ')
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	LDA	#$04
	LDY	#$00
	CLC
	ADC	ESTKL-4,X
	STA	ESTKL-4,X
	TYA
	ADC	ESTKH-4,X
	TAY
	STY	ESTKH-4,X
	LDA	#$0A
	LDY	#$00
	STA	ESTKL-6,X
	STY	ESTKH-6,X
	LDA	#$20
	LDY	#$00
	STA	ESTKL-8,X
	STY	ESTKH-8,X
	TXA
	PHA
	SEC
	SBC	#8
	TAX
	JSR	C0110
	PLA
	TAX
; 2042: 				fld_disable(l_field,' ')
	LDY	#$03
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$20
	LDY	#$00
	STA	ESTKL-4,X
	STY	ESTKH-4,X
	TXA
	PHA
	SEC
	SBC	#4
	TAX
	JSR	C0149
	PLA
	TAX
; 2043: 			fin
C0368:
C0369:
; 2044: 			i = i + 1			
	LDY	#$02
	LDA	(FP),Y
	LDY	#$00
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	LDA	#$01
	LDY	#$00
	CLC
	ADC	ESTKL-2,X
	STA	ESTKL-2,X
	TYA
	ADC	ESTKH-2,X
	TAY
	LDA	ESTKL-2,X
	LDY	#$02
	STA	(FP),Y
; 2045: 		loop
	JMP	C0360
C0361:
; 2046: 	fin
C0356:
C0357:
; 2047: end
	LDA	#$00
	TAY
	STA	ESTKL-2,X
	STY	ESTKH-2,X
	DEX
	DEX
	JMP	_LEAVE
; 2048: 
; 2049: ; -------------------------------------
; 2050: ; Display disk image selector
; 2051: def spm_selector()
C0370:					; spm_selector()
; 2052: 	byte i
					; i = 2
; 2053: 	word lp_ptr
					; lp_ptr = 3
; 2054: 	
; 2055: 	g_repo_pos = 0
	JSR	INTERP
	DB	$58,$05,$00		; ENTER	5,0
	DB	$00			; ZERO
	DB	$78,<D1869,>D1869	; SAB	D1869
; 2056: 	lp_ptr = dat_dcb_pointer(g_dev_selected)
	DB	$68,<D0056,>D0056	; LAB	D0056
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$76,$03			; SLW	3
; 2057: 	strcpy(lp_ptr+1,@g_pathname)
	DB	$66,$03			; LLW	3
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$54,<C0026,>C0026	; CALL	C0026
	DB	$30			; DROP
; 2058: 	dat_path_sub(@g_pathname)
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$54,<C0042,>C0042	; CALL	C0042
	DB	$30			; DROP
; 2059:    ;strcpy(@g_path,@g_pathname)
; 2060: 
; 2061: 	home()
	DB	$54,<C0008,>C0008	; CALL	C0008
	DB	$30			; DROP
; 2062:    fld_page(c_fld_page_selector,c_fld_parent)
	DB	$2A,$01			; CB	1
	DB	$00			; ZERO
	DB	$54,<C0157,>C0157	; CALL	C0157
	DB	$30			; DROP
; 2063:   
; 2064: 	dsp_print(0,23,@msg_help)
	DB	$00			; ZERO
	DB	$2A,$17			; CB	23
	DB	$26,<D0733,>D0733	; LAA	D0733
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2065: 	dsp_print(0,0,@msg_drive)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$26,<D0783,>D0783	; LAA	D0783
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2066: 	gotoxy(1 + msg_drive.0,0)
	DB	$2A,$01			; CB	1
	DB	$26,<(D0783+0),>(D0783+0)	; LAA	D0783+0
	DB	$60			; LB
	DB	$02			; ADD
	DB	$00			; ZERO
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
; 2067: 	printeger(g_dev_selected)
	DB	$68,<D0056,>D0056	; LAB	D0056
	DB	$54,<C0018,>C0018	; CALL	C0018
	DB	$30			; DROP
; 2068: 	dsp_fill(0,1,40,'=')
	DB	$00			; ZERO
	DB	$2A,$01			; CB	1
	DB	$2A,$28			; CB	40
	DB	$2A,$3D			; CB	61
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 2069: 	dsp_fill(0,3,40,'-')
	DB	$00			; ZERO
	DB	$2A,$03			; CB	3
	DB	$2A,$28			; CB	40
	DB	$2A,$2D			; CB	45
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 2070: 	dsp_fill(0,22,40,'=')
	DB	$00			; ZERO
	DB	$2A,$16			; CB	22
	DB	$2A,$28			; CB	40
	DB	$2A,$3D			; CB	61
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 2071: 	spm_pathname()
	DB	$54,<C0352,>C0352	; CALL	C0352
	DB	$30			; DROP
; 2072: 	fld_display(c_fld_parent)	
	DB	$00			; ZERO
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2073: 	;fld_display(c_fld_done)	
; 2074: 	fld_display(c_fld_clear)	
	DB	$2A,$01			; CB	1
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2075: 	fld_display(c_fld_abort)
	DB	$2A,$02			; CB	2
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2076: 	g_pathname.0 = 0
	DB	$26,<(D1735+0),>(D1735+0)	; LAA	D1735+0
	DB	$00			; ZERO
	DB	$70			; SB
; 2077: 	spm_repository()
	DB	$54,<C0354,>C0354	; CALL	C0354
	DB	$30			; DROP
; 2078: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 2079: 
; 2080: ; -------------------------------------
; 2081: ; Display real time clock page
; 2082: def spm_rtc()
C0372:					; spm_rtc()
; 2083: 	byte lp_date[4]
					; lp_date = 2
; 2084: 	byte i
					; i = 6
; 2085: 	byte j
					; j = 7
; 2086: 	
; 2087: 	;home()
; 2088: 	fld_page(c_fld_page_rtc,fld_last(c_fld_page_rtc,c_fld_abort_rtc))
	JSR	INTERP
	DB	$58,$08,$00		; ENTER	8,0
	DB	$2A,$02			; CB	2
	DB	$2A,$02			; CB	2
	DB	$00			; ZERO
	DB	$54,<C0159,>C0159	; CALL	C0159
	DB	$54,<C0157,>C0157	; CALL	C0157
	DB	$30			; DROP
; 2089: 	dsp_print(0,0,@msg_title_rtc)
	DB	$00			; ZERO
	DB	$00			; ZERO
	DB	$26,<D0873,>D0873	; LAA	D0873
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2090: 	dsp_fill(0,1,40,'=')
	DB	$00			; ZERO
	DB	$2A,$01			; CB	1
	DB	$2A,$28			; CB	40
	DB	$2A,$3D			; CB	61
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 2091: 	dsp_fill(0,21,40,'=')
	DB	$00			; ZERO
	DB	$2A,$15			; CB	21
	DB	$2A,$28			; CB	40
	DB	$2A,$3D			; CB	61
	DB	$54,<C0110,>C0110	; CALL	C0110
	DB	$30			; DROP
; 2092: 	dsp_print(0,22,@msg_help)
	DB	$00			; ZERO
	DB	$2A,$16			; CB	22
	DB	$26,<D0733,>D0733	; LAA	D0733
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2093: 	dsp_print(0,23,@msg_helprtc)
	DB	$00			; ZERO
	DB	$2A,$17			; CB	23
	DB	$26,<D0802,>D0802	; LAA	D0802
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2094: 	
; 2095: 	fld_display(c_fld_abort_rtc)
	DB	$00			; ZERO
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2096: 	fld_display(c_fld_save_rtc)
	DB	$2A,$06			; CB	6
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2097: 	fld_display(c_fld_prodos)
	DB	$2A,$07			; CB	7
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2098: 	if ^($BF06)==$60
	DB	$2C,$06,$BF		; CW	48902
	DB	$60			; LB
	DB	$2A,$60			; CB	96
	DB	$40			; ISEQ
	DB	$4C,<C0374,>C0374	; BRFLS	C0374
; 2099: 		fld_display(c_fld_install)
	DB	$2A,$08			; CB	8
	DB	$54,<C0137,>C0137	; CALL	C0137
	DB	$30			; DROP
; 2100: 	else
	DB	$50,<C0375,>C0375	; JUMP	C0375
C0374:
; 2101: 		fld_disable(c_fld_install,' ')
	DB	$2A,$08			; CB	8
	DB	$2A,$20			; CB	32
	DB	$54,<C0149,>C0149	; CALL	C0149
	DB	$30			; DROP
; 2102: 		gotoxy(3,8)
	DB	$2A,$03			; CB	3
	DB	$2A,$08			; CB	8
	DB	$54,<C0010,>C0010	; CALL	C0010
	DB	$30			; DROP
; 2103: 		prstr(@msg_driver_present)
	DB	$26,<D0843,>D0843	; LAA	D0843
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2104: 	fin
C0375:
; 2105: 
; 2106: 	spvhd_get_date(g_spvhdid,@lp_date)
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$28,$02			; LLA	2
	DB	$54,<C0270,>C0270	; CALL	C0270
	DB	$30			; DROP
; 2107: 	if g_sperr == 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0376,>C0376	; BRFLS	C0376
; 2108: 		dat_date_unpack(@lp_date)
	DB	$28,$02			; LLA	2
	DB	$54,<C0092,>C0092	; CALL	C0092
	DB	$30			; DROP
; 2109: 	else
	DB	$50,<C0377,>C0377	; JUMP	C0377
C0376:
; 2110: 		dat_date_unpack(c_pdos_date)
	DB	$2C,$90,$BF		; CW	49040
	DB	$54,<C0092,>C0092	; CALL	C0092
	DB	$30			; DROP
; 2111: 		fld_disable(c_fld_save_rtc)
	DB	$2A,$06			; CB	6
	DB	$54,<C0149,>C0149	; CALL	C0149
	DB	$30			; DROP
; 2112: 		i = fields_rtc_x[c_fld_install]
	DB	$26,<D1645,>D1645	; LAA	D1645
	DB	$2A,$08			; CB	8
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$74,$06			; SLB	6
; 2113: 		j = fields_rtc_y[c_fld_install]
	DB	$26,<D1654,>D1654	; LAA	D1654
	DB	$2A,$08			; CB	8
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$74,$07			; SLB	7
; 2114: 		fld_disable(c_fld_install)
	DB	$2A,$08			; CB	8
	DB	$54,<C0149,>C0149	; CALL	C0149
	DB	$30			; DROP
; 2115: 		dsp_print(i,j,@msg_no_sprtc1)
	DB	$64,$06			; LLB	6
	DB	$64,$07			; LLB	7
	DB	$26,<D0889,>D0889	; LAA	D0889
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2116: 		dsp_print(i,j+1,@msg_no_sprtc2)
	DB	$64,$06			; LLB	6
	DB	$64,$07			; LLB	7
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$26,<D0924,>D0924	; LAA	D0924
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2117: 	fin
C0377:
; 2118: 	fld_date_time()		
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2119: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 2120: 
; 2121: ; -------------------------------------
; 2122: ; Manage user interface
; 2123: def spm_manage_ui()
C0378:					; spm_manage_ui()
; 2124: 	word lp_ptr
					; lp_ptr = 2
; 2125: 	byte state
					; state = 4
; 2126: 	byte nextstate
					; nextstate = 5
; 2127: 	byte lp_date[4]
					; lp_date = 6
; 2128: 
; 2129: 	fld_shorcuts()
	JSR	INTERP
	DB	$58,$0A,$00		; ENTER	10,0
	DB	$54,<C0185,>C0185	; CALL	C0185
	DB	$30			; DROP
; 2130: 	
; 2131: 	if fields_page_selected == c_fld_page_main
	DB	$68,<D1718,>D1718	; LAB	D1718
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0380,>C0380	; BRFLS	C0380
; 2132: 	
; 2133: 		if g_key == keyenter
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8D			; CB	141
	DB	$40			; ISEQ
	DB	$4C,<C0382,>C0382	; BRFLS	C0382
; 2134: 			if fields_selected >= c_fld_vdsta and fields_selected < c_fld_vdsta + c_max_device
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$04			; CB	4
	DB	$48			; ISGE
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$04			; CB	4
	DB	$2A,$0A			; CB	10
	DB	$02			; ADD
	DB	$46			; ISLT
	DB	$24			; LAND
	DB	$4C,<C0384,>C0384	; BRFLS	C0384
; 2135: 				; change the state of a virtual device
; 2136: 				lp_ptr = dat_dcb_pointer(fields_selected + 1 - c_fld_vdsta)
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$2A,$04			; CB	4
	DB	$04			; SUB
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$76,$02			; SLW	2
; 2137: 				state = (lp_ptr).c_spvhd_param
	DB	$66,$02			; LLW	2
	DB	$60			; LB
	DB	$74,$04			; SLB	4
; 2138: 				nextstate = (state + 1) & 3
	DB	$64,$04			; LLB	4
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$2A,$03			; CB	3
	DB	$14			; BAND
	DB	$74,$05			; SLB	5
; 2139: 				; update virtual device state without changing reserved bits
; 2140: 				state = state & $FC
	DB	$64,$04			; LLB	4
	DB	$2A,$FC			; CB	252
	DB	$14			; BAND
	DB	$74,$04			; SLB	4
; 2141: 				(lp_ptr).c_spvhd_param = state ? nextstate
	DB	$66,$02			; LLW	2
	DB	$64,$04			; LLB	4
	DB	$64,$05			; LLB	5
	DB	$16			; IOR
	DB	$70			; SB
; 2142: 				fld_display_state(fields_selected)
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$54,<C0163,>C0163	; CALL	C0163
	DB	$30			; DROP
; 2143: 			elsif fields_selected >= c_fld_vdpath and fields_selected < c_fld_vdpath + c_max_device
	DB	$50,<C0385,>C0385	; JUMP	C0385
C0384:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$0E			; CB	14
	DB	$48			; ISGE
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$0E			; CB	14
	DB	$2A,$0A			; CB	10
	DB	$02			; ADD
	DB	$46			; ISLT
	DB	$24			; LAND
	DB	$4C,<C0386,>C0386	; BRFLS	C0386
; 2144: 				g_dev_selected = fields_selected - c_fld_vdpath + 1
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$0E			; CB	14
	DB	$04			; SUB
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$78,<D0056,>D0056	; SAB	D0056
; 2145: 				dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2146: 				spm_selector()
	DB	$54,<C0370,>C0370	; CALL	C0370
	DB	$30			; DROP
; 2147: 			elsif fields_selected == c_fld_save
	DB	$50,<C0385,>C0385	; JUMP	C0385
C0386:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0387,>C0387	; BRFLS	C0387
; 2148: 				spvhd_cfg_save()
	DB	$54,<C0340,>C0340	; CALL	C0340
	DB	$30			; DROP
; 2149: 				sp_init()
	DB	$54,<C0256,>C0256	; CALL	C0256
	DB	$30			; DROP
; 2150: 				dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2151: 				spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2152: 			elsif fields_selected == c_fld_load
	DB	$50,<C0385,>C0385	; JUMP	C0385
C0387:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$02			; CB	2
	DB	$40			; ISEQ
	DB	$4C,<C0388,>C0388	; BRFLS	C0388
; 2153: 				spvhd_cfg_load(1)
	DB	$2A,$01			; CB	1
	DB	$54,<C0330,>C0330	; CALL	C0330
	DB	$30			; DROP
; 2154: 				dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2155: 				spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2156: 			elsif fields_selected == c_fld_quit
	DB	$50,<C0385,>C0385	; JUMP	C0385
C0388:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0389,>C0389	; BRFLS	C0389
; 2157: 				g_key = keyescape
	DB	$2A,$9B			; CB	155
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2158: 			elsif fields_selected == c_fld_date
	DB	$50,<C0385,>C0385	; JUMP	C0385
C0389:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$03			; CB	3
	DB	$40			; ISEQ
	DB	$4C,<C0390,>C0390	; BRFLS	C0390
; 2159: 				dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2160: 				spm_rtc()
	DB	$54,<C0372,>C0372	; CALL	C0372
	DB	$30			; DROP
; 2161: 			fin
C0390:
C0385:
; 2162: 		fin
C0382:
C0383:
; 2163: 		
; 2164: 	elsif fields_page_selected == c_fld_page_selector
	DB	$50,<C0381,>C0381	; JUMP	C0381
C0380:
	DB	$68,<D1718,>D1718	; LAB	D1718
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0391,>C0391	; BRFLS	C0391
; 2165: 	
; 2166: 		if g_key == keyenter
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8D			; CB	141
	DB	$40			; ISEQ
	DB	$4C,<C0392,>C0392	; BRFLS	C0392
; 2167: 			if fields_selected == c_fld_abort
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$02			; CB	2
	DB	$40			; ISEQ
	DB	$4C,<C0394,>C0394	; BRFLS	C0394
; 2168: 				dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2169: 				spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2170: ;			elsif fields_selected == c_fld_done				
; 2171: ;				lp_ptr = dat_dcb_pointer(g_dev_selected)
; 2172: ;				strcpy(lp_ptr+1,@g_pathname)
; 2173: ;				spm_main()
; 2174: 			elsif fields_selected == c_fld_clear
	DB	$50,<C0395,>C0395	; JUMP	C0395
C0394:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0396,>C0396	; BRFLS	C0396
; 2175: 				g_pathname.0 = 1
	DB	$26,<(D1735+0),>(D1735+0)	; LAA	D1735+0
	DB	$2A,$01			; CB	1
	DB	$70			; SB
; 2176: 				g_pathname.1 = $2F
	DB	$26,<(D1735+1),>(D1735+1)	; LAA	D1735+1
	DB	$2A,$2F			; CB	47
	DB	$70			; SB
; 2177: ;strcpy(@g_path,@g_pathname)
; 2178: 				spm_repository()
	DB	$54,<C0354,>C0354	; CALL	C0354
	DB	$30			; DROP
; 2179: 			elsif fields_selected == c_fld_parent
	DB	$50,<C0395,>C0395	; JUMP	C0395
C0396:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0397,>C0397	; BRFLS	C0397
; 2180: 				dat_path_sub(@g_pathname)
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$54,<C0042,>C0042	; CALL	C0042
	DB	$30			; DROP
; 2181: 				spm_repository()
	DB	$54,<C0354,>C0354	; CALL	C0354
	DB	$30			; DROP
; 2182: 			elsif fields_selected >= c_fld_file
	DB	$50,<C0395,>C0395	; JUMP	C0395
C0397:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$03			; CB	3
	DB	$48			; ISGE
	DB	$4C,<C0398,>C0398	; BRFLS	C0398
; 2183: 				dat_path_add(@g_pathname,fields_sel_l[fields_selected])
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$26,<D1582,>D1582	; LAA	D1582
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$54,<C0052,>C0052	; CALL	C0052
	DB	$30			; DROP
; 2184: 				if ^(fields_sel_l[fields_selected]+1) <> $2F
	DB	$26,<D1582,>D1582	; LAA	D1582
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$1E			; IDXW
	DB	$62			; LW
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$60			; LB
	DB	$2A,$2F			; CB	47
	DB	$42			; ISNE
	DB	$4C,<C0399,>C0399	; BRFLS	C0399
; 2185: 					;this is a file, update the configuration of the virtual device
; 2186: 					lp_ptr = dat_dcb_pointer(g_dev_selected)
	DB	$68,<D0056,>D0056	; LAB	D0056
	DB	$54,<C0040,>C0040	; CALL	C0040
	DB	$76,$02			; SLW	2
; 2187: 					;remove the leading path separator
; 2188: 					dat_right(@g_pathname)
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$54,<C0066,>C0066	; CALL	C0066
	DB	$30			; DROP
; 2189: 					strcpy(@g_pathname,lp_ptr+1)
	DB	$26,<D1735,>D1735	; LAA	D1735
	DB	$66,$02			; LLW	2
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$54,<C0026,>C0026	; CALL	C0026
	DB	$30			; DROP
; 2190: 					dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2191: 					spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2192: 				else
	DB	$50,<C0400,>C0400	; JUMP	C0400
C0399:
; 2193: 					;refresh directory listing
; 2194: 					fld_select(c_fld_parent)
	DB	$00			; ZERO
	DB	$54,<C0145,>C0145	; CALL	C0145
	DB	$30			; DROP
; 2195: 					spm_repository()
	DB	$54,<C0354,>C0354	; CALL	C0354
	DB	$30			; DROP
; 2196: 				fin					
C0400:
; 2197: 			fin
C0398:
C0395:
; 2198: 		elsif g_key == keyarrowdown and fields_selected == c_fld_file + 17
	DB	$50,<C0393,>C0393	; JUMP	C0393
C0392:
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8A			; CB	138
	DB	$40			; ISEQ
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$03			; CB	3
	DB	$2A,$11			; CB	17
	DB	$02			; ADD
	DB	$40			; ISEQ
	DB	$24			; LAND
	DB	$4C,<C0401,>C0401	; BRFLS	C0401
; 2199: 			g_repo_pos = g_repo_pos + 8
	DB	$68,<D1869,>D1869	; LAB	D1869
	DB	$2A,$08			; CB	8
	DB	$02			; ADD
	DB	$78,<D1869,>D1869	; SAB	D1869
; 2200: 			fld_select(fields_selected - 8)
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$08			; CB	8
	DB	$04			; SUB
	DB	$54,<C0145,>C0145	; CALL	C0145
	DB	$30			; DROP
; 2201: 			spm_repository()			
	DB	$54,<C0354,>C0354	; CALL	C0354
	DB	$30			; DROP
; 2202: 			g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2203: 		elsif g_key == keyarrowup and fields_selected == c_fld_file and g_repo_pos >= 8 
	DB	$50,<C0393,>C0393	; JUMP	C0393
C0401:
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8B			; CB	139
	DB	$40			; ISEQ
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$03			; CB	3
	DB	$40			; ISEQ
	DB	$68,<D1869,>D1869	; LAB	D1869
	DB	$2A,$08			; CB	8
	DB	$48			; ISGE
	DB	$24			; LAND
	DB	$24			; LAND
	DB	$4C,<C0402,>C0402	; BRFLS	C0402
; 2204: 			g_repo_pos = g_repo_pos - 8
	DB	$68,<D1869,>D1869	; LAB	D1869
	DB	$2A,$08			; CB	8
	DB	$04			; SUB
	DB	$78,<D1869,>D1869	; SAB	D1869
; 2205: 			fld_select(fields_selected + 8)
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$08			; CB	8
	DB	$02			; ADD
	DB	$54,<C0145,>C0145	; CALL	C0145
	DB	$30			; DROP
; 2206: 			spm_repository()
	DB	$54,<C0354,>C0354	; CALL	C0354
	DB	$30			; DROP
; 2207: 			g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2208: 		fin
C0402:
C0393:
; 2209: 
; 2210: 	elsif fields_page_selected == c_fld_page_rtc
	DB	$50,<C0381,>C0381	; JUMP	C0381
C0391:
	DB	$68,<D1718,>D1718	; LAB	D1718
	DB	$2A,$02			; CB	2
	DB	$40			; ISEQ
	DB	$4C,<C0403,>C0403	; BRFLS	C0403
; 2211: 
; 2212: 		if g_key == keyenter
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8D			; CB	141
	DB	$40			; ISEQ
	DB	$4C,<C0404,>C0404	; BRFLS	C0404
; 2213: 			if fields_selected == c_fld_abort_rtc
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0406,>C0406	; BRFLS	C0406
; 2214: 				dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2215: 				spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2216: 			elsif fields_selected == c_fld_save_rtc				
	DB	$50,<C0407,>C0407	; JUMP	C0407
C0406:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$06			; CB	6
	DB	$40			; ISEQ
	DB	$4C,<C0408,>C0408	; BRFLS	C0408
; 2217: 				dat_date_pack(@lp_date)
	DB	$28,$06			; LLA	6
	DB	$54,<C0090,>C0090	; CALL	C0090
	DB	$30			; DROP
; 2218: 				spvhd_set_date(g_spvhdid,@lp_date)
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$28,$06			; LLA	6
	DB	$54,<C0274,>C0274	; CALL	C0274
	DB	$30			; DROP
; 2219: 				if g_sperr == 0
	DB	$68,<D0055,>D0055	; LAB	D0055
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0409,>C0409	; BRFLS	C0409
; 2220: 					dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2221: 					spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2222: 				fin
C0409:
C0410:
; 2223: 			elsif fields_selected == c_fld_prodos
	DB	$50,<C0407,>C0407	; JUMP	C0407
C0408:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$07			; CB	7
	DB	$40			; ISEQ
	DB	$4C,<C0411,>C0411	; BRFLS	C0411
; 2224: 				dat_date_pack(c_pdos_date)
	DB	$2C,$90,$BF		; CW	49040
	DB	$54,<C0090,>C0090	; CALL	C0090
	DB	$30			; DROP
; 2225: 				dsp_print(18+fields_rtc_x[fields_selected],fields_rtc_y[fields_selected],@msg_ok)
	DB	$2A,$12			; CB	18
	DB	$26,<D1645,>D1645	; LAA	D1645
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$02			; ADD
	DB	$26,<D1654,>D1654	; LAA	D1654
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$26,<D0840,>D0840	; LAA	D0840
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2226: 			elsif fields_selected == c_fld_install
	DB	$50,<C0407,>C0407	; JUMP	C0407
C0411:
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2A,$08			; CB	8
	DB	$40			; ISEQ
	DB	$4C,<C0412,>C0412	; BRFLS	C0412
; 2227: 				if clock_driver_install() == 0
	DB	$54,<C0246,>C0246	; CALL	C0246
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0413,>C0413	; BRFLS	C0413
; 2228: 					dsp_print(18+fields_rtc_x[fields_selected],fields_rtc_y[fields_selected],@msg_installed)
	DB	$2A,$12			; CB	18
	DB	$26,<D1645,>D1645	; LAA	D1645
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$02			; ADD
	DB	$26,<D1654,>D1654	; LAA	D1654
	DB	$68,<D1717,>D1717	; LAB	D1717
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$26,<D0863,>D0863	; LAA	D0863
	DB	$54,<C0098,>C0098	; CALL	C0098
	DB	$30			; DROP
; 2229: 				fin	
C0413:
C0414:
; 2230: 			fin
C0412:
C0407:
; 2231: 		elsif g_key == keyarrowup
	DB	$50,<C0405,>C0405	; JUMP	C0405
C0404:
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8B			; CB	139
	DB	$40			; ISEQ
	DB	$4C,<C0415,>C0415	; BRFLS	C0415
; 2232: 			case fields_selected
	DB	$68,<D1717,>D1717	; LAB	D1717
; 2233: 				of c_fld_day
	DB	$2A,$01			; CB	1
	DB	$3E,<C0417,>C0417	; BRNE	C0417
; 2234: 					g_day = g_day +1
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$78,<D1865,>D1865	; SAB	D1865
; 2235: 					if g_day > dayspermonth[g_month]
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$44			; ISGT
	DB	$4C,<C0418,>C0418	; BRFLS	C0418
; 2236: 						g_day = 1
	DB	$2A,$01			; CB	1
	DB	$78,<D1865,>D1865	; SAB	D1865
; 2237: 					fin
C0418:
C0419:
; 2238: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2239: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2240: 				of c_fld_month
	DB	$50,<C0416,>C0416	; JUMP	C0416
C0417:
	DB	$2A,$02			; CB	2
	DB	$3E,<C0420,>C0420	; BRNE	C0420
; 2241: 					g_month = g_month +1
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$78,<D1866,>D1866	; SAB	D1866
; 2242: 					if g_month > 11
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$0B			; CB	11
	DB	$44			; ISGT
	DB	$4C,<C0421,>C0421	; BRFLS	C0421
; 2243: 						g_month = 0
	DB	$00			; ZERO
	DB	$78,<D1866,>D1866	; SAB	D1866
; 2244: 					fin
C0421:
C0422:
; 2245: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2246: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2247: 				of c_fld_year
	DB	$50,<C0416,>C0416	; JUMP	C0416
C0420:
	DB	$2A,$03			; CB	3
	DB	$3E,<C0423,>C0423	; BRNE	C0423
; 2248: 					g_year = g_year +1
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$7A,<D1867,>D1867	; SAW	D1867
; 2249: 					if g_year > 99
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$63			; CB	99
	DB	$44			; ISGT
	DB	$4C,<C0424,>C0424	; BRFLS	C0424
; 2250: 						g_year = 0
	DB	$00			; ZERO
	DB	$7A,<D1867,>D1867	; SAW	D1867
; 2251: 					fin
C0424:
C0425:
; 2252: 					dat_check_leapyear()
	DB	$54,<C0078,>C0078	; CALL	C0078
	DB	$30			; DROP
; 2253: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2254: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2255: 				of c_fld_hour
	DB	$50,<C0416,>C0416	; JUMP	C0416
C0423:
	DB	$2A,$04			; CB	4
	DB	$3E,<C0426,>C0426	; BRNE	C0426
; 2256: 					g_hour = g_hour +1
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$78,<D1863,>D1863	; SAB	D1863
; 2257: 					if g_hour > 23
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$2A,$17			; CB	23
	DB	$44			; ISGT
	DB	$4C,<C0427,>C0427	; BRFLS	C0427
; 2258: 						g_hour = 0
	DB	$00			; ZERO
	DB	$78,<D1863,>D1863	; SAB	D1863
; 2259: 					fin
C0427:
C0428:
; 2260: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2261: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2262: 				of c_fld_minute
	DB	$50,<C0416,>C0416	; JUMP	C0416
C0426:
	DB	$2A,$05			; CB	5
	DB	$3E,<C0429,>C0429	; BRNE	C0429
; 2263: 					g_minute = g_minute +1
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$2A,$01			; CB	1
	DB	$02			; ADD
	DB	$78,<D1864,>D1864	; SAB	D1864
; 2264: 					if g_minute > 59
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$2A,$3B			; CB	59
	DB	$44			; ISGT
	DB	$4C,<C0430,>C0430	; BRFLS	C0430
; 2265: 						g_minute = 0
	DB	$00			; ZERO
	DB	$78,<D1864,>D1864	; SAB	D1864
; 2266: 					fin
C0430:
C0431:
; 2267: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2268: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2269: 			shut
	DB	$50,<C0416,>C0416	; JUMP	C0416
C0429:
C0416:
	DB	$30			; DROP
; 2270: 		elsif g_key == keyarrowdown
	DB	$50,<C0405,>C0405	; JUMP	C0405
C0415:
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8A			; CB	138
	DB	$40			; ISEQ
	DB	$4C,<C0433,>C0433	; BRFLS	C0433
; 2271: 			case fields_selected
	DB	$68,<D1717,>D1717	; LAB	D1717
; 2272: 				of c_fld_day
	DB	$2A,$01			; CB	1
	DB	$3E,<C0435,>C0435	; BRNE	C0435
; 2273: 					if g_day == 1
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$2A,$01			; CB	1
	DB	$40			; ISEQ
	DB	$4C,<C0436,>C0436	; BRFLS	C0436
; 2274: 						g_day = dayspermonth[g_month]
	DB	$26,<D1120,>D1120	; LAA	D1120
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2E			; IDXB
	DB	$60			; LB
	DB	$78,<D1865,>D1865	; SAB	D1865
; 2275: 					else
	DB	$50,<C0437,>C0437	; JUMP	C0437
C0436:
; 2276: 						g_day = g_day -1
	DB	$68,<D1865,>D1865	; LAB	D1865
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$78,<D1865,>D1865	; SAB	D1865
; 2277: 					fin
C0437:
; 2278: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2279: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2280: 				of c_fld_month
	DB	$50,<C0434,>C0434	; JUMP	C0434
C0435:
	DB	$2A,$02			; CB	2
	DB	$3E,<C0438,>C0438	; BRNE	C0438
; 2281: 					if g_month == 0
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0439,>C0439	; BRFLS	C0439
; 2282: 						g_month = 11
	DB	$2A,$0B			; CB	11
	DB	$78,<D1866,>D1866	; SAB	D1866
; 2283: 					else
	DB	$50,<C0440,>C0440	; JUMP	C0440
C0439:
; 2284: 						g_month = g_month -1
	DB	$68,<D1866,>D1866	; LAB	D1866
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$78,<D1866,>D1866	; SAB	D1866
; 2285: 					fin
C0440:
; 2286: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2287: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2288: 				of c_fld_year
	DB	$50,<C0434,>C0434	; JUMP	C0434
C0438:
	DB	$2A,$03			; CB	3
	DB	$3E,<C0441,>C0441	; BRNE	C0441
; 2289: 					if g_year == 0
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0442,>C0442	; BRFLS	C0442
; 2290: 						g_year = 99
	DB	$2A,$63			; CB	99
	DB	$7A,<D1867,>D1867	; SAW	D1867
; 2291: 					else
	DB	$50,<C0443,>C0443	; JUMP	C0443
C0442:
; 2292: 						g_year = g_year -1
	DB	$6A,<D1867,>D1867	; LAW	D1867
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$7A,<D1867,>D1867	; SAW	D1867
; 2293: 					fin
C0443:
; 2294: 					dat_check_leapyear()
	DB	$54,<C0078,>C0078	; CALL	C0078
	DB	$30			; DROP
; 2295: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2296: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2297: 				of c_fld_hour
	DB	$50,<C0434,>C0434	; JUMP	C0434
C0441:
	DB	$2A,$04			; CB	4
	DB	$3E,<C0444,>C0444	; BRNE	C0444
; 2298: 					if g_hour == 0
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0445,>C0445	; BRFLS	C0445
; 2299: 						g_hour = 23
	DB	$2A,$17			; CB	23
	DB	$78,<D1863,>D1863	; SAB	D1863
; 2300: 					else
	DB	$50,<C0446,>C0446	; JUMP	C0446
C0445:
; 2301: 						g_hour = g_hour -1
	DB	$68,<D1863,>D1863	; LAB	D1863
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$78,<D1863,>D1863	; SAB	D1863
; 2302: 					fin
C0446:
; 2303: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2304: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2305: 				of c_fld_minute
	DB	$50,<C0434,>C0434	; JUMP	C0434
C0444:
	DB	$2A,$05			; CB	5
	DB	$3E,<C0447,>C0447	; BRNE	C0447
; 2306: 					if g_minute == 0
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$4C,<C0448,>C0448	; BRFLS	C0448
; 2307: 						g_minute = 59
	DB	$2A,$3B			; CB	59
	DB	$78,<D1864,>D1864	; SAB	D1864
; 2308: 					else
	DB	$50,<C0449,>C0449	; JUMP	C0449
C0448:
; 2309: 						g_minute = g_minute -1
	DB	$68,<D1864,>D1864	; LAB	D1864
	DB	$2A,$01			; CB	1
	DB	$04			; SUB
	DB	$78,<D1864,>D1864	; SAB	D1864
; 2310: 					fin
C0449:
; 2311: 					fld_date_time()
	DB	$54,<C0232,>C0232	; CALL	C0232
	DB	$30			; DROP
; 2312: 					g_key = 0			
	DB	$00			; ZERO
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2313: 			shut
	DB	$50,<C0434,>C0434	; JUMP	C0434
C0447:
C0434:
	DB	$30			; DROP
; 2314: 		fin
C0433:
C0405:
; 2315: 					
; 2316: 	fin
C0403:
C0381:
; 2317: 	
; 2318: 	if g_key == keyarrowup or g_key == keyarrowdown or g_key == keyarrowleft or g_key == keyarrowright
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8B			; CB	139
	DB	$40			; ISEQ
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$8A			; CB	138
	DB	$40			; ISEQ
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$88			; CB	136
	DB	$40			; ISEQ
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$95			; CB	149
	DB	$40			; ISEQ
	DB	$22			; LOR
	DB	$22			; LOR
	DB	$22			; LOR
	DB	$4C,<C0451,>C0451	; BRFLS	C0451
; 2319: 		fld_navigation()
	DB	$54,<C0193,>C0193	; CALL	C0193
	DB	$30			; DROP
; 2320: 	fin
C0451:
C0452:
; 2321: end
	DB	$00			; ZERO
	DB	$5A			; LEAVE
; 2322: 
; 2323: ; =====================================
; 2324: ; Let's go !
; 2325: 
; 2326: g_dsp_flag = 255
START:	JSR	INTERP
	DB	$2A,$FF			; CB	255
	DB	$78,<D3790,>D3790	; SAB	D3790
; 2327: home()
	DB	$54,<C0008,>C0008	; CALL	C0008
	DB	$30			; DROP
; 2328: ;...humpffff...
; 2329: prstr(@msg_title)
	DB	$26,<D0125,>D0125	; LAA	D0125
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2330: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2331: prstr(@msg_copyright)
	DB	$26,<D0159,>D0159	; LAA	D0159
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2332: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2333: prstr(@msg_url)
	DB	$26,<D0194,>D0194	; LAA	D0194
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2334: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2335: prstr(@msg_asciiart0)
	DB	$26,<D0225,>D0225	; LAA	D0225
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2336: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2337: prstr(@msg_asciiart1)
	DB	$26,<D0257,>D0257	; LAA	D0257
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2338: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2339: prstr(@msg_asciiart2)
	DB	$26,<D0290,>D0290	; LAA	D0290
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2340: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2341: prstr(@msg_asciiart3)
	DB	$26,<D0323,>D0323	; LAA	D0323
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2342: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2343: prstr(@msg_asciiart4)
	DB	$26,<D0355,>D0355	; LAA	D0355
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2344: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2345: prstr(@msg_asciiart5)
	DB	$26,<D0386,>D0386	; LAA	D0386
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2346: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2347: prstr(@msg_asciiart6)
	DB	$26,<D0416,>D0416	; LAA	D0416
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2348: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2349: prstr(@msg_asciiart7)
	DB	$26,<D0445,>D0445	; LAA	D0445
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2350: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2351: prstr(@msg_asciiart8)
	DB	$26,<D0473,>D0473	; LAA	D0473
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2352: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2353: prstr(@msg_asciiart9)
	DB	$26,<D0500,>D0500	; LAA	D0500
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2354: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2355: prstr(@msg_asciiartA)
	DB	$26,<D0526,>D0526	; LAA	D0526
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2356: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2357: prstr(@msg_asciiartB)
	DB	$26,<D0551,>D0551	; LAA	D0551
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2358: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2359: prstr(@msg_asciiartC)
	DB	$26,<D0575,>D0575	; LAA	D0575
	DB	$54,<C0006,>C0006	; CALL	C0006
	DB	$30			; DROP
; 2360: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2361: crout()
	DB	$54,<C0012,>C0012	; CALL	C0012
	DB	$30			; DROP
; 2362: spvhd_locate()
	DB	$54,<C0322,>C0322	; CALL	C0322
	DB	$30			; DROP
; 2363: if g_spvhdid == 255 or g_spep == 0
	DB	$68,<D0052,>D0052	; LAB	D0052
	DB	$2A,$FF			; CB	255
	DB	$40			; ISEQ
	DB	$6A,<D0050,>D0050	; LAW	D0050
	DB	$00			; ZERO
	DB	$40			; ISEQ
	DB	$22			; LOR
	DB	$4C,<C0453,>C0453	; BRFLS	C0453
; 2364: 	g_key = getkey()
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2365: else
	DB	$50,<C0454,>C0454	; JUMP	C0454
C0453:
; 2366: 	spvhd_cfg_load(0)
	DB	$00			; ZERO
	DB	$54,<C0330,>C0330	; CALL	C0330
	DB	$30			; DROP
; 2367: 	while ^(pushbttn1)>127
C0455:
	DB	$2C,$61,$C0		; CW	49249
	DB	$60			; LB
	DB	$2A,$7F			; CB	127
	DB	$44			; ISGT
	DB	$4C,<C0456,>C0456	; BRFLS	C0456
; 2368: 	loop
	DB	$50,<C0455,>C0455	; JUMP	C0455
C0456:
; 2369: 	fld_init()
	DB	$54,<C0238,>C0238	; CALL	C0238
	DB	$30			; DROP
; 2370: 	dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2371: 	spm_main()
	DB	$54,<C0348,>C0348	; CALL	C0348
	DB	$30			; DROP
; 2372: 	repeat
C0458:
; 2373: 		g_key = getkey()
	DB	$54,<C0036,>C0036	; CALL	C0036
	DB	$78,<D0049,>D0049	; SAB	D0049
; 2374: 		spm_manage_ui()
	DB	$54,<C0378,>C0378	; CALL	C0378
	DB	$30			; DROP
; 2375: 	until g_key == keyescape
	DB	$68,<D0049,>D0049	; LAB	D0049
	DB	$2A,$9B			; CB	155
	DB	$40			; ISEQ
	DB	$4C,<C0458,>C0458	; BRFLS	C0458
C0457:
; 2376: fin
C0454:
; 2377: dsp_page_away(@txtscrn)
	DB	$26,<D0000,>D0000	; LAA	D0000
	DB	$54,<C0133,>C0133	; CALL	C0133
	DB	$30			; DROP
; 2378: done
	DB	$00			; ZERO
	DB	$5E			; EXIT
